
#beginMacro loops(OP)
if( defectOption.eq.0 )then
  do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
  do i1=n1a,n1b,n1c
    if( mask(i1,i2,i3).gt.0 )then
      defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
    else
      defect(i1,i2,i3)=0.
    end if
  end do
  end do
  end do
else if( defectOption.eq.1 )then
  ! In this case compute the l2-norm of the defect too
  count=0
  defectSquared=0.
  do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
  do i1=n1a,n1b,n1c
    if( mask(i1,i2,i3).gt.0 )then
      defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
      defectSquared=defectSquared+defect(i1,i2,i3)**2
      count=count+1
    else
      defect(i1,i2,i3)=0.
    end if
  end do
  end do
  end do
else if( defectOption.eq.2 )then
  ! In this case compute the max-norm of the defect too
  defectMax=0.
  do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
  do i1=n1a,n1b,n1c
    if( mask(i1,i2,i3).gt.0 )then
      defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
      defectMax=max(defectMax,abs(defect(i1,i2,i3)))
    else
      defect(i1,i2,i3)=0.
    end if
  end do
  end do
  end do
else if( defectOption.eq.3 )then
  ! In this case compute both the l2-norm and max-norm of the defect too
  count=0
  defectSquared=0.
  defectMax=0.
  do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
  do i1=n1a,n1b,n1c
    if( mask(i1,i2,i3).gt.0 )then
      defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
      defectMax=max(defectMax,abs(defect(i1,i2,i3)))
      defectSquared=defectSquared+defect(i1,i2,i3)**2
      count=count+1
    else
      defect(i1,i2,i3)=0.
    end if
  end do
  end do
  end do
else
  write(*,'("ERROR:defectOpt: unknown defectOption")')
  stop 89
end if
#endMacro

#beginMacro DEFECT(OP,ND)
if( lineSmoothOption .eq. -1 )then
c  general defect
  loops(OP)
else if( lineSmoothOption .eq. 0 )then
c  defect for line smooth in direction 0
  loops(OP ## l0)
#If #ND ne "1"
else if( lineSmoothOption .eq. 1 )then
c  defect for line smooth in direction 1
  loops(OP ## l1)
#End
#If #ND eq "3"
else if( lineSmoothOption .eq. 2 )then
c  defect for line smooth in direction 2
  loops(OP ## l2)
#End
else
  write(*,*) 'defectOpt::ERROR invalid lineSmoothOption'
  write(*,*) 'defectOpt::nd=#ND'
  write(*,*) 'defectOpt::lineSmoothOption=',lineSmoothOption
  stop 
end if
#endMacro

c =============================================================
#beginMacro loops2dVC(OP)
do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
    do i1=n1a,n1b,n1c
      if( mask(i1,i2,i3).gt.0 )then
        a1p=(s(i1,i2,i3)+s(i1+1,i2,i3))*dx2i
        a1m=(s(i1,i2,i3)+s(i1-1,i2,i3))*dx2i
        a2p=(s(i1,i2,i3)+s(i1,i2+1,i3))*dy2i
        a2m=(s(i1,i2,i3)+s(i1,i2-1,i3))*dy2i
        ad=-(a1p+a1m+a2p+a2m)
        defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
        ! write(*,*) 'defect: ',i1,i2,s(i1,i2,i3),a1p,a1m,a2p,a2m
      else
        defect(i1,i2,i3)=0.
      end if
    end do
  end do
end do
#endMacro


#beginMacro DEFECT2dVC(OP,ND)
if( lineSmoothOption .eq. -1 )then
c  general defect
  loops2dVC(OP)
else if( lineSmoothOption .eq. 0 )then
c  defect for line smooth in direction 0
  loops2dVC(OP ## l0)
#If #ND ne "1"
else if( lineSmoothOption .eq. 1 )then
c  defect for line smooth in direction 1
  loops2dVC(OP ## l1)
#End
#If #ND eq "3"
else if( lineSmoothOption .eq. 2 )then
c  defect for line smooth in direction 2
  loops2dVC(OP ## l2)
#End
else
  write(*,*) 'defectOpt::ERROR invalid lineSmoothOption'
  stop 
end if
#endMacro

c =============================================================
#beginMacro loops3dVC(OP)
do i3=n3a,n3b,n3c
  do i2=n2a,n2b,n2c
    do i1=n1a,n1b,n1c
      if( mask(i1,i2,i3).gt.0 )then
        a1p=(s(i1,i2,i3)+s(i1+1,i2,i3))*dx2i
        a1m=(s(i1,i2,i3)+s(i1-1,i2,i3))*dx2i
        a2p=(s(i1,i2,i3)+s(i1,i2+1,i3))*dy2i
        a2m=(s(i1,i2,i3)+s(i1,i2-1,i3))*dy2i
        a3p=(s(i1,i2,i3)+s(i1,i2,i3+1))*dz2i
        a3m=(s(i1,i2,i3)+s(i1,i2,i3-1))*dz2i
        ad=-(a1p+a1m+a2p+a2m+a3p+a3m)
        defect(i1,i2,i3)=f(i1,i2,i3)-OP(i1,i2,i3)
      else
        defect(i1,i2,i3)=0.
      end if
    end do
  end do
end do
#endMacro


#beginMacro DEFECT3dVC(OP,ND)
if( lineSmoothOption .eq. -1 )then
c  general defect
  loops3dVC(OP)
else if( lineSmoothOption .eq. 0 )then
c  defect for line smooth in direction 0
  loops3dVC(OP ## l0)
#If #ND ne "1"
else if( lineSmoothOption .eq. 1 )then
c  defect for line smooth in direction 1
  loops3dVC(OP ## l1)
#End
#If #ND eq "3"
else if( lineSmoothOption .eq. 2 )then
c  defect for line smooth in direction 2
  loops3dVC(OP ## l2)
#End
else
  write(*,*) 'defectOpt::ERROR invalid lineSmoothOption'
  stop 
end if
#endMacro


#beginMacro DEFECT_SUBROUTINE(NAME,DIM,ORDER) 
 subroutine NAME( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, \
        n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,\
        mask, cc, s, ipar, rpar )
c ===================================================================================
c  Optimised defect
c
c defectOption: ipar(0)
c               =0 : compute defect only
c               =1 : compute defect and l2-norm: sqrt{ sum( defect**2 )/sum( 1 ) }, returned as rpar(3)
c               =2 : compute defect and max norm, returned as rpar(4)
c               =3 : compute defect and both l2-norm and max-norm, l2-norm=rpar(3), max-norm=rpar(4)  
c
c lineSmoothOption=ipar(1)
c lineSmoothOption: -1 : general
c                    0 : line smooth, direction 1
c                    1 : line smooth, direction 2
c                    2 : line smooth, direction 3
c                    3 : red-points
c                    4 : black-points
c
c
c  cc(m) : constant coefficients
c  sparseStencil : general=0, sparse=1, constantCoefficients=2, sparseConstantCoefficients=3
c ===================================================================================

 implicit none
 integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,\
        n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc,\
        ipar(0:*)
 integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)

 real defect(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
 real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
 real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
 real c(1:ndc,nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
 real cc(1:*),rpar(0:*)
 real s(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)

c......local variables
 integer lineSmoothOption,order,sparseStencil,defectOption
 real dx(3)
 integer i1,i2,i3,n,count
 real defectSquared,defectMax

 integer m11,m12,m13,m14,m15,\
        m21,m22,m23,m24,m25,\
        m31,m32,m33,m34,m35,\
        m41,m42,m43,m44,m45,\
        m51,m52,m53,m54,m55
 integer    m111,m211,m311,m411,m511,\
           m121,m221,m321,m421,m521,\
           m131,m231,m331,m431,m531,\
           m141,m241,m341,m441,m541,\
           m151,m251,m351,m451,m551,\
           m112,m212,m312,m412,m512,\
           m122,m222,m322,m422,m522,\
           m132,m232,m332,m432,m532,\
           m142,m242,m342,m442,m542,\
           m152,m252,m352,m452,m552,\
           m113,m213,m313,m413,m513,\
           m123,m223,m323,m423,m523,\
           m133,m233,m333,m433,m533,\
           m143,m243,m343,m443,m543,\
           m153,m253,m353,m453,m553,\
           m114,m214,m314,m414,m514,\
           m124,m224,m324,m424,m524,\
           m134,m234,m334,m434,m534,\
           m144,m244,m344,m444,m544,\
           m154,m254,m354,m454,m554,\
           m115,m215,m315,m415,m515,\
           m125,m225,m325,m425,m525,\
           m135,m235,m335,m435,m535,\
           m145,m245,m345,m445,m545,\
           m155,m255,m355,m455,m555

 integer    m11n,m21n,m31n,m41n,m51n,\
           m12n,m22n,m32n,m42n,m52n,\
           m13n,m23n,m33n,m43n,m53n,\
           m14n,m24n,m34n,m44n,m54n,\
           m15n,m25n,m35n,m45n,m55n

 real a1m,a1p,a2m,a2p,a3m,a3p,ad
 real dx2i,dy2i,dz2i

 integer general, sparse, constantCoefficients, \
   sparseConstantCoefficients,variableCoefficients,\
   sparseVariableCoefficients
 parameter( general=0, sparse=1, constantCoefficients=2,\
           sparseConstantCoefficients=3,\
           variableCoefficients=4,\
           sparseVariableCoefficients=5 )
c..........start statement functions
 real op2d,op2dSparse,op2dCC,op2dSparseCC
 real op2dl0,op2dSparsel0,op2dCCl0,op2dSparseCCl0
 real op2dl1,op2dSparsel1,op2dCCl1,op2dSparseCCl1
 real op3d,op3dSparse,op3dCC,op3dSparseCC
 real op3dl0,op3dSparsel0,op3dCCl0,op3dSparseCCl0
 real op3dl1,op3dSparsel1,op3dCCl1,op3dSparseCCl1
 real op3dl2,op3dSparsel2,op3dCCl2,op3dSparseCCl2
 
 real op2d4,op2dSparse4,op2dCC4,op2dSparseCC4
 real op2d4l0,op2dSparse4l0,op2dCC4l0,op2dSparseCC4l0
 real op2d4l1,op2dSparse4l1,op2dCC4l1,op2dSparseCC4l1
 real op3d4,op3dSparse4,op3dCC4,op3dSparseCC4
 real op3d4l0,op3dSparse4l0,op3dCC4l0,op3dSparseCC4l0
 real op3d4l1,op3dSparse4l1,op3dCC4l1,op3dSparseCC4l1
 real op3d4l2,op3dSparse4l2,op3dCC4l2,op3dSparseCC4l2

 real op3d4a,op3d4al0,op3d4al1,op3d4al2
 real op3dCC4a,op3dCC4al0,op3dCC4al1,op3dCC4al2

 real op2dSparseVC,op2dSparseVCl0,op2dSparseVCl1
 real op3dSparseVC,op3dSparseVCl0,op3dSparseVCl1,op3dSparseVCl2

#If #DIM == "2"
 op2d(i1,i2,i3)= \
     c(m11,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m21,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m31,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m12,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m22,i1,i2,i3)*u(i1  ,i2  ,i3)+ \
     c(m32,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m13,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m23,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m33,i1,i2,i3)*u(i1+1,i2+1,i3)
! line smooth direction 1 
 op2dl0(i1,i2,i3)=   \
     c(m11,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m21,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m31,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m13,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m23,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m33,i1,i2,i3)*u(i1+1,i2+1,i3)
 op2dl1(i1,i2,i3)= \
     c(m11,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m31,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m12,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m32,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m13,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m33,i1,i2,i3)*u(i1+1,i2+1,i3)
 op2dSparse(i1,i2,i3)= \
     c(m22,i1,i2,i3)*u(i1  ,i2  ,i3)+ \
     c(m32,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m23,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m12,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m21,i1,i2,i3)*u(i1  ,i2-1,i3)
 op2dSparsel0(i1,i2,i3)= \
     c(m23,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m21,i1,i2,i3)*u(i1  ,i2-1,i3)
 op2dSparsel1(i1,i2,i3)= \
     c(m32,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m12,i1,i2,i3)*u(i1-1,i2  ,i3) 
 op2dCC(i1,i2,i3)= \
     cc(m11)*u(i1-1,i2-1,i3)+ \
     cc(m21)*u(i1  ,i2-1,i3)+ \
     cc(m31)*u(i1+1,i2-1,i3)+ \
     cc(m12)*u(i1-1,i2  ,i3)+ \
     cc(m22)*u(i1  ,i2  ,i3)+ \
     cc(m32)*u(i1+1,i2  ,i3)+ \
     cc(m13)*u(i1-1,i2+1,i3)+ \
     cc(m23)*u(i1  ,i2+1,i3)+ \
     cc(m33)*u(i1+1,i2+1,i3)
 op2dCCl0(i1,i2,i3)= \
     cc(m11)*u(i1-1,i2-1,i3)+ \
     cc(m21)*u(i1  ,i2-1,i3)+ \
     cc(m31)*u(i1+1,i2-1,i3)+ \
     cc(m13)*u(i1-1,i2+1,i3)+ \
     cc(m23)*u(i1  ,i2+1,i3)+ \
     cc(m33)*u(i1+1,i2+1,i3)
 op2dCCl1(i1,i2,i3)= \
     cc(m11)*u(i1-1,i2-1,i3)+ \
     cc(m31)*u(i1+1,i2-1,i3)+ \
     cc(m12)*u(i1-1,i2  ,i3)+ \
     cc(m32)*u(i1+1,i2  ,i3)+ \
     cc(m13)*u(i1-1,i2+1,i3)+ \
     cc(m33)*u(i1+1,i2+1,i3)
 op2dSparseCC(i1,i2,i3)= \
     cc(m22)*u(i1  ,i2  ,i3)+ \
     cc(m32)*u(i1+1,i2  ,i3)+ \
     cc(m23)*u(i1  ,i2+1,i3)+ \
     cc(m12)*u(i1-1,i2  ,i3)+ \
     cc(m21)*u(i1  ,i2-1,i3)
 op2dSparseCCl0(i1,i2,i3)= \
     cc(m23)*u(i1  ,i2+1,i3)+ \
     cc(m21)*u(i1  ,i2-1,i3)
 op2dSparseCCl1(i1,i2,i3)= \
     cc(m32)*u(i1+1,i2  ,i3)+ \
     cc(m12)*u(i1-1,i2  ,i3) 

#End
#If #DIM == "3"

 op3d(i1,i2,i3)= \
                    c(m111,i1,i2,i3)*u(i1-1,i2-1,i3-1)+ \
                    c(m211,i1,i2,i3)*u(i1  ,i2-1,i3-1)+ \
                    c(m311,i1,i2,i3)*u(i1+1,i2-1,i3-1)+ \
                    c(m121,i1,i2,i3)*u(i1-1,i2  ,i3-1)+ \
                    c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                    c(m321,i1,i2,i3)*u(i1+1,i2  ,i3-1)+ \
                    c(m131,i1,i2,i3)*u(i1-1,i2+1,i3-1)+ \
                    c(m231,i1,i2,i3)*u(i1  ,i2+1,i3-1)+ \
                    c(m331,i1,i2,i3)*u(i1+1,i2+1,i3-1)+ \
                    c(m112,i1,i2,i3)*u(i1-1,i2-1,i3  )+ \
                    c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                    c(m312,i1,i2,i3)*u(i1+1,i2-1,i3  )+ \
                    c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                    c(m222,i1,i2,i3)*u(i1  ,i2  ,i3  )+ \
                    c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                    c(m132,i1,i2,i3)*u(i1-1,i2+1,i3  )+ \
                    c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
                    c(m332,i1,i2,i3)*u(i1+1,i2+1,i3  )+ \
                    c(m113,i1,i2,i3)*u(i1-1,i2-1,i3+1)+ \
                    c(m213,i1,i2,i3)*u(i1  ,i2-1,i3+1)+ \
                    c(m313,i1,i2,i3)*u(i1+1,i2-1,i3+1)+ \
                    c(m123,i1,i2,i3)*u(i1-1,i2  ,i3+1)+ \
                    c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
                    c(m323,i1,i2,i3)*u(i1+1,i2  ,i3+1)+ \
                    c(m133,i1,i2,i3)*u(i1-1,i2+1,i3+1)+ \
                    c(m233,i1,i2,i3)*u(i1  ,i2+1,i3+1)+ \
                    c(m333,i1,i2,i3)*u(i1+1,i2+1,i3+1)
 op3dl0(i1,i2,i3)= \
                    c(m111,i1,i2,i3)*u(i1-1,i2-1,i3-1)+ \
                    c(m211,i1,i2,i3)*u(i1  ,i2-1,i3-1)+ \
                    c(m311,i1,i2,i3)*u(i1+1,i2-1,i3-1)+ \
                    c(m121,i1,i2,i3)*u(i1-1,i2  ,i3-1)+ \
                    c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                    c(m321,i1,i2,i3)*u(i1+1,i2  ,i3-1)+ \
                    c(m131,i1,i2,i3)*u(i1-1,i2+1,i3-1)+ \
                    c(m231,i1,i2,i3)*u(i1  ,i2+1,i3-1)+ \
                    c(m331,i1,i2,i3)*u(i1+1,i2+1,i3-1)+ \
                    c(m112,i1,i2,i3)*u(i1-1,i2-1,i3  )+ \
                    c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                    c(m312,i1,i2,i3)*u(i1+1,i2-1,i3  )+ \
                    c(m132,i1,i2,i3)*u(i1-1,i2+1,i3  )+ \
                    c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
                    c(m332,i1,i2,i3)*u(i1+1,i2+1,i3  )+ \
                    c(m113,i1,i2,i3)*u(i1-1,i2-1,i3+1)+ \
                    c(m213,i1,i2,i3)*u(i1  ,i2-1,i3+1)+ \
                    c(m313,i1,i2,i3)*u(i1+1,i2-1,i3+1)+ \
                    c(m123,i1,i2,i3)*u(i1-1,i2  ,i3+1)+ \
                    c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
                    c(m323,i1,i2,i3)*u(i1+1,i2  ,i3+1)+ \
                    c(m133,i1,i2,i3)*u(i1-1,i2+1,i3+1)+ \
                    c(m233,i1,i2,i3)*u(i1  ,i2+1,i3+1)+ \
                    c(m333,i1,i2,i3)*u(i1+1,i2+1,i3+1)
 op3dl1(i1,i2,i3)= \
                    c(m111,i1,i2,i3)*u(i1-1,i2-1,i3-1)+ \
                    c(m211,i1,i2,i3)*u(i1  ,i2-1,i3-1)+ \
                    c(m311,i1,i2,i3)*u(i1+1,i2-1,i3-1)+ \
                    c(m121,i1,i2,i3)*u(i1-1,i2  ,i3-1)+ \
                    c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                    c(m321,i1,i2,i3)*u(i1+1,i2  ,i3-1)+ \
                    c(m131,i1,i2,i3)*u(i1-1,i2+1,i3-1)+ \
                    c(m231,i1,i2,i3)*u(i1  ,i2+1,i3-1)+ \
                    c(m331,i1,i2,i3)*u(i1+1,i2+1,i3-1)+ \
                    c(m112,i1,i2,i3)*u(i1-1,i2-1,i3  )+ \
                    c(m312,i1,i2,i3)*u(i1+1,i2-1,i3  )+ \
                    c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                    c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                    c(m132,i1,i2,i3)*u(i1-1,i2+1,i3  )+ \
                    c(m332,i1,i2,i3)*u(i1+1,i2+1,i3  )+ \
                    c(m113,i1,i2,i3)*u(i1-1,i2-1,i3+1)+ \
                    c(m213,i1,i2,i3)*u(i1  ,i2-1,i3+1)+ \
                    c(m313,i1,i2,i3)*u(i1+1,i2-1,i3+1)+ \
                    c(m123,i1,i2,i3)*u(i1-1,i2  ,i3+1)+ \
                    c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
                    c(m323,i1,i2,i3)*u(i1+1,i2  ,i3+1)+ \
                    c(m133,i1,i2,i3)*u(i1-1,i2+1,i3+1)+ \
                    c(m233,i1,i2,i3)*u(i1  ,i2+1,i3+1)+ \
                    c(m333,i1,i2,i3)*u(i1+1,i2+1,i3+1)
 op3dl2(i1,i2,i3)= \
                    c(m111,i1,i2,i3)*u(i1-1,i2-1,i3-1)+ \
                    c(m211,i1,i2,i3)*u(i1  ,i2-1,i3-1)+ \
                    c(m311,i1,i2,i3)*u(i1+1,i2-1,i3-1)+ \
                    c(m121,i1,i2,i3)*u(i1-1,i2  ,i3-1)+ \
                    c(m321,i1,i2,i3)*u(i1+1,i2  ,i3-1)+ \
                    c(m131,i1,i2,i3)*u(i1-1,i2+1,i3-1)+ \
                    c(m231,i1,i2,i3)*u(i1  ,i2+1,i3-1)+ \
                    c(m331,i1,i2,i3)*u(i1+1,i2+1,i3-1)+ \
                    c(m112,i1,i2,i3)*u(i1-1,i2-1,i3  )+ \
                    c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                    c(m312,i1,i2,i3)*u(i1+1,i2-1,i3  )+ \
                    c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                    c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                    c(m132,i1,i2,i3)*u(i1-1,i2+1,i3  )+ \
                    c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
                    c(m332,i1,i2,i3)*u(i1+1,i2+1,i3  )+ \
                    c(m113,i1,i2,i3)*u(i1-1,i2-1,i3+1)+ \
                    c(m213,i1,i2,i3)*u(i1  ,i2-1,i3+1)+ \
                    c(m313,i1,i2,i3)*u(i1+1,i2-1,i3+1)+ \
                    c(m123,i1,i2,i3)*u(i1-1,i2  ,i3+1)+ \
                    c(m323,i1,i2,i3)*u(i1+1,i2  ,i3+1)+ \
                    c(m133,i1,i2,i3)*u(i1-1,i2+1,i3+1)+ \
                    c(m233,i1,i2,i3)*u(i1  ,i2+1,i3+1)+ \
                    c(m333,i1,i2,i3)*u(i1+1,i2+1,i3+1)
 op3dSparse(i1,i2,i3)= \
                       c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                       c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                       c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                       c(m222,i1,i2,i3)*u(i1  ,i2  ,i3  )+ \
                       c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                       c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
                       c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)
 op3dSparsel0(i1,i2,i3)= \
                       c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                       c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                       c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
                       c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)
 op3dSparsel1(i1,i2,i3)= \
                       c(m221,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
                       c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                       c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                       c(m223,i1,i2,i3)*u(i1  ,i2  ,i3+1)
 op3dSparsel2(i1,i2,i3)= \
                       c(m212,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
                       c(m122,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
                       c(m322,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
                       c(m232,i1,i2,i3)*u(i1  ,i2+1,i3  ) 

 op3dSparseCC(i1,i2,i3) = \
     cc(m221)*u(i1  ,i2  ,i3-1)+ \
     cc(m212)*u(i1  ,i2-1,i3  )+ \
     cc(m122)*u(i1-1,i2  ,i3  )+ \
     cc(m222)*u(i1  ,i2  ,i3  )+ \
     cc(m322)*u(i1+1,i2  ,i3  )+ \
     cc(m232)*u(i1  ,i2+1,i3  )+ \
     cc(m223)*u(i1  ,i2  ,i3+1)
 op3dSparseCCl0(i1,i2,i3) = \
     cc(m221)*u(i1  ,i2  ,i3-1)+ \
     cc(m212)*u(i1  ,i2-1,i3  )+ \
     cc(m232)*u(i1  ,i2+1,i3  )+ \
     cc(m223)*u(i1  ,i2  ,i3+1)
 op3dSparseCCl1(i1,i2,i3) = \
     cc(m221)*u(i1  ,i2  ,i3-1)+ \
     cc(m122)*u(i1-1,i2  ,i3  )+ \
     cc(m322)*u(i1+1,i2  ,i3  )+ \
     cc(m223)*u(i1  ,i2  ,i3+1)
 op3dSparseCCl2(i1,i2,i3) = \
     cc(m212)*u(i1  ,i2-1,i3  )+ \
     cc(m122)*u(i1-1,i2  ,i3  )+ \
     cc(m322)*u(i1+1,i2  ,i3  )+ \
     cc(m232)*u(i1  ,i2+1,i3  ) 

 op3dCC(i1,i2,i3)= \
                    cc(m111)*u(i1-1,i2-1,i3-1)+ \
                    cc(m211)*u(i1  ,i2-1,i3-1)+ \
                    cc(m311)*u(i1+1,i2-1,i3-1)+ \
                    cc(m121)*u(i1-1,i2  ,i3-1)+ \
                    cc(m221)*u(i1  ,i2  ,i3-1)+ \
                    cc(m321)*u(i1+1,i2  ,i3-1)+ \
                    cc(m131)*u(i1-1,i2+1,i3-1)+ \
                    cc(m231)*u(i1  ,i2+1,i3-1)+ \
                    cc(m331)*u(i1+1,i2+1,i3-1)+ \
                    cc(m112)*u(i1-1,i2-1,i3  )+ \
                    cc(m212)*u(i1  ,i2-1,i3  )+ \
                    cc(m312)*u(i1+1,i2-1,i3  )+ \
                    cc(m122)*u(i1-1,i2  ,i3  )+ \
                    cc(m222)*u(i1  ,i2  ,i3  )+ \
                    cc(m322)*u(i1+1,i2  ,i3  )+ \
                    cc(m132)*u(i1-1,i2+1,i3  )+ \
                    cc(m232)*u(i1  ,i2+1,i3  )+ \
                    cc(m332)*u(i1+1,i2+1,i3  )+ \
                    cc(m113)*u(i1-1,i2-1,i3+1)+ \
                    cc(m213)*u(i1  ,i2-1,i3+1)+ \
                    cc(m313)*u(i1+1,i2-1,i3+1)+ \
                    cc(m123)*u(i1-1,i2  ,i3+1)+ \
                    cc(m223)*u(i1  ,i2  ,i3+1)+ \
                    cc(m323)*u(i1+1,i2  ,i3+1)+ \
                    cc(m133)*u(i1-1,i2+1,i3+1)+ \
                    cc(m233)*u(i1  ,i2+1,i3+1)+ \
                    cc(m333)*u(i1+1,i2+1,i3+1)
 op3dCCl0(i1,i2,i3)= \
                    cc(m111)*u(i1-1,i2-1,i3-1)+ \
                    cc(m211)*u(i1  ,i2-1,i3-1)+ \
                    cc(m311)*u(i1+1,i2-1,i3-1)+ \
                    cc(m121)*u(i1-1,i2  ,i3-1)+ \
                    cc(m221)*u(i1  ,i2  ,i3-1)+ \
                    cc(m321)*u(i1+1,i2  ,i3-1)+ \
                    cc(m131)*u(i1-1,i2+1,i3-1)+ \
                    cc(m231)*u(i1  ,i2+1,i3-1)+ \
                    cc(m331)*u(i1+1,i2+1,i3-1)+ \
                    cc(m112)*u(i1-1,i2-1,i3  )+ \
                    cc(m212)*u(i1  ,i2-1,i3  )+ \
                    cc(m312)*u(i1+1,i2-1,i3  )+ \
                    cc(m132)*u(i1-1,i2+1,i3  )+ \
                    cc(m232)*u(i1  ,i2+1,i3  )+ \
                    cc(m332)*u(i1+1,i2+1,i3  )+ \
                    cc(m113)*u(i1-1,i2-1,i3+1)+ \
                    cc(m213)*u(i1  ,i2-1,i3+1)+ \
                    cc(m313)*u(i1+1,i2-1,i3+1)+ \
                    cc(m123)*u(i1-1,i2  ,i3+1)+ \
                    cc(m223)*u(i1  ,i2  ,i3+1)+ \
                    cc(m323)*u(i1+1,i2  ,i3+1)+ \
                    cc(m133)*u(i1-1,i2+1,i3+1)+ \
                    cc(m233)*u(i1  ,i2+1,i3+1)+ \
                    cc(m333)*u(i1+1,i2+1,i3+1)
 op3dCCl1(i1,i2,i3)= \
                    cc(m111)*u(i1-1,i2-1,i3-1)+ \
                    cc(m211)*u(i1  ,i2-1,i3-1)+ \
                    cc(m311)*u(i1+1,i2-1,i3-1)+ \
                    cc(m121)*u(i1-1,i2  ,i3-1)+ \
                    cc(m221)*u(i1  ,i2  ,i3-1)+ \
                    cc(m321)*u(i1+1,i2  ,i3-1)+ \
                    cc(m131)*u(i1-1,i2+1,i3-1)+ \
                    cc(m231)*u(i1  ,i2+1,i3-1)+ \
                    cc(m331)*u(i1+1,i2+1,i3-1)+ \
                    cc(m112)*u(i1-1,i2-1,i3  )+ \
                    cc(m312)*u(i1+1,i2-1,i3  )+ \
                    cc(m122)*u(i1-1,i2  ,i3  )+ \
                    cc(m322)*u(i1+1,i2  ,i3  )+ \
                    cc(m132)*u(i1-1,i2+1,i3  )+ \
                    cc(m332)*u(i1+1,i2+1,i3  )+ \
                    cc(m113)*u(i1-1,i2-1,i3+1)+ \
                    cc(m213)*u(i1  ,i2-1,i3+1)+ \
                    cc(m313)*u(i1+1,i2-1,i3+1)+ \
                    cc(m123)*u(i1-1,i2  ,i3+1)+ \
                    cc(m223)*u(i1  ,i2  ,i3+1)+ \
                    cc(m323)*u(i1+1,i2  ,i3+1)+ \
                    cc(m133)*u(i1-1,i2+1,i3+1)+ \
                    cc(m233)*u(i1  ,i2+1,i3+1)+ \
                    cc(m333)*u(i1+1,i2+1,i3+1)
 op3dCCl2(i1,i2,i3)= \
                    cc(m111)*u(i1-1,i2-1,i3-1)+ \
                    cc(m211)*u(i1  ,i2-1,i3-1)+ \
                    cc(m311)*u(i1+1,i2-1,i3-1)+ \
                    cc(m121)*u(i1-1,i2  ,i3-1)+ \
                    cc(m321)*u(i1+1,i2  ,i3-1)+ \
                    cc(m131)*u(i1-1,i2+1,i3-1)+ \
                    cc(m231)*u(i1  ,i2+1,i3-1)+ \
                    cc(m331)*u(i1+1,i2+1,i3-1)+ \
                    cc(m112)*u(i1-1,i2-1,i3  )+ \
                    cc(m212)*u(i1  ,i2-1,i3  )+ \
                    cc(m312)*u(i1+1,i2-1,i3  )+ \
                    cc(m122)*u(i1-1,i2  ,i3  )+ \
                    cc(m322)*u(i1+1,i2  ,i3  )+ \
                    cc(m132)*u(i1-1,i2+1,i3  )+ \
                    cc(m232)*u(i1  ,i2+1,i3  )+ \
                    cc(m332)*u(i1+1,i2+1,i3  )+ \
                    cc(m113)*u(i1-1,i2-1,i3+1)+ \
                    cc(m213)*u(i1  ,i2-1,i3+1)+ \
                    cc(m313)*u(i1+1,i2-1,i3+1)+ \
                    cc(m123)*u(i1-1,i2  ,i3+1)+ \
                    cc(m323)*u(i1+1,i2  ,i3+1)+ \
                    cc(m133)*u(i1-1,i2+1,i3+1)+ \
                    cc(m233)*u(i1  ,i2+1,i3+1)+ \
                    cc(m333)*u(i1+1,i2+1,i3+1)

#End

#If #DIM == "2"
 ! ===========  div( s grad ) ===========================
 op2dSparseVC(i1,i2,i3)= \
     a2m*u(i1  ,i2-1,i3)+ \
     a1m*u(i1-1,i2  ,i3)+ \
     ad *u(i1  ,i2  ,i3)+ \
     a1p*u(i1+1,i2  ,i3)+ \
     a2p*u(i1  ,i2+1,i3)

 op2dSparseVCl0(i1,i2,i3)= \
     a2m*u(i1  ,i2-1,i3)+ \
      a2p*u(i1  ,i2+1,i3)

 op2dSparseVCl1(i1,i2,i3)= \
      a1m*u(i1-1,i2  ,i3)+ \
      a1p*u(i1+1,i2  ,i3) 

#End
#If #DIM == "3"
 op3dSparseVC(i1,i2,i3) = \
     a3m*u(i1  ,i2  ,i3-1)+ \
     a2m*u(i1  ,i2-1,i3  )+ \
     a1m*u(i1-1,i2  ,i3  )+ \
     ad*u(i1  ,i2  ,i3  )+ \
     a1p*u(i1+1,i2  ,i3  )+ \
     a2p*u(i1  ,i2+1,i3  )+ \
     a3p*u(i1  ,i2  ,i3+1)

 op3dSparseVCl0(i1,i2,i3) = \
     a3m*u(i1  ,i2  ,i3-1)+ \
     a2m*u(i1  ,i2-1,i3  )+ \
     a2p*u(i1  ,i2+1,i3  )+ \
     a3p*u(i1  ,i2  ,i3+1)

 op3dSparseVCl1(i1,i2,i3) = \
     a3m*u(i1  ,i2  ,i3-1)+ \
     a1m*u(i1-1,i2  ,i3  )+ \
     a1p*u(i1+1,i2  ,i3  )+ \
     a3p*u(i1  ,i2  ,i3+1)

 op3dSparseVCl2(i1,i2,i3) = \
     a2m*u(i1  ,i2-1,i3  )+ \
     a1m*u(i1-1,i2  ,i3  )+ \
     a1p*u(i1+1,i2  ,i3  )+ \
     a2p*u(i1  ,i2+1,i3  ) 

#End
#If #DIM == "2"
 ! ==================================================
 ! ===========  4th order ===========================
 ! ==================================================
 op2dSparse4(i1,i2,i3)= \
     c(m31,i1,i2,i3)*u(i1  ,i2-2,i3)+ \
     c(m32,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m13,i1,i2,i3)*u(i1-2,i2  ,i3)+ \
     c(m23,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m33,i1,i2,i3)*u(i1  ,i2  ,i3)+ \
     c(m43,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m53,i1,i2,i3)*u(i1+2,i2  ,i3)+ \
     c(m34,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m35,i1,i2,i3)*u(i1  ,i2+2,i3)
 op2dSparse4l0(i1,i2,i3)= \
     c(m31,i1,i2,i3)*u(i1  ,i2-2,i3)+ \
     c(m32,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m34,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m35,i1,i2,i3)*u(i1  ,i2+2,i3)
 op2dSparse4l1(i1,i2,i3)= \
     c(m13,i1,i2,i3)*u(i1-2,i2  ,i3)+ \
     c(m23,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m43,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m53,i1,i2,i3)*u(i1+2,i2  ,i3) 

 op2d4(i1,i2,i3)= \
     c(m11,i1,i2,i3)*u(i1-2,i2-2,i3)+ \
     c(m21,i1,i2,i3)*u(i1-1,i2-2,i3)+ \
     c(m31,i1,i2,i3)*u(i1  ,i2-2,i3)+ \
     c(m41,i1,i2,i3)*u(i1+1,i2-2,i3)+ \
     c(m51,i1,i2,i3)*u(i1+2,i2-2,i3)+ \
     c(m12,i1,i2,i3)*u(i1-2,i2-1,i3)+ \
     c(m22,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m32,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m42,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m52,i1,i2,i3)*u(i1+2,i2-1,i3)+ \
     c(m13,i1,i2,i3)*u(i1-2,i2  ,i3)+ \
     c(m23,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m33,i1,i2,i3)*u(i1  ,i2  ,i3)+ \
     c(m43,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m53,i1,i2,i3)*u(i1+2,i2  ,i3)+ \
     c(m14,i1,i2,i3)*u(i1-2,i2+1,i3)+ \
     c(m24,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m34,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m44,i1,i2,i3)*u(i1+1,i2+1,i3)+ \
     c(m54,i1,i2,i3)*u(i1+2,i2+1,i3)+ \
     c(m15,i1,i2,i3)*u(i1-2,i2+2,i3)+ \
     c(m25,i1,i2,i3)*u(i1-1,i2+2,i3)+ \
     c(m35,i1,i2,i3)*u(i1  ,i2+2,i3)+ \
     c(m45,i1,i2,i3)*u(i1+1,i2+2,i3)+ \
     c(m55,i1,i2,i3)*u(i1+2,i2+2,i3)

 op2d4l0(i1,i2,i3)= \
     c(m11,i1,i2,i3)*u(i1-2,i2-2,i3)+ \
     c(m21,i1,i2,i3)*u(i1-1,i2-2,i3)+ \
     c(m31,i1,i2,i3)*u(i1  ,i2-2,i3)+ \
     c(m41,i1,i2,i3)*u(i1+1,i2-2,i3)+ \
     c(m51,i1,i2,i3)*u(i1+2,i2-2,i3)+ \
     c(m12,i1,i2,i3)*u(i1-2,i2-1,i3)+ \
     c(m22,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m32,i1,i2,i3)*u(i1  ,i2-1,i3)+ \
     c(m42,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m52,i1,i2,i3)*u(i1+2,i2-1,i3)+ \
     c(m14,i1,i2,i3)*u(i1-2,i2+1,i3)+ \
     c(m24,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m34,i1,i2,i3)*u(i1  ,i2+1,i3)+ \
     c(m44,i1,i2,i3)*u(i1+1,i2+1,i3)+ \
     c(m54,i1,i2,i3)*u(i1+2,i2+1,i3)+ \
     c(m15,i1,i2,i3)*u(i1-2,i2+2,i3)+ \
     c(m25,i1,i2,i3)*u(i1-1,i2+2,i3)+ \
     c(m35,i1,i2,i3)*u(i1  ,i2+2,i3)+ \
     c(m45,i1,i2,i3)*u(i1+1,i2+2,i3)+ \
     c(m55,i1,i2,i3)*u(i1+2,i2+2,i3)

 op2d4l1(i1,i2,i3)= \
     c(m11,i1,i2,i3)*u(i1-2,i2-2,i3)+ \
     c(m21,i1,i2,i3)*u(i1-1,i2-2,i3)+ \
     c(m41,i1,i2,i3)*u(i1+1,i2-2,i3)+ \
     c(m51,i1,i2,i3)*u(i1+2,i2-2,i3)+ \
     c(m12,i1,i2,i3)*u(i1-2,i2-1,i3)+ \
     c(m22,i1,i2,i3)*u(i1-1,i2-1,i3)+ \
     c(m42,i1,i2,i3)*u(i1+1,i2-1,i3)+ \
     c(m52,i1,i2,i3)*u(i1+2,i2-1,i3)+ \
     c(m13,i1,i2,i3)*u(i1-2,i2  ,i3)+ \
     c(m23,i1,i2,i3)*u(i1-1,i2  ,i3)+ \
     c(m43,i1,i2,i3)*u(i1+1,i2  ,i3)+ \
     c(m53,i1,i2,i3)*u(i1+2,i2  ,i3)+ \
     c(m14,i1,i2,i3)*u(i1-2,i2+1,i3)+ \
     c(m24,i1,i2,i3)*u(i1-1,i2+1,i3)+ \
     c(m44,i1,i2,i3)*u(i1+1,i2+1,i3)+ \
     c(m54,i1,i2,i3)*u(i1+2,i2+1,i3)+ \
     c(m15,i1,i2,i3)*u(i1-2,i2+2,i3)+ \
     c(m25,i1,i2,i3)*u(i1-1,i2+2,i3)+ \
     c(m45,i1,i2,i3)*u(i1+1,i2+2,i3)+ \
     c(m55,i1,i2,i3)*u(i1+2,i2+2,i3)

#End

#If #DIM == "3"

 op3dSparse4(i1,i2,i3) =  \
     c(m331,i1,i2,i3)*u(i1  ,i2  ,i3-2)+ \
     c(m332,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
     c(m313,i1,i2,i3)*u(i1  ,i2-2,i3  )+ \
     c(m323,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
     c(m133,i1,i2,i3)*u(i1-2,i2  ,i3  )+ \
     c(m233,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
     c(m333,i1,i2,i3)*u(i1  ,i2  ,i3  )+ \
     c(m433,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
     c(m533,i1,i2,i3)*u(i1+2,i2  ,i3  )+ \
     c(m343,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
     c(m353,i1,i2,i3)*u(i1  ,i2+2,i3  )+ \
     c(m334,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
     c(m335,i1,i2,i3)*u(i1  ,i2  ,i3+2)

 op3dSparse4l0(i1,i2,i3) =  \
     c(m331,i1,i2,i3)*u(i1  ,i2  ,i3-2)+ \
     c(m332,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
     c(m313,i1,i2,i3)*u(i1  ,i2-2,i3  )+ \
     c(m323,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
     c(m343,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
     c(m353,i1,i2,i3)*u(i1  ,i2+2,i3  )+ \
     c(m334,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
     c(m335,i1,i2,i3)*u(i1  ,i2  ,i3+2)

 op3dSparse4l1(i1,i2,i3) =  \
     c(m331,i1,i2,i3)*u(i1  ,i2  ,i3-2)+ \
     c(m332,i1,i2,i3)*u(i1  ,i2  ,i3-1)+ \
     c(m133,i1,i2,i3)*u(i1-2,i2  ,i3  )+ \
     c(m233,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
     c(m433,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
     c(m533,i1,i2,i3)*u(i1+2,i2  ,i3  )+ \
     c(m334,i1,i2,i3)*u(i1  ,i2  ,i3+1)+ \
     c(m335,i1,i2,i3)*u(i1  ,i2  ,i3+2)

 op3dSparse4l2(i1,i2,i3) =  \
     c(m313,i1,i2,i3)*u(i1  ,i2-2,i3  )+ \
     c(m323,i1,i2,i3)*u(i1  ,i2-1,i3  )+ \
     c(m133,i1,i2,i3)*u(i1-2,i2  ,i3  )+ \
     c(m233,i1,i2,i3)*u(i1-1,i2  ,i3  )+ \
     c(m433,i1,i2,i3)*u(i1+1,i2  ,i3  )+ \
     c(m533,i1,i2,i3)*u(i1+2,i2  ,i3  )+ \
     c(m343,i1,i2,i3)*u(i1  ,i2+1,i3  )+ \
     c(m353,i1,i2,i3)*u(i1  ,i2+2,i3  ) 

 op3d4a(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     c(m11n,i1,i2,i3)*u(i1-2,i2-2,i3+n)+ \
     c(m21n,i1,i2,i3)*u(i1-1,i2-2,i3+n)+ \
     c(m31n,i1,i2,i3)*u(i1  ,i2-2,i3+n)+ \
     c(m41n,i1,i2,i3)*u(i1+1,i2-2,i3+n)+ \
     c(m51n,i1,i2,i3)*u(i1+2,i2-2,i3+n)+ \
     c(m12n,i1,i2,i3)*u(i1-2,i2-1,i3+n)+ \
     c(m22n,i1,i2,i3)*u(i1-1,i2-1,i3+n)+ \
     c(m32n,i1,i2,i3)*u(i1  ,i2-1,i3+n)+ \
     c(m42n,i1,i2,i3)*u(i1+1,i2-1,i3+n)+ \
     c(m52n,i1,i2,i3)*u(i1+2,i2-1,i3+n)+ \
     c(m13n,i1,i2,i3)*u(i1-2,i2  ,i3+n)+ \
     c(m23n,i1,i2,i3)*u(i1-1,i2  ,i3+n)+ \
     c(m33n,i1,i2,i3)*u(i1  ,i2  ,i3+n)+ \
     c(m43n,i1,i2,i3)*u(i1+1,i2  ,i3+n)+ \
     c(m53n,i1,i2,i3)*u(i1+2,i2  ,i3+n)+ \
     c(m14n,i1,i2,i3)*u(i1-2,i2+1,i3+n)+ \
     c(m24n,i1,i2,i3)*u(i1-1,i2+1,i3+n)+ \
     c(m34n,i1,i2,i3)*u(i1  ,i2+1,i3+n)+ \
     c(m44n,i1,i2,i3)*u(i1+1,i2+1,i3+n)+ \
     c(m54n,i1,i2,i3)*u(i1+2,i2+1,i3+n)+ \
     c(m15n,i1,i2,i3)*u(i1-2,i2+2,i3+n)+ \
     c(m25n,i1,i2,i3)*u(i1-1,i2+2,i3+n)+ \
     c(m35n,i1,i2,i3)*u(i1  ,i2+2,i3+n)+ \
     c(m45n,i1,i2,i3)*u(i1+1,i2+2,i3+n)+ \
     c(m55n,i1,i2,i3)*u(i1+2,i2+2,i3+n)
 op3d4al0(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     c(m11n,i1,i2,i3)*u(i1-2,i2-2,i3+n)+ \
     c(m21n,i1,i2,i3)*u(i1-1,i2-2,i3+n)+ \
     c(m31n,i1,i2,i3)*u(i1  ,i2-2,i3+n)+ \
     c(m41n,i1,i2,i3)*u(i1+1,i2-2,i3+n)+ \
     c(m51n,i1,i2,i3)*u(i1+2,i2-2,i3+n)+ \
     c(m12n,i1,i2,i3)*u(i1-2,i2-1,i3+n)+ \
     c(m22n,i1,i2,i3)*u(i1-1,i2-1,i3+n)+ \
     c(m32n,i1,i2,i3)*u(i1  ,i2-1,i3+n)+ \
     c(m42n,i1,i2,i3)*u(i1+1,i2-1,i3+n)+ \
     c(m52n,i1,i2,i3)*u(i1+2,i2-1,i3+n)+ \
     c(m14n,i1,i2,i3)*u(i1-2,i2+1,i3+n)+ \
     c(m24n,i1,i2,i3)*u(i1-1,i2+1,i3+n)+ \
     c(m34n,i1,i2,i3)*u(i1  ,i2+1,i3+n)+ \
     c(m44n,i1,i2,i3)*u(i1+1,i2+1,i3+n)+ \
     c(m54n,i1,i2,i3)*u(i1+2,i2+1,i3+n)+ \
     c(m15n,i1,i2,i3)*u(i1-2,i2+2,i3+n)+ \
     c(m25n,i1,i2,i3)*u(i1-1,i2+2,i3+n)+ \
     c(m35n,i1,i2,i3)*u(i1  ,i2+2,i3+n)+ \
     c(m45n,i1,i2,i3)*u(i1+1,i2+2,i3+n)+ \
     c(m55n,i1,i2,i3)*u(i1+2,i2+2,i3+n)
 op3d4al1(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     c(m11n,i1,i2,i3)*u(i1-2,i2-2,i3+n)+ \
     c(m21n,i1,i2,i3)*u(i1-1,i2-2,i3+n)+ \
     c(m41n,i1,i2,i3)*u(i1+1,i2-2,i3+n)+ \
     c(m51n,i1,i2,i3)*u(i1+2,i2-2,i3+n)+ \
     c(m12n,i1,i2,i3)*u(i1-2,i2-1,i3+n)+ \
     c(m22n,i1,i2,i3)*u(i1-1,i2-1,i3+n)+ \
     c(m42n,i1,i2,i3)*u(i1+1,i2-1,i3+n)+ \
     c(m52n,i1,i2,i3)*u(i1+2,i2-1,i3+n)+ \
     c(m13n,i1,i2,i3)*u(i1-2,i2  ,i3+n)+ \
     c(m23n,i1,i2,i3)*u(i1-1,i2  ,i3+n)+ \
     c(m43n,i1,i2,i3)*u(i1+1,i2  ,i3+n)+ \
     c(m53n,i1,i2,i3)*u(i1+2,i2  ,i3+n)+ \
     c(m14n,i1,i2,i3)*u(i1-2,i2+1,i3+n)+ \
     c(m24n,i1,i2,i3)*u(i1-1,i2+1,i3+n)+ \
     c(m44n,i1,i2,i3)*u(i1+1,i2+1,i3+n)+ \
     c(m54n,i1,i2,i3)*u(i1+2,i2+1,i3+n)+ \
     c(m15n,i1,i2,i3)*u(i1-2,i2+2,i3+n)+ \
     c(m25n,i1,i2,i3)*u(i1-1,i2+2,i3+n)+ \
     c(m45n,i1,i2,i3)*u(i1+1,i2+2,i3+n)+ \
     c(m55n,i1,i2,i3)*u(i1+2,i2+2,i3+n)
 op3d4al2(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     c(m11n,i1,i2,i3)*u(i1-2,i2-2,i3+n)+ \
     c(m21n,i1,i2,i3)*u(i1-1,i2-2,i3+n)+ \
     c(m31n,i1,i2,i3)*u(i1  ,i2-2,i3+n)+ \
     c(m41n,i1,i2,i3)*u(i1+1,i2-2,i3+n)+ \
     c(m51n,i1,i2,i3)*u(i1+2,i2-2,i3+n)+ \
     c(m12n,i1,i2,i3)*u(i1-2,i2-1,i3+n)+ \
     c(m22n,i1,i2,i3)*u(i1-1,i2-1,i3+n)+ \
     c(m32n,i1,i2,i3)*u(i1  ,i2-1,i3+n)+ \
     c(m42n,i1,i2,i3)*u(i1+1,i2-1,i3+n)+ \
     c(m52n,i1,i2,i3)*u(i1+2,i2-1,i3+n)+ \
     c(m13n,i1,i2,i3)*u(i1-2,i2  ,i3+n)+ \
     c(m23n,i1,i2,i3)*u(i1-1,i2  ,i3+n)+ \
     c(m43n,i1,i2,i3)*u(i1+1,i2  ,i3+n)+ \
     c(m53n,i1,i2,i3)*u(i1+2,i2  ,i3+n)+ \
     c(m14n,i1,i2,i3)*u(i1-2,i2+1,i3+n)+ \
     c(m24n,i1,i2,i3)*u(i1-1,i2+1,i3+n)+ \
     c(m34n,i1,i2,i3)*u(i1  ,i2+1,i3+n)+ \
     c(m44n,i1,i2,i3)*u(i1+1,i2+1,i3+n)+ \
     c(m54n,i1,i2,i3)*u(i1+2,i2+1,i3+n)+ \
     c(m15n,i1,i2,i3)*u(i1-2,i2+2,i3+n)+ \
     c(m25n,i1,i2,i3)*u(i1-1,i2+2,i3+n)+ \
     c(m35n,i1,i2,i3)*u(i1  ,i2+2,i3+n)+ \
     c(m45n,i1,i2,i3)*u(i1+1,i2+2,i3+n)+ \
     c(m55n,i1,i2,i3)*u(i1+2,i2+2,i3+n)

 op3d4(i1,i2,i3)= \
         op3d4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3d4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3d4a(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3d4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3d4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)

 op3d4l0(i1,i2,i3)= \
         op3d4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3d4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3d4al0(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3d4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3d4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)

 op3d4l1(i1,i2,i3)= \
         op3d4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3d4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3d4al1(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3d4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3d4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)

 op3d4l2(i1,i2,i3)= \
         op3d4al2(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3d4al2(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3d4al2(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3d4al2(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3d4al2(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)

#End
#If #DIM == "2"
 ! ------------------------------------------------------
 ! --------- const coefficients versions ----------------
 ! ------------------------------------------------------
 op2dSparseCC4(i1,i2,i3)= \
     cc(m31)*u(i1  ,i2-2,i3)+ \
     cc(m32)*u(i1  ,i2-1,i3)+ \
     cc(m13)*u(i1-2,i2  ,i3)+ \
     cc(m23)*u(i1-1,i2  ,i3)+ \
     cc(m33)*u(i1  ,i2  ,i3)+ \
     cc(m43)*u(i1+1,i2  ,i3)+ \
     cc(m53)*u(i1+2,i2  ,i3)+ \
     cc(m34)*u(i1  ,i2+1,i3)+ \
     cc(m35)*u(i1  ,i2+2,i3)

 op2dSparseCC4l0(i1,i2,i3)= \
     cc(m31)*u(i1  ,i2-2,i3)+ \
     cc(m32)*u(i1  ,i2-1,i3)+ \
     cc(m34)*u(i1  ,i2+1,i3)+ \
     cc(m35)*u(i1  ,i2+2,i3)

 op2dSparseCC4l1(i1,i2,i3)= \
     cc(m13)*u(i1-2,i2  ,i3)+ \
     cc(m23)*u(i1-1,i2  ,i3)+ \
     cc(m43)*u(i1+1,i2  ,i3)+ \
     cc(m53)*u(i1+2,i2  ,i3)

 op2dCC4(i1,i2,i3)= \
     cc(m11)*u(i1-2,i2-2,i3)+ \
     cc(m21)*u(i1-1,i2-2,i3)+ \
     cc(m31)*u(i1  ,i2-2,i3)+ \
     cc(m41)*u(i1+1,i2-2,i3)+ \
     cc(m51)*u(i1+2,i2-2,i3)+ \
     cc(m12)*u(i1-2,i2-1,i3)+ \
     cc(m22)*u(i1-1,i2-1,i3)+ \
     cc(m32)*u(i1  ,i2-1,i3)+ \
     cc(m42)*u(i1+1,i2-1,i3)+ \
     cc(m52)*u(i1+2,i2-1,i3)+ \
     cc(m13)*u(i1-2,i2  ,i3)+ \
     cc(m23)*u(i1-1,i2  ,i3)+ \
     cc(m33)*u(i1  ,i2  ,i3)+ \
     cc(m43)*u(i1+1,i2  ,i3)+ \
     cc(m53)*u(i1+2,i2  ,i3)+ \
     cc(m14)*u(i1-2,i2+1,i3)+ \
     cc(m24)*u(i1-1,i2+1,i3)+ \
     cc(m34)*u(i1  ,i2+1,i3)+ \
     cc(m44)*u(i1+1,i2+1,i3)+ \
     cc(m54)*u(i1+2,i2+1,i3)+ \
     cc(m15)*u(i1-2,i2+2,i3)+ \
     cc(m25)*u(i1-1,i2+2,i3)+ \
     cc(m35)*u(i1  ,i2+2,i3)+ \
     cc(m45)*u(i1+1,i2+2,i3)+ \
     cc(m55)*u(i1+2,i2+2,i3)

 op2dCC4l0(i1,i2,i3)= \
     cc(m11)*u(i1-2,i2-2,i3)+ \
     cc(m21)*u(i1-1,i2-2,i3)+ \
     cc(m31)*u(i1  ,i2-2,i3)+ \
     cc(m41)*u(i1+1,i2-2,i3)+ \
     cc(m51)*u(i1+2,i2-2,i3)+ \
     cc(m12)*u(i1-2,i2-1,i3)+ \
     cc(m22)*u(i1-1,i2-1,i3)+ \
     cc(m32)*u(i1  ,i2-1,i3)+ \
     cc(m42)*u(i1+1,i2-1,i3)+ \
     cc(m52)*u(i1+2,i2-1,i3)+ \
     cc(m14)*u(i1-2,i2+1,i3)+ \
     cc(m24)*u(i1-1,i2+1,i3)+ \
     cc(m34)*u(i1  ,i2+1,i3)+ \
     cc(m44)*u(i1+1,i2+1,i3)+ \
     cc(m54)*u(i1+2,i2+1,i3)+ \
     cc(m15)*u(i1-2,i2+2,i3)+ \
     cc(m25)*u(i1-1,i2+2,i3)+ \
     cc(m35)*u(i1  ,i2+2,i3)+ \
     cc(m45)*u(i1+1,i2+2,i3)+ \
     cc(m55)*u(i1+2,i2+2,i3)

 op2dCC4l1(i1,i2,i3)= \
     cc(m11)*u(i1-2,i2-2,i3)+ \
     cc(m21)*u(i1-1,i2-2,i3)+ \
     cc(m41)*u(i1+1,i2-2,i3)+ \
     cc(m51)*u(i1+2,i2-2,i3)+ \
     cc(m12)*u(i1-2,i2-1,i3)+ \
     cc(m22)*u(i1-1,i2-1,i3)+ \
     cc(m42)*u(i1+1,i2-1,i3)+ \
     cc(m52)*u(i1+2,i2-1,i3)+ \
     cc(m13)*u(i1-2,i2  ,i3)+ \
     cc(m23)*u(i1-1,i2  ,i3)+ \
     cc(m43)*u(i1+1,i2  ,i3)+ \
     cc(m53)*u(i1+2,i2  ,i3)+ \
     cc(m14)*u(i1-2,i2+1,i3)+ \
     cc(m24)*u(i1-1,i2+1,i3)+ \
     cc(m44)*u(i1+1,i2+1,i3)+ \
     cc(m54)*u(i1+2,i2+1,i3)+ \
     cc(m15)*u(i1-2,i2+2,i3)+ \
     cc(m25)*u(i1-1,i2+2,i3)+ \
     cc(m45)*u(i1+1,i2+2,i3)+ \
     cc(m55)*u(i1+2,i2+2,i3)
#End

#If #DIM == "3"

 op3dSparseCC4(i1,i2,i3) =  \
     cc(m331)*u(i1  ,i2  ,i3-2)+ \
     cc(m332)*u(i1  ,i2  ,i3-1)+ \
     cc(m313)*u(i1  ,i2-2,i3  )+ \
     cc(m323)*u(i1  ,i2-1,i3  )+ \
     cc(m133)*u(i1-2,i2  ,i3  )+ \
     cc(m233)*u(i1-1,i2  ,i3  )+ \
     cc(m333)*u(i1  ,i2  ,i3  )+ \
     cc(m433)*u(i1+1,i2  ,i3  )+ \
     cc(m533)*u(i1+2,i2  ,i3  )+ \
     cc(m343)*u(i1  ,i2+1,i3  )+ \
     cc(m353)*u(i1  ,i2+2,i3  )+ \
     cc(m334)*u(i1  ,i2  ,i3+1)+ \
     cc(m335)*u(i1  ,i2  ,i3+2)

 op3dSparseCC4l0(i1,i2,i3) =  \
     cc(m331)*u(i1  ,i2  ,i3-2)+ \
     cc(m332)*u(i1  ,i2  ,i3-1)+ \
     cc(m313)*u(i1  ,i2-2,i3  )+ \
     cc(m323)*u(i1  ,i2-1,i3  )+ \
     cc(m343)*u(i1  ,i2+1,i3  )+ \
     cc(m353)*u(i1  ,i2+2,i3  )+ \
     cc(m334)*u(i1  ,i2  ,i3+1)+ \
     cc(m335)*u(i1  ,i2  ,i3+2)

 op3dSparseCC4l1(i1,i2,i3) =  \
     cc(m331)*u(i1  ,i2  ,i3-2)+ \
     cc(m332)*u(i1  ,i2  ,i3-1)+ \
     cc(m133)*u(i1-2,i2  ,i3  )+ \
     cc(m233)*u(i1-1,i2  ,i3  )+ \
     cc(m433)*u(i1+1,i2  ,i3  )+ \
     cc(m533)*u(i1+2,i2  ,i3  )+ \
     cc(m334)*u(i1  ,i2  ,i3+1)+ \
     cc(m335)*u(i1  ,i2  ,i3+2)

 op3dSparseCC4l2(i1,i2,i3) =  \
     cc(m313)*u(i1  ,i2-2,i3  )+ \
     cc(m323)*u(i1  ,i2-1,i3  )+ \
     cc(m133)*u(i1-2,i2  ,i3  )+ \
     cc(m233)*u(i1-1,i2  ,i3  )+ \
     cc(m433)*u(i1+1,i2  ,i3  )+ \
     cc(m533)*u(i1+2,i2  ,i3  )+ \
     cc(m343)*u(i1  ,i2+1,i3  )+ \
     cc(m353)*u(i1  ,i2+2,i3  ) 

 op3dCC4a(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     cc(m11n)*u(i1-2,i2-2,i3+n)+ \
     cc(m21n)*u(i1-1,i2-2,i3+n)+ \
     cc(m31n)*u(i1  ,i2-2,i3+n)+ \
     cc(m41n)*u(i1+1,i2-2,i3+n)+ \
     cc(m51n)*u(i1+2,i2-2,i3+n)+ \
     cc(m12n)*u(i1-2,i2-1,i3+n)+ \
     cc(m22n)*u(i1-1,i2-1,i3+n)+ \
     cc(m32n)*u(i1  ,i2-1,i3+n)+ \
     cc(m42n)*u(i1+1,i2-1,i3+n)+ \
     cc(m52n)*u(i1+2,i2-1,i3+n)+ \
     cc(m13n)*u(i1-2,i2  ,i3+n)+ \
     cc(m23n)*u(i1-1,i2  ,i3+n)+ \
     cc(m33n)*u(i1  ,i2  ,i3+n)+ \
     cc(m43n)*u(i1+1,i2  ,i3+n)+ \
     cc(m53n)*u(i1+2,i2  ,i3+n)+ \
     cc(m14n)*u(i1-2,i2+1,i3+n)+ \
     cc(m24n)*u(i1-1,i2+1,i3+n)+ \
     cc(m34n)*u(i1  ,i2+1,i3+n)+ \
     cc(m44n)*u(i1+1,i2+1,i3+n)+ \
     cc(m54n)*u(i1+2,i2+1,i3+n)+ \
     cc(m15n)*u(i1-2,i2+2,i3+n)+ \
     cc(m25n)*u(i1-1,i2+2,i3+n)+ \
     cc(m35n)*u(i1  ,i2+2,i3+n)+ \
     cc(m45n)*u(i1+1,i2+2,i3+n)+ \
     cc(m55n)*u(i1+2,i2+2,i3+n)

 op3dCC4al0(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     cc(m11n)*u(i1-2,i2-2,i3+n)+ \
     cc(m21n)*u(i1-1,i2-2,i3+n)+ \
     cc(m31n)*u(i1  ,i2-2,i3+n)+ \
     cc(m41n)*u(i1+1,i2-2,i3+n)+ \
     cc(m51n)*u(i1+2,i2-2,i3+n)+ \
     cc(m12n)*u(i1-2,i2-1,i3+n)+ \
     cc(m22n)*u(i1-1,i2-1,i3+n)+ \
     cc(m32n)*u(i1  ,i2-1,i3+n)+ \
     cc(m42n)*u(i1+1,i2-1,i3+n)+ \
     cc(m52n)*u(i1+2,i2-1,i3+n)+ \
     cc(m14n)*u(i1-2,i2+1,i3+n)+ \
     cc(m24n)*u(i1-1,i2+1,i3+n)+ \
     cc(m34n)*u(i1  ,i2+1,i3+n)+ \
     cc(m44n)*u(i1+1,i2+1,i3+n)+ \
     cc(m54n)*u(i1+2,i2+1,i3+n)+ \
     cc(m15n)*u(i1-2,i2+2,i3+n)+ \
     cc(m25n)*u(i1-1,i2+2,i3+n)+ \
     cc(m35n)*u(i1  ,i2+2,i3+n)+ \
     cc(m45n)*u(i1+1,i2+2,i3+n)+ \
     cc(m55n)*u(i1+2,i2+2,i3+n)

 op3dCC4al1(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     cc(m11n)*u(i1-2,i2-2,i3+n)+ \
     cc(m21n)*u(i1-1,i2-2,i3+n)+ \
     cc(m41n)*u(i1+1,i2-2,i3+n)+ \
     cc(m51n)*u(i1+2,i2-2,i3+n)+ \
     cc(m12n)*u(i1-2,i2-1,i3+n)+ \
     cc(m22n)*u(i1-1,i2-1,i3+n)+ \
     cc(m42n)*u(i1+1,i2-1,i3+n)+ \
     cc(m52n)*u(i1+2,i2-1,i3+n)+ \
     cc(m13n)*u(i1-2,i2  ,i3+n)+ \
     cc(m23n)*u(i1-1,i2  ,i3+n)+ \
     cc(m43n)*u(i1+1,i2  ,i3+n)+ \
     cc(m53n)*u(i1+2,i2  ,i3+n)+ \
     cc(m14n)*u(i1-2,i2+1,i3+n)+ \
     cc(m24n)*u(i1-1,i2+1,i3+n)+ \
     cc(m44n)*u(i1+1,i2+1,i3+n)+ \
     cc(m54n)*u(i1+2,i2+1,i3+n)+ \
     cc(m15n)*u(i1-2,i2+2,i3+n)+ \
     cc(m25n)*u(i1-1,i2+2,i3+n)+ \
     cc(m45n)*u(i1+1,i2+2,i3+n)+ \
     cc(m55n)*u(i1+2,i2+2,i3+n)

 op3dCC4al2(i1,i2,i3,n, \
           m11n,m21n,m31n,m41n,m51n, \
           m12n,m22n,m32n,m42n,m52n, \
           m13n,m23n,m33n,m43n,m53n, \
           m14n,m24n,m34n,m44n,m54n, \
           m15n,m25n,m35n,m45n,m55n)= \
     cc(m11n)*u(i1-2,i2-2,i3+n)+ \
     cc(m21n)*u(i1-1,i2-2,i3+n)+ \
     cc(m31n)*u(i1  ,i2-2,i3+n)+ \
     cc(m41n)*u(i1+1,i2-2,i3+n)+ \
     cc(m51n)*u(i1+2,i2-2,i3+n)+ \
     cc(m12n)*u(i1-2,i2-1,i3+n)+ \
     cc(m22n)*u(i1-1,i2-1,i3+n)+ \
     cc(m32n)*u(i1  ,i2-1,i3+n)+ \
     cc(m42n)*u(i1+1,i2-1,i3+n)+ \
     cc(m52n)*u(i1+2,i2-1,i3+n)+ \
     cc(m13n)*u(i1-2,i2  ,i3+n)+ \
     cc(m23n)*u(i1-1,i2  ,i3+n)+ \
     cc(m43n)*u(i1+1,i2  ,i3+n)+ \
     cc(m53n)*u(i1+2,i2  ,i3+n)+ \
     cc(m14n)*u(i1-2,i2+1,i3+n)+ \
     cc(m24n)*u(i1-1,i2+1,i3+n)+ \
     cc(m34n)*u(i1  ,i2+1,i3+n)+ \
     cc(m44n)*u(i1+1,i2+1,i3+n)+ \
     cc(m54n)*u(i1+2,i2+1,i3+n)+ \
     cc(m15n)*u(i1-2,i2+2,i3+n)+ \
     cc(m25n)*u(i1-1,i2+2,i3+n)+ \
     cc(m35n)*u(i1  ,i2+2,i3+n)+ \
     cc(m45n)*u(i1+1,i2+2,i3+n)+ \
     cc(m55n)*u(i1+2,i2+2,i3+n)

 op3dCC4(i1,i2,i3)= \
         op3dCC4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3dCC4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3dCC4a(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3dCC4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3dCC4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)
 op3dCC4l0(i1,i2,i3)= \
         op3dCC4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3dCC4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3dCC4al0(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3dCC4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3dCC4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)
 op3dCC4l1(i1,i2,i3)= \
         op3dCC4a(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3dCC4a(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3dCC4al1(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3dCC4a(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3dCC4a(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)
 op3dCC4l2(i1,i2,i3)= \
         op3dCC4al2(i1,i2,i3,-2, \
           m111,m211,m311,m411,m511, \
           m121,m221,m321,m421,m521, \
           m131,m231,m331,m431,m531, \
           m141,m241,m341,m441,m541, \
           m151,m251,m351,m451,m551) \
        +op3dCC4al2(i1,i2,i3,-1, \
           m112,m212,m312,m412,m512, \
           m122,m222,m322,m422,m522, \
           m132,m232,m332,m432,m532, \
           m142,m242,m342,m442,m542, \
           m152,m252,m352,m452,m552) \
        +op3dCC4al2(i1,i2,i3,0, \
           m113,m213,m313,m413,m513, \
           m123,m223,m323,m423,m523, \
           m133,m233,m333,m433,m533, \
           m143,m243,m343,m443,m543, \
           m153,m253,m353,m453,m553) \
        +op3dCC4al2(i1,i2,i3,1, \
           m114,m214,m314,m414,m514, \
           m124,m224,m324,m424,m524, \
           m134,m234,m334,m434,m534, \
           m144,m244,m344,m444,m544, \
           m154,m254,m354,m454,m554) \
        +op3dCC4al2(i1,i2,i3,2, \
           m115,m215,m315,m415,m515, \
           m125,m225,m325,m425,m525, \
           m135,m235,m335,m435,m535, \
           m145,m245,m345,m445,m545, \
           m155,m255,m355,m455,m555)

#End
c............end statement functions


 defectOption    =ipar(0)
 lineSmoothOption=ipar(1)
 order           =ipar(2)
 sparseStencil   =ipar(3)

 if( order.ne.2 .and. order.ne.4 )then
   write(*,*) 'defectOpt:ERROR: invalid order=',order
   stop 1
 end if

 dx(1)=rpar(0)
 dx(2)=rpar(1)
 dx(3)=rpar(2)

 dx2i=.5/dx(1)**2
 dy2i=.5/dx(2)**2
 dz2i=.5/dx(3)**2

 #If #DIM == "2" 
   ! **************************
   ! ***** Two Dimensions *****
   ! **************************

   #If #ORDER == "2" 
     ! ****** 2nd order accurate ****

     m11=1                 ! MCE(-1,-1, 0)
     m21=2                 ! MCE( 0,-1, 0)
     m31=3                 ! MCE(+1,-1, 0)
     m12=4                 ! MCE(-1, 0, 0)
     m22=5                 ! MCE( 0, 0, 0)
     m32=6                 ! MCE(+1, 0, 0)
     m13=7                 ! MCE(-1,+1, 0)
     m23=8                 ! MCE( 0,+1, 0)
     m33=9                 ! MCE(+1,+1, 0)
     
     if( sparseStencil.eq.sparse )then
       DEFECT(op2dSparse,2)
     else if( sparseStencil.eq.general )then
       !    **** full stencil *****
       DEFECT(op2d,2)
     else if( sparseStencil.eq.constantCoefficients )then
       DEFECT(op2dCC,2)
     else if( sparseStencil.eq.sparseConstantCoefficients )then
       DEFECT(op2dSparseCC,2)
     else if( sparseStencil.eq.sparseVariableCoefficients )then
       DEFECT2dVC(op2dSparseVC,2)
     else if( sparseStencil.eq.variableCoefficients )then
       ! use sparse version for now:
       DEFECT2dVC(op2dSparseVC,2)
     else
       write(*,*) 'defectOpt:ERROR: invalid sparseStencil'
       stop 1
     end if

   #Elif #ORDER == "4" 
     ! ****** 4th order accurate ****
     
     m11=1     
     m21=2     
     m31=3     
     m41=4     
     m51=5     
     m12=6     
     m22=7     
     m32=8     
     m42=9     
     m52=10    
     m13=11    
     m23=12    
     m33=13    
     m43=14    
     m53=15    
     m14=16    
     m24=17    
     m34=18    
     m44=19    
     m54=20    
     m15=21    
     m25=22    
     m35=23    
     m45=24    
     m55=25    

     ! write(*,*) 'defect; cc=',(cc(i1),i1=1,25)

     if( sparseStencil.eq.sparse )then
       DEFECT(op2dSparse4,2)
     else if( sparseStencil.eq.general )then
       !    **** full stencil *****
       DEFECT(op2d4,2)
     else if( sparseStencil.eq.constantCoefficients )then
       DEFECT(op2dCC4,2)
     else if( sparseStencil.eq.sparseConstantCoefficients )then
       DEFECT(op2dSparseCC4,2)
     else
       write(*,*) 'defectOpt:ERROR: invalid sparseStencil'
       stop 1
     end if

   #Else 
     write(*,*) 'defectOpt:ERROR unknown order=',order
     stop 1
   #End

 #Else 
   ! ****************       
   ! ***** 3D *******       
   ! ****************       
   #If #ORDER == "2" 
     ! ****** 2nd order accurate ****

     m111=1 
     m211=2 
     m311=3 
     m121=4 
     m221=5 
     m321=6 
     m131=7 
     m231=8 
     m331=9 
     m112=10
     m212=11
     m312=12
     m122=13
     m222=14
     m322=15 
     m132=16
     m232=17
     m332=18
     m113=19
     m213=20
     m313=21
     m123=22
     m223=23
     m323=24 
     m133=25
     m233=26
     m333=27

     if( sparseStencil.eq.sparse )then
       DEFECT(op3dSparse,3)
     else if( sparseStencil.eq.general )then
       ! *** full stencil *****
       DEFECT(op3d,3)
     else if( sparseStencil.eq.constantCoefficients )then
       DEFECT(op3dCC,3)
     else if( sparseStencil.eq.sparseConstantCoefficients )then
       DEFECT(op3dSparseCC,3)
     else if( sparseStencil.eq.sparseVariableCoefficients )then
       DEFECT3dVC(op3dSparseVC,3)
     else if( sparseStencil.eq.variableCoefficients )then
       ! use sparse version for now:
       DEFECT3dVC(op3dSparseVC,3)
     else
       write(*,*) 'defectOpt:ERROR: invalid sparseStencil'
       stop 1
     end if

    #Elif #ORDER == "4" 
     ! ****** 4th order accurate ****
     
     m111=1 
     m211=2 
     m311=3 
     m411=4 
     m511=5 
     m121=6 
     m221=7 
     m321=8 
     m421=9 
     m521=10
     m131=11
     m231=12
     m331=13
     m431=14
     m531=15
     m141=16
     m241=17
     m341=18
     m441=19
     m541=20
     m151=21
     m251=22
     m351=23
     m451=24
     m551=25

     m112=26
     m212=27
     m312=28
     m412=29
     m512=30
     m122=31 
     m222=32
     m322=33
     m422=34
     m522=35
     m132=36
     m232=37
     m332=38
     m432=39
     m532=40
     m142=41
     m242=42
     m342=43
     m442=44
     m542=45
     m152=46
     m252=47
     m352=48
     m452=49
     m552=50

     m113=51 
     m213=52 
     m313=53 
     m413=54 
     m513=55 
     m123=56 
     m223=57 
     m323=58 
     m423=59 
     m523=60
     m133=61
     m233=62
     m333=63
     m433=64
     m533=65
     m143=66
     m243=67
     m343=68
     m443=69
     m543=70
     m153=71
     m253=72
     m353=73
     m453=74
     m553=75

     m114=76
     m214=77
     m314=78
     m414=79
     m514=80
     m124=81 
     m224=82
     m324=83
     m424=84
     m524=85
     m134=86
     m234=87
     m334=88
     m434=89
     m534=90
     m144=91
     m244=92
     m344=93
     m444=94
     m544=95
     m154=96
     m254=97
     m354=98
     m454=99
     m554=100

     m115=101 
     m215=102 
     m315=103 
     m415=104 
     m515=105 
     m125=106 
     m225=107 
     m325=108 
     m425=109 
     m525=110
     m135=111
     m235=112
     m335=113
     m435=114
     m535=115
     m145=116
     m245=117
     m345=118
     m445=119
     m545=120
     m155=121
     m255=122
     m355=123
     m455=124
     m555=125

     if( sparseStencil.eq.sparse )then
       DEFECT(op3dSparse4,3)
     else if( sparseStencil.eq.general )then
      !   **** full stencil *****
       DEFECT(op3d4,3)
     else if( sparseStencil.eq.constantCoefficients )then
       DEFECT(op3dCC4,3)
     else if( sparseStencil.eq.sparseConstantCoefficients )then
       DEFECT(op3dSparseCC4,3)
     else
       write(*,*) 'defectOpt:ERROR: invalid sparseStencil'
       stop 1
     end if


   #Else 
     write(*,*) 'defectOpt:ERROR unknown order=',order
     stop 1
   #End 

 #End 

 rpar(3)=0.
 rpar(4)=0.
 if( defectOption.eq.1 )then
   rpar(3)=sqrt( defectSquared/max(count,1))
   ! write(*,'("defectOpt: count=",i6," l2-norm=",e13.3)') count,rpar(3)
 else if( defectOption.eq.2 )then
   rpar(4)=defectMax
   ! write(*,'("defectOpt: max-norm=",e13.3)') rpar(4)
 else if( defectOption.eq.3 )then
   rpar(3)=sqrt( defectSquared/max(count,1))
   rpar(4)=defectMax
   ! write(*,'("defectOpt: max-norm=",e13.3," count=",i6," l2-norm=",e13.3)') rpar(4),count,rpar(3)
 else
   ! write(*,'("defectOpt: defectOption=",3i)') defectOption
 end if
 return
 end

#endMacro




#beginMacro buildFile(NAME,DIM,ORDER)
#beginFile NAME.f
 DEFECT_SUBROUTINE(NAME,DIM,ORDER)
#endFile
#endMacro

      buildFile(defect2dOrder2,2,2)
      buildFile(defect2dOrder4,2,4)
      buildFile(defect3dOrder2,3,2)
      buildFile(defect3dOrder4,3,4)



      subroutine defectOpt( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,
     &    mask, cc, s, ipar, rpar )
c ===================================================================================
c  Optimised defect
c
c defectOption: ipar(0)
c               =0 : compute defect only
c               =1 : compute defect and l2-norm: sqrt{ sum( defect**2 )/sum( 1 ) }, returned as rpar(3)
c               =2 : compute defect and max norm, returned as rpar(4)
c               =3 : compute defect and both l2-norm and max-norm, l2-norm=rpar(3), max-norm=rpar(4)  
c
c lineSmoothOption=ipar(1)
c lineSmoothOption: -1 : general
c                    0 : line smooth, direction 1
c                    1 : line smooth, direction 2
c                    2 : line smooth, direction 3
c                    3 : red-points
c                    4 : black-points
c
c
c  cc(m) : constant coefficients
c  sparseStencil : general=0, sparse=1, constantCoefficients=2, sparseConstantCoefficients=3
c ===================================================================================

      implicit none
      integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &        n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc,
     &        ipar(0:*)
      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)

      real defect(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real c(1:ndc,nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real cc(1:*),rpar(0:*)
      real s(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)

c......local variables
      integer lineSmoothOption,order,sparseStencil,defectOption
      real dx(3)
      integer i1,i2,i3,n,count
      real defectSquared,defectMax

      integer m11,m12,m13,m14,m15,
     &        m21,m22,m23,m24,m25,
     &        m31,m32,m33,m34,m35,
     &        m41,m42,m43,m44,m45,
     &        m51,m52,m53,m54,m55
      integer    m111,m211,m311,m411,m511,
     &           m121,m221,m321,m421,m521,
     &           m131,m231,m331,m431,m531,
     &           m141,m241,m341,m441,m541,
     &           m151,m251,m351,m451,m551,
     &           m112,m212,m312,m412,m512,
     &           m122,m222,m322,m422,m522,
     &           m132,m232,m332,m432,m532,
     &           m142,m242,m342,m442,m542,
     &           m152,m252,m352,m452,m552,
     &           m113,m213,m313,m413,m513,
     &           m123,m223,m323,m423,m523,
     &           m133,m233,m333,m433,m533,
     &           m143,m243,m343,m443,m543,
     &           m153,m253,m353,m453,m553,
     &           m114,m214,m314,m414,m514,
     &           m124,m224,m324,m424,m524,
     &           m134,m234,m334,m434,m534,
     &           m144,m244,m344,m444,m544,
     &           m154,m254,m354,m454,m554,
     &           m115,m215,m315,m415,m515,
     &           m125,m225,m325,m425,m525,
     &           m135,m235,m335,m435,m535,
     &           m145,m245,m345,m445,m545,
     &           m155,m255,m355,m455,m555

      integer    m11n,m21n,m31n,m41n,m51n,
     &           m12n,m22n,m32n,m42n,m52n,
     &           m13n,m23n,m33n,m43n,m53n,
     &           m14n,m24n,m34n,m44n,m54n,
     &           m15n,m25n,m35n,m45n,m55n

      real a1m,a1p,a2m,a2p,a3m,a3p,ad
      real dx2i,dy2i,dz2i

      integer general, sparse, constantCoefficients, 
     &   sparseConstantCoefficients,variableCoefficients,
     &   sparseVariableCoefficients
      parameter( general=0, sparse=1, constantCoefficients=2,
     &           sparseConstantCoefficients=3,
     &           variableCoefficients=4,
     &           sparseVariableCoefficients=5 )



      defectOption    =ipar(0)
      lineSmoothOption=ipar(1)
      order           =ipar(2)
      sparseStencil   =ipar(3)

      if( order.ne.2 .and. order.ne.4 )then
        write(*,*) 'defectOpt:ERROR: invalid order=',order
        stop 1
      end if

      if( nd.eq.2 )then
        ! **************************
        ! ***** Two Dimensions *****
        ! **************************

        if( order.eq.2 )then
          ! ****** 2nd order accurate ****

         call defect2dOrder2( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,
     &    mask, cc, s, ipar, rpar )

        else if( order.eq.4 ) then
          ! ****** 4th order accurate ****
          
         call defect2dOrder4( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,
     &    mask, cc, s, ipar, rpar )

        else
          write(*,*) 'defectOpt:ERROR unknown order=',order
          stop 1
        end if

      else 
c       ****************       
c       ***** 3D *******       
c       ****************       
        if( order.eq.2 )then
          ! ****** 2nd order accurate ****

         call defect3dOrder2( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,
     &    mask, cc, s, ipar, rpar )

        else if( order.eq.4 ) then
          ! ****** 4th order accurate ****
          
         call defect3dOrder4( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c, ndc, defect, f, c, u,
     &    mask, cc, s, ipar, rpar )

        else
          write(*,*) 'defectOpt:ERROR unknown order=',order
          stop 1
        end if

      end if
      return
      end

