// This file automatically generated from lineSmooth.bC with bpp.
#include "Ogmg.h"
#include "TridiagonalSolver.h"

static int numberOfLinesSolves=0;

#define lineSmoothBuild EXTERN_C_NAME(linesmoothbuild)
#define lineSmoothRHS EXTERN_C_NAME(linesmoothrhs)
#define lineSmoothUpdate EXTERN_C_NAME(linesmoothupdate)
extern "C"
{
  void lineSmoothBuild(const int&nd,
                                            const int&nd1a,const int&nd1b,const int&nd2a,const int&nd2b,const int&nd3a,const int&nd3b,
                                const int&nda1a,const int&nda1b,const int&nda2a,const int&nda2b,const int&nda3a,const int&nda3b,
            		const int&ndc, const real&coeff, const real&cc, 
                                real&a, real&b, real&c, real&d, real&e, const real&s, const real&u, const real&f, const int&mask, 
                                  const real&rsxy, const int&ipar, const real&rpar, const int&ndbcd, const real&bcData );

void lineSmoothRHS( const int&nd,
                		    const int&nd1a,const int&nd1b,
                		    const int&nd2a,const int&nd2b,
                		    const int&nd3a,const int&nd3b,
                		    const int&ndc, const real&coeff, const real&cc,  
                		    real&r, const real&s, const real&u, const real&f, 
                		    const int&mask, const real&rsxy, const int&ipar, 
                		    const real&rpar, const int&ndbcd, const real&bcData );

void lineSmoothUpdate( const int&nd,
                                              const int&nd1a,const int&nd1b,const int&nd2a,const int&nd2b,const int&nd3a,const int&nd3b,
                                              real&u, const real&defect, const int&mask, const int&ndc, const real&c, 
                                              const int&ipar, const real&rpar );
}



#undef M123
#define M123(m1,m2,m3) (m1+halfWidth1+width1*(m2+halfWidth2+width2*(m3+halfWidth3)))
// define C(m1,m2,m3,I1,I2,I3) c(I1,I2,I3,M123(m1,m2,m3))
// undef C
// define C(m1,m2,m3,I1,I2,I3) coeff(M123(m1,m2,m3),I1,I2,I3)

#define FOR_3(i1,i2,i3,I1,I2,I3) I1Bound=I1.getBound();  I2Bound=I2.getBound(); I3Bound=I3.getBound(); for(i3=I3.getBase(); i3<=I3Bound; i3++) for(i2=I2.getBase(); i2<=I2Bound; i2++) for(i1=I1.getBase(); i1<=I1Bound; i1++)

#define FOR_3S(i1,i2,i3,I1,I2,I3) I1Bound=I1.getBound();  I2Bound=I2.getBound(); I3Bound=I3.getBound(); I1Stride=I1.getStride();  I2Stride=I2.getStride(); I3Stride=I3.getStride(); for(i3=I3.getBase(); i3<=I3Bound; i3+=I3Stride) for(i2=I2.getBase(); i2<=I2Bound; i2+=I2Stride) for(i1=I1.getBase(); i1<=I1Bound; i1+=I1Stride)


// This next macro assign the RHS for the 4th order Neumann+extrapolation condition
// on curvilinear grids. The Neumann BC looks like
//         c1*ur + c2*us + c3*u = f
// The tridiagonal matrix includes all terms on a line normal to the boundary
// The RHS has to include the tangential terms on the boundary (except the diagonal)
//
//  DIR = R, S or T
//  DIM = 2 or 3



//\begin{>>OgmgInclude.tex}{\subsection{smoothLine}}
void Ogmg::
smoothLine(const int & level, const int & grid, 
                      const int & direction, 
                      bool useZebra /* =true */,
                      const int smoothBoundarySide /* = -1 */ )
//---------------------------------------------------------------------------------------------
// /Description:
//    Line Smoother. Zebra line smoothing.
//    
// /direction (input) : smooth on lines in this direction, 0,1,2
// /useZebra (input) : if true use alternating line zebra smoothing.
//\end{OgmgInclude.tex} 
//---------------------------------------------------------------------------------------------
{
    assert( direction>-1 && direction<3 );

    const int m11= 0,m12= 5,m13=10,m14=15,m15=20,
                        m21= 1,m22= 6,m23=11,m24=16,m25=21,
                        m31= 2,m32= 7,m33=12,m34=17,m35=22,
                        m41= 3,m42= 8,m43=13,m44=18,m45=23,
                        m51= 4,m52= 9,m53=14,m54=19,m55=24;
    const int m111=   0,m211=   1,m311=   2,m411=   3,m511=   4,
                        m121=   5,m221=   6,m321=   7,m421=   8,m521=   9,
                        m131=  10,m231=  11,m331=  12,m431=  13,m531=  14,
                        m141=  15,m241=  16,m341=  17,m441=  18,m541=  19,
                        m151=  20,m251=  21,m351=  22,m451=  23,m551=  24,
                        m112=  25,m212=  26,m312=  27,m412=  28,m512=  29,
                        m122=  30,m222=  31,m322=  32,m422=  33,m522=  34,
                        m132=  35,m232=  36,m332=  37,m432=  38,m532=  39,
                        m142=  40,m242=  41,m342=  42,m442=  43,m542=  44,
                        m152=  45,m252=  46,m352=  47,m452=  48,m552=  49,
                        m113=  50,m213=  51,m313=  52,m413=  53,m513=  54,
                        m123=  55,m223=  56,m323=  57,m423=  58,m523=  59,
                        m133=  60,m233=  61,m333=  62,m433=  63,m533=  64,
                        m143=  65,m243=  66,m343=  67,m443=  68,m543=  69,
                        m153=  70,m253=  71,m353=  72,m453=  73,m553=  74,
                        m114=  75,m214=  76,m314=  77,m414=  78,m514=  79,
                        m124=  80,m224=  81,m324=  82,m424=  83,m524=  84,
                        m134=  85,m234=  86,m334=  87,m434=  88,m534=  89,
                        m144=  90,m244=  91,m344=  92,m444=  93,m544=  94,
                        m154=  95,m254=  96,m354=  97,m454=  98,m554=  99,
                        m115= 100,m215= 101,m315= 102,m415= 103,m515= 104,
                        m125= 105,m225= 106,m325= 107,m425= 108,m525= 109,
                        m135= 110,m235= 111,m335= 112,m435= 113,m535= 114,
                        m145= 115,m245= 116,m345= 117,m445= 118,m545= 119,
                        m155= 120,m255= 121,m355= 122,m455= 123,m555= 124;



    realArray & u = uMG.multigridLevel[level][grid];
    realArray & f = fMG.multigridLevel[level][grid];
    realMappedGridFunction & uu= uMG.multigridLevel[level][grid];
    realMappedGridFunction & ff= fMG.multigridLevel[level][grid];
    realMappedGridFunction & coeff =  level==0 ? cMG[grid] : cMG.multigridLevel[level][grid];
    MappedGrid & mg = mgcg.multigridLevel[level][grid];  
    const intArray & mask = mg.mask();
    const int numberOfDimensions = mg.numberOfDimensions();
    
    const int * maskp = mask.Array_Descriptor.Array_View_Pointer2;
    const int maskDim0=mask.getRawDataSize(0);
    const int maskDim1=mask.getRawDataSize(1);
#undef MASK
#define MASK(i0,i1,i2) maskp[i0+maskDim0*(i1+maskDim1*(i2))]

    realArray & defect = defectMG.multigridLevel[level][grid];

    real *defectp = defect.Array_Descriptor.Array_View_Pointer2;
    const int defectDim0=defect.getRawDataSize(0);
    const int defectDim1=defect.getRawDataSize(1);
#undef DEFECT
#define DEFECT(i0,i1,i2) defectp[i0+defectDim0*(i1+defectDim1*(i2))]
    real *up = u.Array_Descriptor.Array_View_Pointer2;
    const int uDim0=u.getRawDataSize(0);
    const int uDim1=u.getRawDataSize(1);
#undef U
#define U(i0,i1,i2) up[i0+uDim0*(i1+uDim1*(i2))]
    real *fp = f.Array_Descriptor.Array_View_Pointer2;
    const int fDim0=f.getRawDataSize(0);
    const int fDim1=f.getRawDataSize(1);
#undef F
#define F(i0,i1,i2) fp[i0+fDim0*(i1+fDim1*(i2))]
    real *coeffp = coeff.Array_Descriptor.Array_View_Pointer3;
    const int coeffDim0=coeff.getRawDataSize(0);
    const int coeffDim1=coeff.getRawDataSize(1);
    const int coeffDim2=coeff.getRawDataSize(2);
#undef COEFF
#define COEFF(i0,i1,i2,i3) coeffp[i0+coeffDim0*(i1+coeffDim1*(i2+coeffDim2*(i3)))]

    const int numberOfInterpolationPoints = mgcg.multigridLevel[level].numberOfInterpolationPoints(grid);
    const intArray & ip = numberOfInterpolationPoints>0 ? mgcg.multigridLevel[level].interpolationPoint[grid] : maskp; 
    const int * ipp = ip.Array_Descriptor.Array_View_Pointer2;
    const int ipDim0=ip.getRawDataSize(0);
#define IP(i0,i1) ipp[i0+ipDim0*(i1)]

    int I1Bound, I2Bound, I3Bound;
    int I1Stride, I2Stride, I3Stride;
    Index Iv[3], &I1=Iv[0], &I2=Iv[1], &I3=Iv[2];
    Index Dv[3], &D1=Dv[0], &D2=Dv[1], &D3=Dv[2];
    getIndex(mg.extendedIndexRange(),I1,I2,I3);  // include boundary  -- holds boundary conditions
                                                                              
    D1=I1; D2=I2; D3=I3;  // points where we should evaluate the defect ** could do better **

    const int width = orderOfAccuracy+1;  // 3 or 5

   // The tridiagonal (pentadiagonal) system will have a BC of normal, extended or periodic along axis==direction
    bool extendedSystem=false; // true if we have neumann or mixed BC's on an end

    int side,axis;
    for( axis=0; axis<mg.numberOfDimensions(); axis++ )
    {
        if( axis==direction )
        {
      // include ghost line for neumann or mixed BC'S                     
            if( boundaryCondition(Start,direction,grid)>0 && 
        	  (boundaryCondition(Start,direction,grid)!=OgmgParameters::extrapolate || orderOfAccuracy==4) )
            {
//	extendedSystem=extendedSystem || orderOfAccuracy==2 || parameters.fourthOrderBoundaryConditionOption==0;
      	extendedSystem=extendedSystem || orderOfAccuracy==2 || orderOfAccuracy==4;
        // we need 1 ghost line for dirichlet (4th-order) or 2 ghost lines for Neumann fourth-order
                int numGhost= boundaryCondition(Start,direction,grid)!=OgmgParameters::extrapolate ? orderOfAccuracy/2 : 1;
      	Iv[direction]=Range(Iv[direction].getBase()-numGhost,Iv[direction].getBound());
            }
            if( boundaryCondition(End,direction,grid)>0 && 
        	  (boundaryCondition(End,direction,grid)!=OgmgParameters::extrapolate || orderOfAccuracy==4) )
            {
//	extendedSystem=extendedSystem || orderOfAccuracy==2 || parameters.fourthOrderBoundaryConditionOption==0;
      	extendedSystem=extendedSystem || orderOfAccuracy==2 || orderOfAccuracy==4;
        // we need 1 ghost line for dirichlet (4th-order) or 2 ghost lines for Neumann fourth-order
                int numGhost= boundaryCondition(End,direction,grid)!=OgmgParameters::extrapolate ? orderOfAccuracy/2 : 1;
      	Iv[direction]=Range(Iv[direction].getBase(),Iv[direction].getBound()+numGhost);
            }
        }
        else if( true )
        {
      // This axis is not in the direction of the line solve.
      // we only need to solve the equations on the boundary if there is a neumann/mixed BC
            if( mg.boundaryCondition(0,axis)>=0 && boundaryCondition(0,axis,grid)!=OgmgParameters::equation )
            {
                Iv[axis]=Range(Iv[axis].getBase()+1,Iv[axis].getBound());
            }
            if( mg.boundaryCondition(1,axis)>=0 && boundaryCondition(1,axis,grid)!=OgmgParameters::equation )
            {
                Iv[axis]=Range(Iv[axis].getBase(),Iv[axis].getBound()-1);
            }
        }
    }


    if( Ogmg::debug & 64 )
        f.display(sPrintF(buff,"smoothLine, direction=%i: Here is f",direction));

    const bool rectangular=(*coeff.getOperators()).isRectangular() &&
        ( level < mgcg.numberOfMultigridLevels()-numberOfExtraLevels ); 
    StencilTypeEnum sparseStencil=general;
    const bool isRectangular=mg.isRectangular();
    if( isRectangular )
    {
        if( equationToSolve!=OgesParameters::userDefined ) 
            sparseStencil=level==0 ? sparseConstantCoefficients : constantCoeff;
        else if( rectangular && assumeSparseStencilForRectangularGrids )
            sparseStencil=sparse;
    }
    const int gridType = isRectangular ? 0 : 1;

    real jacobiWork;  // = number of mults+divides for a jacobi iteration
    if(level==0 && (sparseStencil==constantCoeff || sparseStencil==sparseConstantCoefficients) ) 
    {
        jacobiWork=orderOfAccuracy==2 ? ( mg.numberOfDimensions()==2 ? 6. : 8.) :  // sparse 5-point or 7-point stencil
            ( mg.numberOfDimensions()==2 ? 10. : 14.); // 4th-order 9-pt or 13
    }
    else
    {
        jacobiWork=orderOfAccuracy==2 ? ( mg.numberOfDimensions()==2 ? 10. : 28.) : // 9-pt or 27-pt
            ( mg.numberOfDimensions()==2 ? 25. : 125.); // 4th-order: 25 or 125 pt stencil
    }
    

    real dx[3]={1.,1.,1.};
    if( sparseStencil==constantCoeff || sparseStencil==sparseConstantCoefficients )
        mg.getDeltaX( dx );

    bool useEquationOnGhostForDirichlet= orderOfAccuracy==2 ? 0 : useEquationOnGhostLineForDirichletBC(mg,level);
    bool useEquationOnGhostForNeumann= orderOfAccuracy==2 ? 0 : useEquationOnGhostLineForNeumannBC(mg,level);

    

  // we may apply the eqn as a BC on dirichlet boundaries.  
    const int bcOptionD = (useEquationOnGhostForDirichlet ? 1 : 
                   			 (level>0 && parameters.useSymmetryForDirichletOnLowerLevels) ? 2 : 0);  

    int bcOptionN;
    if( level==0 && parameters.neumannSecondGhostLineBC==OgmgParameters::useEquationToSecondOrder )
        bcOptionN=1; // use "eqn" BC for second ghost line
    else if( level>0 && parameters.lowerLevelNeumannSecondGhostLineBC==OgmgParameters::useEquationToSecondOrder )
        bcOptionN=3; // Use mixed BC to second order on both lines
    else if( level>0 && parameters.useSymmetryForNeumannOnLowerLevels )
        bcOptionN=2;  // even symmetry
    else
        bcOptionN=0;  // extrapolate 2nd ghost
            
      // This next variable is only used for fourth-order
    const int orderOfExtrapD= bcOptionD==1 ? 4 : parameters.orderOfExtrapolationForDirichletOnLowerLevels;
    const int orderOfExtrapN= 4;  // ********** 

    int ipar[] ={ mg.numberOfDimensions(),
            		direction,
            		(int)sparseStencil,
            		orderOfAccuracy,
            		I1.getBase(),I1.getBound(),1,
            		I2.getBase(),I2.getBound(),1,
            		I3.getBase(),I3.getBound(),1,
            		boundaryCondition(0,0,grid),
            		boundaryCondition(1,0,grid),         
            		boundaryCondition(0,1,grid),         
            		boundaryCondition(1,1,grid),         
            		boundaryCondition(0,2,grid),         
            		boundaryCondition(1,2,grid),
            		bcOptionD,
            		bcOptionN,
            		orderOfExtrapD,
            		orderOfExtrapN,
            		gridType,
            		I1.getBase(),I1.getBound(),
            		I2.getBase(),I2.getBound(),
            		I3.getBase(),I3.getBound(),
                                grid,
                                level }; //         

    real *uptr=u.getDataPointer();
    real *sptr= uptr;  // not used for now
    real *prsxy= isRectangular ? uptr : mg.inverseVertexDerivative().getDataPointer();
            
    real rpar[] = { dx[0],dx[1],dx[2],mg.gridSpacing(0),mg.gridSpacing(1),mg.gridSpacing(2) }; //



    real time0;
    if( !lineSmoothIsInitialized(direction,grid,level) )
    {
        time0=getCPU();
        
        lineSmoothIsInitialized(direction,grid,level)=TRUE;
        realArray a(I1,I2,I3),b(I1,I2,I3),c(I1,I2,I3),d,e;

        if( orderOfAccuracy==4 )
        {
            d.redim(I1,I2,I3);
            e.redim(I1,I2,I3);
        }
        
        bool useOpt= true; // false; 

            
    //      const int bcOption = level==0 && parameters.fourthOrderBoundaryConditionOption==1;


        if( useOpt )
        {

            lineSmoothBuild( numberOfDimensions,
                                              u.getBase(0),u.getBound(0),u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2),
                   		       a.getBase(0),a.getBound(0),a.getBase(1),a.getBound(1),a.getBase(2),a.getBound(2),
                   		       coeff.getLength(0), *coeff.getDataPointer(), 
                   		       constantCoefficients(0,grid,level), 
                                              *a.getDataPointer(), *b.getDataPointer(), *c.getDataPointer(), 
                                              *d.getDataPointer(), *e.getDataPointer(), 
                   		       *sptr, *uptr, *f.getDataPointer(), 
                   		       *mask.getDataPointer(), *prsxy, ipar[0], rpar[0], 
                   		       boundaryConditionData.getLength(0), boundaryConditionData(0,0,0,grid) );
        }
        else
        {

            real *ap = a.Array_Descriptor.Array_View_Pointer2;
            const int aDim0=a.getRawDataSize(0);
            const int aDim1=a.getRawDataSize(1);
#define A(i0,i1,i2) ap[i0+aDim0*(i1+aDim1*(i2))]
            real *bp = b.Array_Descriptor.Array_View_Pointer2;
            const int bDim0=b.getRawDataSize(0);
            const int bDim1=b.getRawDataSize(1);
#define B(i0,i1,i2) bp[i0+bDim0*(i1+bDim1*(i2))]
            real *cp = c.Array_Descriptor.Array_View_Pointer2;
            const int cDim0=c.getRawDataSize(0);
            const int cDim1=c.getRawDataSize(1);
#define C(i0,i1,i2) cp[i0+cDim0*(i1+cDim1*(i2))]


            assert( orderOfAccuracy==2 );
#define CC(m) constantCoefficients(m,grid,level)

            int md; // diagonal term
            if( mg.numberOfDimensions()==2 )
      	md=(width*width)/2; // 4 or 12 ;
            else if( mg.numberOfDimensions()==3 )
      	md=(width*width*width)/2; // 13 or 62;
            else
      	md=width/2; // 1;


    // form the tridiagonal matrices 
            int iv[3], &i1=iv[0], &i2=iv[1], &i3=iv[2];
            int mdm1,mdp1;
            if( direction==axis1 )
            {
      	mdm1=md-1;
      	mdp1=md+1;
            }
            else if( direction==axis2 )
            {
      	mdm1=md-width;
      	mdp1=md+width;
            }
            else if( direction==axis3 )
            {
      	mdm1=md-width*width;
      	mdp1=md+width*width;
            }
            else
            {
      	cout << "lineSmooth:ERROR: invalid direction! \n";
            }

            const int iva=mg.extendedIndexRange()(Start,direction)-1;
            const int ivb=mg.extendedIndexRange()(End  ,direction)+1;
            if( sparseStencil==constantCoeff || sparseStencil==sparseConstantCoefficients )
            {
	// constant coefficients
      	FOR_3(i1,i2,i3,I1,I2,I3)
      	{
        	  if( MASK(i1,i2,i3) > 0 )   
        	  {
          	    A(i1,i2,i3)=CC(mdm1);
          	    B(i1,i2,i3)=CC(md);
          	    C(i1,i2,i3)=CC(mdp1);
        	  }
        	  else 
        	  {
          	    A(i1,i2,i3)=0.;
          	    B(i1,i2,i3)=1.;
          	    C(i1,i2,i3)=0.;
        	  }
      	}
	// Boundary Conditions
      	real dx[3],xab[2][3];
      	mg.getRectangularGridParameters( dx, xab );
    
      	const real dxi = 1./dx[direction];
            
      	Index Jv[3], &J1=Jv[0], &J2=Jv[1], &J3=Jv[2];
      	axis=direction; // for( int axis=0; axis<mg.numberOfDimensions(); axis++ )
      	{
        	  for( int side=0; side<=1; side++ )
        	  {
          	    if( boundaryCondition(side,axis,grid)>0 )
          	    {
            	      if( boundaryCondition(side,axis,grid)==OgmgParameters::extrapolate )
            	      {
		// Dirichlet BC

//  		getBoundaryIndex(mg.gridIndexRange(),side,axis,J1,J2,J3); // do not include ghost pts on adj sides.
//  		printf("************** side=%i axis=%i Fill in Dirichlet Equation J1=%i,%i J2=%i,%i J3=%i,%i\n",side,axis,
//  		          J1.getBase(),J1.getBound(),J2.getBase(),J2.getBound(),J3.getBase(),J3.getBound());
            		J1=I1; J2=I2; J3=I3;
            		Jv[axis]=side==0 ? Iv[axis].getBase() : Iv[axis].getBound();
            		FOR_3(i1,i2,i3,J1,J2,J3)
            		{
              		  A(i1,i2,i3)=0.;
              		  B(i1,i2,i3)=1.;
              		  C(i1,i2,i3)=0.;
		  // printf(" i1,i2,i3=%i,%i,%i b=%e \n",i1,i2,i3,B(i1,i2,i3));
            		}
            	      }
            	      else if( axis==direction )  // only apply Neumman BC if axis==direction
            	      {
		// apply a neumann or mixed BC on this side.
		//     b0*u + b1*u.n = f
            		real b0=boundaryConditionData(0,side,axis,grid);
            		real b1=boundaryConditionData(1,side,axis,grid);
		// printf("************** side=%i axis=%i b0=%e b1=%e dxi=%e \n",side,axis,b0,b1,dxi);
            	      
            		J1=I1; J2=I2; J3=I3;
            		Jv[axis]=side==0 ? Iv[axis].getBase() : Iv[axis].getBound();
            		if( side==0 )
            		{
              		  FOR_3(i1,i2,i3,J1,J2,J3)
              		  {
                		    B(i1,i2,i3)= b1*dxi*.5;
                		    C(i1,i2,i3)= b0;
                		    A(i1,i2,i3)=-b1*dxi*.5;
              		  }
            		}
            		else
            		{
              		  FOR_3(i1,i2,i3,J1,J2,J3)
              		  {
                		    C(i1,i2,i3)=-b1*dxi*.5;
                		    A(i1,i2,i3)= b0;
                		    B(i1,i2,i3)= b1*dxi*.5;
              		  }
            		}
            	      
            	      }
          	    }
        	  }
      	}
            
            }
            else
            {
      	FOR_3(i1,i2,i3,I1,I2,I3)
      	{
        	  if( MASK(i1,i2,i3) > 0 )  
        	  {
          	    A(i1,i2,i3)=COEFF(mdm1,i1,i2,i3);
          	    B(i1,i2,i3)=COEFF(md  ,i1,i2,i3);
          	    C(i1,i2,i3)=COEFF(mdp1,i1,i2,i3);

          	    if( iv[direction]==iva )
          	    { // Neumann or mixed BC on left edge
            	      B(i1,i2,i3)=COEFF(mdm1,i1,i2,i3);  // note: b
            	      C(i1,i2,i3)=COEFF(md  ,i1,i2,i3);
            	      A(i1,i2,i3)=COEFF(mdp1,i1,i2,i3);
          	    }
          	    else if( iv[direction]==ivb )
          	    { // Neumann or mixed BC on right edge
            	      C(i1,i2,i3)=COEFF(mdm1,i1,i2,i3);  // note: c
            	      A(i1,i2,i3)=COEFF(md  ,i1,i2,i3);
            	      B(i1,i2,i3)=COEFF(mdp1,i1,i2,i3);
          	    }
        	  }
        	  else 
        	  {
          	    A(i1,i2,i3)=0.;
          	    B(i1,i2,i3)=1.;
          	    C(i1,i2,i3)=0.;
        	  }
      	}
            }
            
        } // end else not opt
        
        
        if( Ogmg::debug & 8 )
        {
            fprintf(debugFile,"***** tridiagonal solver level=%i bcOptionN=%i *****\n",level,bcOptionN);
            
            display(a,sPrintF(buff,"Here is the tridiagonal matrix, a, grid=%i direction=%i",grid,direction),debugFile,"%6.1f ");
            display(b,sPrintF(buff,"Here is the tridiagonal matrix, b, grid=%i direction=%i",grid,direction),debugFile,"%6.1f ");
            display(c,sPrintF(buff,"Here is the tridiagonal matrix, c, grid=%i direction=%i",grid,direction),debugFile,"%6.1f ");
            if( orderOfAccuracy==4 )
            {
      	display(d,sPrintF(buff,"Here is the tridiagonal matrix, d, grid=%i direction=%i",grid,direction),debugFile,"%6.1f ");
      	display(e,sPrintF(buff,"Here is the tridiagonal matrix, e, grid=%i direction=%i",grid,direction),debugFile,"%6.1f ");
            }
        }
        
    // printf("Factor the tridiagonal matrix for direction=%i \n",direction);
        

    // *************************************************************
    // ************Factor the Matricies*****************************
    // *************************************************************

        TridiagonalSolver::SystemType
            systemType = (bool)mg.isPeriodic(direction) ? TridiagonalSolver::periodic :
                                                                      extendedSystem ? TridiagonalSolver::extended : 
                                                                                                        TridiagonalSolver::normal;
        
        if( Ogmg::debug & 4 ) printf(">>>>>>>>>>>>>>> TridiagonalSolver::systemType = %s\n",
                         				 systemType==TridiagonalSolver::periodic ? "periodic" : 
                                                                  systemType==TridiagonalSolver::extended ? "extended" : "normal");

        assert( tridiagonalSolver[level][grid][direction]==NULL );
        delete tridiagonalSolver[level][grid][direction];
        tridiagonalSolver[level][grid][direction] = new TridiagonalSolver;
        #ifndef USE_PPP
        if( orderOfAccuracy==2 )
        {
      // second order tridiagonal system
            tridiagonalSolver[level][grid][direction]->factor(a,b,c,systemType,direction); 
        }
        else
        {
      // fourth order : penta-diagonal system
            tridiagonalSolver[level][grid][direction]->factor(a,b,c,d,e,systemType,direction); 
        }
        #else
            Overture::abort("Ogmg::ERROR:finish me for parallel Bill!");
        #endif

        tm[timeForTridiagonalFactorInSmooth]+=getCPU()-time0;

        if( Ogmg::debug & 8 )
        {
            display(a,"AFTER FACTOR: Here is the tridiagonal matrix, a",debugFile,"%6.0f ");
            display(b,"AFTER FACTOR: Here is the tridiagonal matrix, b",debugFile,"%6.0f ");
            display(c,"AFTER FACTOR: Here is the tridiagonal matrix, c",debugFile,"%6.0f ");
            if( orderOfAccuracy==4 )
            {
            display(d,"AFTER FACTOR: Here is the tridiagonal matrix, d",debugFile,"%6.0f ");
            display(e,"AFTER FACTOR: Here is the tridiagonal matrix, e",debugFile,"%6.0f ");
            }
        }
    // LU factor, n-1 multiplies, n-1 divisions 
    //    ***** fourth-order : 8 mults+divides

        real wu = (orderOfAccuracy==2 ? 2. : 8. )/jacobiWork;
        workUnits(level)+=wu*mask.elementCount()/real(numberOfGridPoints);
    }

    if( Ogmg::debug & 8 )
    {
        display(u,sPrintF("lineSmooth: Here is the solution u at start, level=%i, grid=%i ",level,grid),
                                      debugFile,"%8.2e ");
        display(f,sPrintF("lineSmooth: Here is the rhs f at start, level=%i, grid=%i ",level,grid),debugFile,"%8.2e ");
    }

    enum LineOptionEnum
    {
        zebraLine=0,
        jacobiLine
    };
        
    int isv[3], &is1=isv[0], &is2=isv[1], &is3=isv[2];
    int stridev[3], &stride1=stridev[0], &stride2=stridev[1], &stride3=stridev[2];
    int shift[3]; shift[0]=0; shift[1]=0; shift[2]=0; 
    int j1,j2,j3;
    Range Izv[3], &I1z=Izv[0], &I2z=Izv[1], &I3z=Izv[2];
    Range Dzv[3], &D1z=Dzv[0], &D2z=Dzv[1], &D3z=Dzv[2];

//    printf(" ****************** zebra: parameters.numberOfSubSmooths(grid=%i,level=%i)=%i \n",
//  	 grid,level,parameters.numberOfSubSmooths(grid,level));
    
    const bool usingConstantCoefficients=sparseStencil==constantCoeff || sparseStencil==sparseConstantCoefficients;

    if( smoothBoundarySide==0 || smoothBoundarySide==1 )
    {
        assert( numberOfDimensions==2 );
        if( direction==0 )
        {
            I2= smoothBoundarySide==0 ? Range(I2.getBase()+1,I2.getBase()+1) : 
      	Range(I2.getBound()-1,I2.getBound()-1);
            D2=I2;
        }
        else
        {
            I1= smoothBoundarySide==0 ? Range(I1.getBase()+1,I1.getBase()+1) : 
      	Range(I1.getBound()-1,I1.getBound()-1);
            D1=I1;
        }
    }
    

    for( int iteration=0; iteration<parameters.numberOfSubSmooths(grid,level); iteration++ )
    {
        bool preSmooth=true; // numberOfLinesSolves%2 == 0; // true;
        if( preSmooth &&  parameters.numberOfBoundaryLayersToSmooth>0 )
        {
            
      // int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth + (numberOfLinesSolves%3)-1;
            int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth; 
      // int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth;

            int bc[6]={0,0,0,0,0,0}; //
            bc[0+2*direction]=1; // smooth boundaries axis==direction
            bc[1+2*direction]=1;
            if( parameters.smootherType(grid,level)==alternatingLineJacobi ||
                    parameters.smootherType(grid,level)==alternatingLineZebra )
            {
        // for alternating smoothers we smooth all boundaries
	//  bc[0]=bc[1]=bc[2]=bc[3]=bc[4]=bc[5]=1;
            }
            bc[0]=bc[1]=bc[2]=bc[3]=bc[4]=bc[5]=1;
            

            smoothBoundary(level,grid,bc,numberOfLayers,parameters.numberOfBoundarySmoothIterations );
        }



        if( useZebra )
        {
      // ******* Alternating Zebra Smoothing ******

            if( debug & 8 && level==0 ) printf("smooth zebra level=%i direction=%i\n",level,direction);
            

      // this extra shift is added so that we solve on the same order of red/black points as an older version
            const int delta1=mg.boundaryCondition(0,(direction+1)% mg.numberOfDimensions())<0 ? 0 : 1;
            const int delta2=mg.boundaryCondition(0,(direction+2)% mg.numberOfDimensions())<0 ? 0 : 1;
            
            real & omega=parameters.omegaLineZebra;
            real variableOmegaFactor=1.;
      // scale factor for the locally optimal omega
            if( orderOfAccuracy==2 )
      	variableOmegaFactor=2.*parameters.variableOmegaScaleFactor; // 1.01231; // 1.085/1.071796 ! NOTE
            else
      	variableOmegaFactor=parameters.variableOmegaScaleFactor;

            if( omega<0. )
            { // assign default values
      	omega=1.; // numberOfDimensions==2 ? 1.1 : 1.15;
      	if( numberOfDimensions==3 )
      	{
        	  if( orderOfAccuracy==2 )
        	  {
	    // ** line zebra acts like RB in the two other directions
	    // real cmax=1.-1./3.;
	    // omega=variableOmegaFactor/(1.+sqrt(1.-cmax*cmax));

          	    omega=1.09;  // "2D" value
        	  }
        	  else // fourth-order accurate
        	  {
          	    omega=1.15; //  ! what should this be ?
        	  }
      	}
            }
            real oneMinusOmega=1.-omega;
            const int variableCoefficients = !(sparseStencil==constantCoeff || sparseStencil==sparseConstantCoefficients);
      // useOmega= 0 : do not use omega
      //           1 : use constant omega
      //           2 : use variable omega 
            int useOmega=(!variableCoefficients || !parameters.useLocallyOptimalLineOmega) ? 1 : 2;
            if( fabs(omega-1.)<10.*REAL_EPSILON )
                useOmega=0;

            for( int zebra3=0; zebra3<mg.numberOfDimensions()-1; zebra3++)
      	for( int zebra2=0; zebra2<2; zebra2++)
      	{
	  // Here is the stride for zebra smoothing:
            	  stride1 = direction==axis1 ? 1 : 2;
            	  stride2 = direction==axis2 ? 1 : 2;
            	  stride3 = (mg.numberOfDimensions()==3 && direction!=axis3) ? 2 : 1;
//  	  stride1 = direction==axis1 ? 1 : 1;
//  	  stride2 = direction==axis2 ? 1 : 1;
//  	  stride3 = (mg.numberOfDimensions()==3 && direction!=axis3) ? 1 : 1;
            
	  // shift[0,1,2] = 0 or 1 : shift the stencil to get red or black points
        	  shift[direction]=0;
        	  shift[(direction+1)% mg.numberOfDimensions()]=(zebra2+zebra3+delta1) %2;  

                    if( false && direction==1 )
          	    shift[(direction+1)% mg.numberOfDimensions()]=(zebra2+zebra3+delta1+1) %2;  

        	  if( mg.numberOfDimensions()==3 )
          	    shift[(direction+2)% mg.numberOfDimensions()]=(zebra2+delta2)%2;

       	 
        	  I1z=IndexBB(I1.getBase()+shift[0],I1.getBound(),stride1);
        	  I2z=IndexBB(I2.getBase()+shift[1],I2.getBound(),stride2);
        	  I3z=IndexBB(I3.getBase()+shift[2],I3.getBound(),stride3);

        	  if( debug & 4 )
          	    fprintf(debugFile,"direction=%i zebra2=%i, zebra3=%i, I1z=(%i,%i,%i), I2z=(%i,%i,%i), I3z=(%i,%i,%i) \n",
                                        direction,zebra2,zebra3,
                		    I1z.getBase(),I1z.getBound(),I1z.getStride(),I2z.getBase(),I2z.getBound(),I2z.getStride(),
                		    I3z.getBase(),I3z.getBound(),I3z.getStride());
            
	  // determine the defect : defect(I1z,I2z,I3z) = f - c* u

        	  real time1=getCPU();

          // We only need to evaluate the defect on a restricted set of points
          //  (We must avoid evaluating the defect at some end points where it would not be a valid operation)
        	  
                    for( axis=0; axis<3; axis++ )
        	  {
          	    int base = Izv[axis].getBase(), bound=Izv[axis].getBound();
                        if( base  < Dv[axis].getBase()  ) base +=stridev[axis];
                        if( bound > Dv[axis].getBound() ) bound-=stridev[axis];
          	    Dzv[axis]=Range(base,bound,Izv[axis].getStride());
        	  }

//          printf(" D1z=[%i,%i] D2z=[%i,%i] D3z=[%i,%i]\n",D1z.getBase(),D1z.getBound(),D2z.getBase(),D2z.getBound(),
//    	     D3z.getBase(),D3z.getBound());
//          printf(" u : [%i,%i][%i,%i][%i,%i]\n",u.getBase(0),u.getBound(0),u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2));
//          printf(" f : [%i,%i][%i,%i][%i,%i]\n",f.getBase(0),f.getBound(0),f.getBase(1),f.getBound(1),f.getBase(2),f.getBound(2));
//          printf(" defect : [%i,%i][%i,%i][%i,%i]\n",defect.getBase(0),defect.getBound(0),defect.getBase(1),defect.getBound(1),defect.getBase(2),defect.getBound(2));

	  // *** getDefect(level,grid,f,u,I1z,I2z,I3z,defect,direction);
                    if( Ogmg::debug & 4 )
        	  {
          	    defect=0.;  // set to zero for debugging since getDefect only assigns the zebra lines
        	  }
        	  
        	  getDefect(level,grid,f,u,D1z,D2z,D3z,defect,direction);

        	  time0=getCPU();
        	  tm[timeForDefectInSmooth]+=time0-time1;

        // 	  lineSmoothBoundaryConditions(FOR_3S,Izv,I1z,I2z,I3z); 
        // Set values at interpolation points
                int i1,i2,i3;
                if( mg.numberOfDimensions()==2 )
                {
                    i3=I3z.getBase();
                    for( int i=0; i<numberOfInterpolationPoints; i++ )
                    {
                        i1=IP(i,0);
                        i2=IP(i,1);
                        DEFECT(i1,i2,i3)=U(i1,i2,i3); 
                    }
                }
                else
                {
                    for( int i=0; i<numberOfInterpolationPoints; i++ )
                    {
                        i1=IP(i,0);
                        i2=IP(i,1);
                        i3=IP(i,2);
                        DEFECT(i1,i2,i3)=U(i1,i2,i3); 
                    }
                }
        // For the constant coeff case we must fill in the BC's into the defect array
        // for fourth order we need to assign the rhs for extrapolation conditions
                if( (true || usingConstantCoefficients ) // **** we must always assign Neumann BC's -- could avoid dirichlet below
                        || orderOfAccuracy==4 )
                {
          // Boundary Conditions
                    Index Jv[3], &J1=Jv[0], &J2=Jv[1], &J3=Jv[2];
                    axis=direction;
                    for( int side=0; side<=1; side++ )
                    {
                        if( boundaryCondition(side,axis,grid)>0 )
                        {
                            is1=is2=is3=0;
                            isv[axis]=1-2*side;
                            if( boundaryCondition(side,axis,grid)==OgmgParameters::extrapolate )
                            {
        	 // Dirichlet BC
        	 // printf("Assign DirichletRHS for TRID side=%i axis=%i \n",side,axis);
         	    // J1=I1z; J2=I2z; J3=I3z;
         	    // Jv[axis]=side==0 ? Izv[axis].getBase() : Izv[axis].getBound();
         	    // do not include ghost pts on adj sides.
         	    // ** getBoundaryIndex(mg.gridIndexRange(),side,axis,J1,J2,J3);  // this fills in values even if not needed		
                       	 J1=I1z; J2=I2z; J3=I3z;
                       	 Jv[axis]=side==0 ? Izv[axis].getBase() : Izv[axis].getBound();
                       	 if( orderOfAccuracy==2 )
                       	 {
                         	   FOR_3S(i1,i2,i3,J1,J2,J3)
                         	   {
                           	     if( MASK(i1,i2,i3)>0 )
                           	     {
                             	       DEFECT(i1,i2,i3)=F(i1,i2,i3);
                           	     }
                           	     else
                           	     {
                             	       DEFECT(i1,i2,i3)=0.;
                           	     }
                         	   }
                       	 }
                       	 else
                       	 {
        	   // if( parameters.fourthOrderBoundaryConditionOption==0 || level>0 )
                         	   if( !useEquationOnGhostForDirichlet )
                         	   {
                           	     FOR_3S(i1,i2,i3,J1,J2,J3)
                           	     {
                             	       j1=i1+is1; j2=i2+is2; j3=i3+is3; // boundary point
                             	       if( MASK(j1,j2,j3)>0 )
                             	       {
                               	         DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               	         DEFECT(i1,i2,i3)=0.;           // extrapolation or symmetry 
                             	       }
                             	       else
                             	       {
                             		 DEFECT(i1,i2,i3)=0.;
                             	       }
                           	     }
                         	   }
                         	   else
                         	   {
                     // Use equation to 2nd order on the first ghost line 
                                          int ms2 = direction==0 ? 1 : direction==1 ? width : width*width;  // shift for 2nd-order stencil in a fourth order operator
                                          ms2*=1-2*side;
                           	     if( numberOfDimensions==2 )
                           	     {
                             	       if( axis==0 )
                             	       {
                             		 if( usingConstantCoefficients )
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1]);  // equation      
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             		 else
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                                   		       COEFF(m22+ms2,i1,i2,i3)*u(j1-1,j2-1,j3)+COEFF(m32+ms2,i1,i2,i3)*u(j1,j2-1,j3)+COEFF(m42+ms2,i1,i2,i3)*u(j1+1,j2-1,j3)+
        		    // COEFF(m23+ms2,i1,i2,i3)*u(j1-1,j2  ,j3)+COEFF(m33+ms2,i1,i2,i3)*u(j1,j2  ,j3)+COEFF(m43+ms2,i1,i2,i3)*u(j1+1,j2  ,j3)+
                                   		       COEFF(m24+ms2,i1,i2,i3)*u(j1-1,j2+1,j3)+COEFF(m34+ms2,i1,i2,i3)*u(j1,j2+1,j3)+COEFF(m44+ms2,i1,i2,i3)*u(j1+1,j2+1,j3) 
                                   			 );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             	       }
                             	       else
                             	       {
                             		 if( usingConstantCoefficients )
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0]);  // equation      
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             		 else
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                               		   COEFF(m22+ms2,i1,i2,i3)*u(j1-1,j2-1,j3)/* +COEFF(m32+ms2,i1,i2,i3)*u(j1,j2-1,j3) */+COEFF(m42+ms2,i1,i2,i3)*u(j1+1,j2-1,j3)+
                               		   COEFF(m23+ms2,i1,i2,i3)*u(j1-1,j2  ,j3)/* +COEFF(m33+ms2,i1,i2,i3)*u(j1,j2  ,j3) */+COEFF(m43+ms2,i1,i2,i3)*u(j1+1,j2  ,j3)+
                               		   COEFF(m24+ms2,i1,i2,i3)*u(j1-1,j2+1,j3)/* +COEFF(m34+ms2,i1,i2,i3)*u(j1,j2+1,j3) */+COEFF(m44+ms2,i1,i2,i3)*u(j1+1,j2+1,j3) 
                                   		       );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             	       }
                           	     }
                           	     else if( numberOfDimensions==3 )
                           	     {
                             	       if( axis==0 )
                             	       {
                             		 if( usingConstantCoefficients )
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1])
                                                           				  		     +(U(j1,j2,j3+1)+U(j1,j2,j3-1))/(dx[2]*dx[2]) );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             		 else
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                                          COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                          COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                          COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                          COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
        	//   COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                          COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                          COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                          COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                          COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                                   		       );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             	       }
                             	       else if( axis==1 )
                             	       {
                             		 if( usingConstantCoefficients )
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0])
                                                           					  	     +(U(j1,j2,j3+1)+U(j1,j2,j3-1))/(dx[2]*dx[2]) );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             		 else
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(
                                          COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                          COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                          COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                          COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+/*COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )*/+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
                           	     COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+/*COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )*/+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                          COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+/*COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )*/+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                          COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                          COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                          COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                                   		       );
                                   		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             	       }
                             	       else 
                             	       {
                             		 if( usingConstantCoefficients )
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0])
                                                         						     +(U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1]) );
                                 		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             		 else
                             		 {
                               		   FOR_3S(i1,i2,i3,J1,J2,J3)
                               		   {
                                 		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                          if( MASK(j1,j2,j3)>0 )
                                                          {
                                   		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                                   		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(
                                          COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                          COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+/*COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)*/+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                          COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                          COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
                           	     COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+/*COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )*/+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                          COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                          COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                          COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+/*COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)*/+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                          COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                                   		       );
                                   		     }
                                                          else
                                 		     {
                                   		       DEFECT(j1,j2,j3)=0.;
                                                              DEFECT(i1,i2,i3)=0.;
                                 		     }
                               		   }
                             		 }
                             	       }
                           	     }
                           	     else
                           	     {
                             	       Overture::abort();
                           	     }
                         	   }
                       	 }
                            }
                            else if( boundaryCondition(side,axis,grid)==OgmgParameters::equation )
                            {
        	 // *****************************************************
        	 // ************ neumann  or mixed **********************
        	 // *****************************************************
                       	 J1=I1z; J2=I2z; J3=I3z;
                       	 Jv[axis]=side==0 ? Izv[axis].getBase() : Izv[axis].getBound();
                       	 if( orderOfAccuracy==2 )
                       	 {
                         	   if( level==0 )
                         	   {
                           	     FOR_3S(i1,i2,i3,J1,J2,J3)
                           	     {
                             	       j1=i1+is1; j2=i2+is2; j3=i3+is3;
                             	       if( MASK(j1,j2,j3)>0 )
                             	       {
                             		 DEFECT(i1,i2,i3)=F(i1,i2,i3);   // neumann BC
                             	       }
                             	       else
                             	       {
                             		 DEFECT(i1,i2,i3)=0.;
                             	       }
                           	     }
                         	   }
                         	   else
                         	   {
                           	     FOR_3S(i1,i2,i3,J1,J2,J3)
                           	     {
                             	       DEFECT(i1,i2,i3)=0.;           // neumann BC
                           	     }
                         	   }
                       	 }
                       	 else // fourth-order
                       	 {
                   // **** fix this ****
                                      if( useEquationOnGhostForNeumann )
                         	   {
                     // *** these values are now filled in below 
                                          if( true )
                           	     {
                           	     }
                           	     else if( level==0 || level>0 )
                           	     {
                             	       if( usingConstantCoefficients )
                             	       {
        		 // Neumann and  u.xxx = f.x - g.yy
                         // i1,i2,i3 = 2nd ghost
                         // j1,j2,j3 = 1st ghost
                             		 FOR_3S(i1,i2,i3,J1,J2,J3)
                             		 {
                               		   j1=i1+is1; j2=i2+is2; j3=i3+is3;
                               		   fprintf(debugFile,"N4Lx: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
                               		   if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                               		   {
                                 		     DEFECT(j1,j2,j3)=F(j1,j2,j3);   // neumann BC
                                 		     DEFECT(i1,i2,i3)=0.;            // u.xxx=
                               		   }
                               		   else
                               		   {
                                 		     DEFECT(j1,j2,j3)=0.;
                                 		     DEFECT(i1,i2,i3)=0.;
                               		   }
                             		 }
                             	       }
                             	       else
                             	       {
                                	          Overture::abort("lineSolve: Error useEquationOnGhostForNeumann not implemented.");
                             	       }
                           	     }
                         	   }
                                      else
                                      {
        	     // extrapolation for 2nd ghost or symmetry
                           	     if( level==0 )
                           	     {
                             	       if( usingConstantCoefficients )
                             	       {
        		 // Neumann + extrapolation for rectangular grids.
                             		 FOR_3S(i1,i2,i3,J1,J2,J3)
                             		 {
                               		   j1=i1+is1; j2=i2+is2; j3=i3+is3;
        		   // fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
                               		   if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                               		   {
                                 		     DEFECT(j1,j2,j3)=F(j1,j2,j3);   // neumann BC
                                 		     DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                               		   }
                               		   else
                               		   {
                                 		     DEFECT(j1,j2,j3)=0.;
                                 		     DEFECT(i1,i2,i3)=0.;
                               		   }
                             		 }
                             	       }
                             	       else
                             	       {
                             		 if( numberOfDimensions==2 && direction==0 )
                             		 {
                       // 		   neumannExtrapCurvilinear(R,2,FOR_3S,Izv,I1z,I2z,I3z);
                                              FOR_3S(i1,i2,i3,J1,J2,J3)
                                              {
                                                  j1=i1+is1; j2=i2+is2; j3=i3+is3;
                       //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                       //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                       //             i1,i2,i3,j1,j2,j3,
                       //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                       //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                       //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                                  if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                                  {
                         //                          #If "2" == "2" && "R" == "R"
                           // neumann BC: nd=2 dir=0
                                                      DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                            COEFF(m31,j1,j2,j3)*u(j1+is1,j2-2,j3)
                                                          +COEFF(m32,j1,j2,j3)*u(j1+is1,j2-1,j3)
                                                          +COEFF(m34,j1,j2,j3)*u(j1+is1,j2+1,j3)
                                                          +COEFF(m35,j1,j2,j3)*u(j1+is1,j2+2,j3) );
                                                      DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                                  }
                                                  else
                                                  {
                                                      DEFECT(j1,j2,j3)=0.;
                                                      DEFECT(i1,i2,i3)=0.;
                                                  }
                                              }
                             		 }
                             		 else if(  numberOfDimensions==2 && direction==1 )
                             		 {
                       // 		   neumannExtrapCurvilinear(S,2,FOR_3S,Izv,I1z,I2z,I3z);
                                              FOR_3S(i1,i2,i3,J1,J2,J3)
                                              {
                                                  j1=i1+is1; j2=i2+is2; j3=i3+is3;
                       //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                       //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                       //             i1,i2,i3,j1,j2,j3,
                       //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                       //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                       //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                                  if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                                  {
                         //                          #If "2" == "2" && "S" == "R"
                         //                          #Elif "2" == "2" && "S" == "S"
                                                      DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                            COEFF(m13,j1,j2,j3)*u(j1-2,j2+is2,j3)
                                                          +COEFF(m23,j1,j2,j3)*u(j1-1,j2+is2,j3)
                                                          +COEFF(m43,j1,j2,j3)*u(j1+1,j2+is2,j3)
                                                          +COEFF(m53,j1,j2,j3)*u(j1+2,j2+is2,j3) );
                                                      DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                                  }
                                                  else
                                                  {
                                                      DEFECT(j1,j2,j3)=0.;
                                                      DEFECT(i1,i2,i3)=0.;
                                                  }
                                              }
                             		 }
                             		 else if(  numberOfDimensions==3 && direction==0 )
                             		 {
                       // 		   neumannExtrapCurvilinear(R,3,FOR_3S,Izv,I1z,I2z,I3z);
                                              FOR_3S(i1,i2,i3,J1,J2,J3)
                                              {
                                                  j1=i1+is1; j2=i2+is2; j3=i3+is3;
                       //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                       //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                       //             i1,i2,i3,j1,j2,j3,
                       //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                       //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                       //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                                  if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                                  {
                         //                          #If "3" == "2" && "R" == "R"
                         //                          #Elif "3" == "2" && "R" == "S"
                         //                          #Elif "3" == "3" && "R" == "R"
                           // neumann BC: nd=3 dir=0
                                                      DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                            COEFF(m313,j1,j2,j3)*u(j1+is1,j2-2,j3)
                                                          +COEFF(m323,j1,j2,j3)*u(j1+is1,j2-1,j3)
                                                          +COEFF(m343,j1,j2,j3)*u(j1+is1,j2+1,j3)
                                                          +COEFF(m353,j1,j2,j3)*u(j1+is1,j2+2,j3)
                                                          +COEFF(m331,j1,j2,j3)*u(j1+is1,j2  ,j3-2)
                                                          +COEFF(m332,j1,j2,j3)*u(j1+is1,j2  ,j3-1)
                                                          +COEFF(m334,j1,j2,j3)*u(j1+is1,j2  ,j3+1)
                                                          +COEFF(m335,j1,j2,j3)*u(j1+is1,j2  ,j3+2) );
                                                      DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                                  }
                                                  else
                                                  {
                                                      DEFECT(j1,j2,j3)=0.;
                                                      DEFECT(i1,i2,i3)=0.;
                                                  }
                                              }
                             		 }
                             		 else if(  numberOfDimensions==3 && direction==1 )
                             		 {
                       // 		   neumannExtrapCurvilinear(S,3,FOR_3S,Izv,I1z,I2z,I3z);
                                              FOR_3S(i1,i2,i3,J1,J2,J3)
                                              {
                                                  j1=i1+is1; j2=i2+is2; j3=i3+is3;
                       //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                       //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                       //             i1,i2,i3,j1,j2,j3,
                       //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                       //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                       //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                                  if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                                  {
                         //                          #If "3" == "2" && "S" == "R"
                         //                          #Elif "3" == "2" && "S" == "S"
                         //                          #Elif "3" == "3" && "S" == "R"
                         //                          #Elif "3" == "3" && "S" == "S"
                                                      DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                            COEFF(m133,j1,j2,j3)*u(j1-2,j2+is2,j3)
                                                          +COEFF(m233,j1,j2,j3)*u(j1-1,j2+is2,j3)
                                                          +COEFF(m433,j1,j2,j3)*u(j1+1,j2+is2,j3)
                                                          +COEFF(m533,j1,j2,j3)*u(j1+2,j2+is2,j3)
                                                          +COEFF(m331,j1,j2,j3)*u(j1  ,j2+is2,j3-2)
                                                          +COEFF(m332,j1,j2,j3)*u(j1  ,j2+is2,j3-1)
                                                          +COEFF(m334,j1,j2,j3)*u(j1  ,j2+is2,j3+1)
                                                          +COEFF(m335,j1,j2,j3)*u(j1  ,j2+is2,j3+2) );
                                                      DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                                  }
                                                  else
                                                  {
                                                      DEFECT(j1,j2,j3)=0.;
                                                      DEFECT(i1,i2,i3)=0.;
                                                  }
                                              }
                             		 }
                             		 else if(  numberOfDimensions==3 && direction==2 )
                             		 {
                       // 		   neumannExtrapCurvilinear(T,3,FOR_3S,Izv,I1z,I2z,I3z);
                                              FOR_3S(i1,i2,i3,J1,J2,J3)
                                              {
                                                  j1=i1+is1; j2=i2+is2; j3=i3+is3;
                       //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                       //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                       //             i1,i2,i3,j1,j2,j3,
                       //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                       //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                       //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                                  if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                                  {
                         //                          #If "3" == "2" && "T" == "R"
                         //                          #Elif "3" == "2" && "T" == "S"
                         //                          #Elif "3" == "3" && "T" == "R"
                         //                          #Elif "3" == "3" && "T" == "S"
                         //                          #Elif "3" == "3" && "T" == "T"
                                                      DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                            COEFF(m133,j1,j2,j3)*u(j1-2,j2  ,j3+is3)
                                                          +COEFF(m233,j1,j2,j3)*u(j1-1,j2  ,j3+is3)
                                                          +COEFF(m433,j1,j2,j3)*u(j1+1,j2  ,j3+is3)
                                                          +COEFF(m533,j1,j2,j3)*u(j1+2,j2  ,j3+is3)
                                                          +COEFF(m313,j1,j2,j3)*u(j1  ,j2-2,j3+is3)
                                                          +COEFF(m323,j1,j2,j3)*u(j1  ,j2-1,j3+is3)
                                                          +COEFF(m343,j1,j2,j3)*u(j1  ,j2+1,j3+is3)
                                                          +COEFF(m353,j1,j2,j3)*u(j1  ,j2+2,j3+is3) );
                                                      DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                                  }
                                                  else
                                                  {
                                                      DEFECT(j1,j2,j3)=0.;
                                                      DEFECT(i1,i2,i3)=0.;
                                                  }
                                              }
                             		 }
        //  	       FOR_3S(i1,i2,i3,J1,J2,J3)
        //  	       {
        //  		 j1=i1+is1; j2=i2+is2; j3=i3+is3;
        //  		 fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
        //                   // neumann BC: nd=2 dir=0
        //  		 DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
        //                                 COEFF(m31,i1,i2,i3)*u(j1+is1,j2-2,j3)
        //                                +COEFF(m32,i1,i2,i3)*u(j1+is1,j2-1,j3)
        //                                +COEFF(m34,i1,i2,i3)*u(j1+is1,j2+1,j3)
        //  			      +COEFF(m35,i1,i2,i3)*u(j1+is1,j2+1,j3) );
        //  		 DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
        //  	       }
                             	       }
                           	     }
                           	     else // level>0 
                           	     {
                             	       FOR_3S(i1,i2,i3,J1,J2,J3)
                             	       {
                             		 j1=i1+is1; j2=i2+is2; j3=i3+is3;
                             		 DEFECT(j1,j2,j3)=0.;           // neumann BC or symmetry or mixed BC
                             		 DEFECT(i1,i2,i3)=0.;           // second ghost line : extrap or symmetry or mixed BC
                             	       }
                           	     }
                         	   }
                       	 }
                            }
                            else
                            {
                      	printf(" ERROR: unknown bc = %i\n",boundaryCondition(side,axis,grid));
                                Overture::abort("ERROR");
                            }
                        }
                    }
                }
                if( useEquationOnGhostForNeumann &&  orderOfAccuracy==4 )
                {
          // new optimised BC's -- currently only for Neumann and equation BC
                    ipar[ 4]=I1z.getBase();
                    ipar[ 5]=I1z.getBound();
                    ipar[ 6]=I1z.getStride();
                    ipar[ 7]=I2z.getBase();
                    ipar[ 8]=I2z.getBound();
                    ipar[ 9]=I2z.getStride();
                    ipar[10]=I3z.getBase();
                    ipar[11]=I3z.getBound();
                    ipar[12]=I3z.getStride();
          // NOTE: do NOT use view pointers here
                    lineSmoothRHS( numberOfDimensions,
                                                  u.getBase(0),u.getBound(0),u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2),
                             		 coeff.getLength(0), *coeffp, 
                             		 constantCoefficients(0,grid,level),
                             		 *defect.getDataPointer(), 
                             		 *sptr, *uptr, *f.getDataPointer(), *mask.getDataPointer(), *prsxy, ipar[0], rpar[0], 
                             		 boundaryConditionData.getLength(0),boundaryConditionData(0,0,0,grid) );
                }

        	  tm[timeForRelaxInSmooth]+=getCPU()-time0;

//  	  if( false && level==0 )
//  	  { // define the defect for Neumann or mixed BC's on level 0 at ghost points
//  	    //     -- these may be inhomogeneous
//  	    // **** this assumes BC is normal direction only ******

//              // ???? check this ???????????

//  	    int iv[3]; 
//  	    iv[0]=I1z.getBase(); iv[1]=I2z.getBase(); iv[2]=I3z.getBase();
//  	    if( iv[direction]==mg.gridIndexRange()(Start,direction)-1 && mg.boundaryCondition(Start,direction)>0 )
//  	      DEFECT(iv[0],iv[1],iv[2])=f(iv[0],iv[1],iv[2]);
//  	    iv[0]=I1z.getBound(); iv[1]=I2z.getBound(); iv[2]=I3z.getBound();
//  	    if( iv[direction]==mg.gridIndexRange()(End,direction)+1 && mg.boundaryCondition(End,direction)>0 )
//  	      DEFECT(iv[0],iv[1],iv[2])=f(iv[0],iv[1],iv[2]);
//  	  }	

        	  if( Ogmg::debug & 8 )
        	  {
                        fprintf(debugFile," lineSmooth: get defect for points: D1z,D2z,D3z=[%i,%i][%i,%i][%i,%i]\n",
                		    D1z.getBase(),D1z.getBound(),D2z.getBase(),D2z.getBound(),D3z.getBase(),D3z.getBound());
          	    
          	    display(defect(I1,I2,I3),sPrintF("lineSmooth: Here is rhs before the zebra tridiagonalSolver, "
                		    "level=%i grid=%i ",level,grid),debugFile,"%8.1e ");
        	  }
            
        	  if( false && parameters.alternateSmoothingDirections ) // negative strides not allowed
        	  {
            // Reverse the order of the lines we solve -- 
	    // Two possibilities for now:
          	    int numMod = parameters.totalNumberOfSubSmooths(grid,level)+iteration % 2;
          	    if( numMod == 1 )
          	    {
                            if( direction!=axis1 )
              	        I1z=Range(I1z.getBound(),I1z.getBase(),-I1z.getStride());
                            if( direction!=axis2 )
              	        I2z=Range(I2z.getBound(),I2z.getBase(),-I2z.getStride());
                            if( direction!=axis3 )
              	        I3z=Range(I3z.getBound(),I3z.getBase(),-I3z.getStride());
            	      
          	    }
        	  }
        	  
        	  time1=getCPU();
                    #ifndef USE_PPP
              	    tridiagonalSolver[level][grid][direction]->solve(defect,I1z,I2z,I3z);
                    #else
                        Overture::abort("Ogmg::ERROR:finish me for parallel Bill!");
                    #endif
        	  time0=getCPU();
        	  tm[timeForTridiagonalSolverInSmooth]+=time0-time1;

        	  if( Ogmg::debug & 8 )
          	    display(defect(I1,I2,I3),"Here is the solution from the zebra tridiagonalSolver ",debugFile,"%8.1e ");
            
//        where( mask(I1z,I2z,I3z) >= 0 )
//          u(I1z,I2z,I3z)=defect(I1z,I2z,I3z);   // @PAW 
          // ******* TO DO **** add variable omega for 3D *************

                    if( false )
        	  {
          	    FOR_3S(i1,i2,i3,I1z,I2z,I3z)
          	    {
            	      if( MASK(i1,i2,i3) >=0 )
            	      {           
            		U(i1,i2,i3)=oneMinusOmega*U(i1,i2,i3)+omega*DEFECT(i1,i2,i3);
            	      }
          	    }
        	  }
        	  else
        	  {
          	    int ipar2[]={ I1z.getBase(),I1z.getBound(),I1z.getStride(),
                    			  I2z.getBase(),I2z.getBound(),I2z.getStride(), //
                    			  I3z.getBase(),I3z.getBound(),I3z.getStride(), //
                    			  direction,orderOfAccuracy,variableCoefficients,useOmega};

                        real rpar2[]={omega,variableOmegaFactor}; //

                        lineSmoothUpdate( mg.numberOfDimensions(),
                                                            u.getBase(0),u.getBound(0),
                                                            u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2),
                        			      *u.getDataPointer(), *defect.getDataPointer(), *mask.getDataPointer(), 
                                                            coeff.getLength(0), *coeff.getDataPointer(),
                                                            ipar2[0], rpar2[0] );
        	  }

        	  tm[timeForRelaxInSmooth]+=getCPU()-time0;

        	  if( Ogmg::debug & 8 )
          	    display(u,sPrintF("lineSmooth:Here is the solution u=defect, level=%i grid=%i ",
                                                  level,grid),debugFile,"%9.2e ");

	  // * applyBoundaryConditions( level,uu,ff );
            
          // uu.periodicUpdate();  // ************** added for testing
        	  

        	  if( Ogmg::debug & 16 )
        	  {
          	    defect(level,grid);
          	    display(defectMG.multigridLevel[level][grid],sPrintF(buff,"smoothLine, direction=%i, zebra2=%i, defect:",
                                                 								 direction,zebra2),debugFile);
          	    display(u,sPrintF(buff,"smoothLine, direction=%i: Here is u",direction),debugFile);
        	  }
        	  applyBoundaryConditions( level,grid,uu,ff );

        	  if( Ogmg::debug & 8 )
        	  {
          	    display(u,sPrintF("lineSmooth: Here is the solution u after applyBoundaryConditions, level=%i grid=%i ",
                                                  level,grid),debugFile,"%9.2e ");
          	    defect=0;
                        getDefect(level,grid,f,u,D1,D2,D3,defect);
                        display(defect(I1,I2,I3),sPrintF("lineSmooth: Defect after apply boundary conditions, level=%i grid=%i ",
                                                  level,grid),debugFile,"%9.2e ");

        	  }
        	  

      	}
        }
        else   //  ****** Jacobi Line Smooth **************
        {
            real time1=getCPU();

//        printf(" I1=[%i,%i] I2=[%i,%i] I3=[%i,%i]\n",I1.getBase(),I1.getBound(),I2.getBase(),I2.getBound(),
//  	     I3.getBase(),I3.getBound());
//        printf(" u : [%i,%i][%i,%i][%i,%i]\n",u.getBase(0),u.getBound(0),u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2));
//        printf(" f : [%i,%i][%i,%i][%i,%i]\n",f.getBase(0),f.getBound(0),f.getBase(1),f.getBound(1),f.getBase(2),f.getBound(2));
//        printf(" defect : [%i,%i][%i,%i][%i,%i]\n",defect.getBase(0),defect.getBound(0),defect.getBase(1),defect.getBound(1),defect.getBase(2),defect.getBound(2));
            
            if( debug & 4 )
      	fprintf(debugFile,"direction=%i jacobi line smooth I1=(%i,%i,%i), I2=(%i,%i,%i), I3=(%i,%i,%i) \n",
            		direction,
            		I1.getBase(),I1.getBound(),I1.getStride(),I2.getBase(),I2.getBound(),I2.getStride(),
            		I3.getBase(),I3.getBound(),I3.getStride());
            

      // We only need to evaluate the defect at points where the ...
            getDefect(level,grid,f,u,D1,D2,D3,defect,direction);

            time0=getCPU();
            tm[timeForDefectInSmooth]+=time0-time1;

      // lineSmoothBoundaryConditions(FOR_3,Iv,I1,I2,I3);
      // Set values at interpolation points
            int i1,i2,i3;
            if( mg.numberOfDimensions()==2 )
            {
                i3=I3.getBase();
                for( int i=0; i<numberOfInterpolationPoints; i++ )
                {
                    i1=IP(i,0);
                    i2=IP(i,1);
                    DEFECT(i1,i2,i3)=U(i1,i2,i3); 
                }
            }
            else
            {
                for( int i=0; i<numberOfInterpolationPoints; i++ )
                {
                    i1=IP(i,0);
                    i2=IP(i,1);
                    i3=IP(i,2);
                    DEFECT(i1,i2,i3)=U(i1,i2,i3); 
                }
            }
      // For the constant coeff case we must fill in the BC's into the defect array
      // for fourth order we need to assign the rhs for extrapolation conditions
            if( (true || usingConstantCoefficients ) // **** we must always assign Neumann BC's -- could avoid dirichlet below
                    || orderOfAccuracy==4 )
            {
        // Boundary Conditions
                Index Jv[3], &J1=Jv[0], &J2=Jv[1], &J3=Jv[2];
                axis=direction;
                for( int side=0; side<=1; side++ )
                {
                    if( boundaryCondition(side,axis,grid)>0 )
                    {
                        is1=is2=is3=0;
                        isv[axis]=1-2*side;
                        if( boundaryCondition(side,axis,grid)==OgmgParameters::extrapolate )
                        {
      	 // Dirichlet BC
      	 // printf("Assign DirichletRHS for TRID side=%i axis=%i \n",side,axis);
       	    // J1=I1; J2=I2; J3=I3;
       	    // Jv[axis]=side==0 ? Iv[axis].getBase() : Iv[axis].getBound();
       	    // do not include ghost pts on adj sides.
       	    // ** getBoundaryIndex(mg.gridIndexRange(),side,axis,J1,J2,J3);  // this fills in values even if not needed		
                   	 J1=I1; J2=I2; J3=I3;
                   	 Jv[axis]=side==0 ? Iv[axis].getBase() : Iv[axis].getBound();
                   	 if( orderOfAccuracy==2 )
                   	 {
                     	   FOR_3(i1,i2,i3,J1,J2,J3)
                     	   {
                       	     if( MASK(i1,i2,i3)>0 )
                       	     {
                         	       DEFECT(i1,i2,i3)=F(i1,i2,i3);
                       	     }
                       	     else
                       	     {
                         	       DEFECT(i1,i2,i3)=0.;
                       	     }
                     	   }
                   	 }
                   	 else
                   	 {
      	   // if( parameters.fourthOrderBoundaryConditionOption==0 || level>0 )
                     	   if( !useEquationOnGhostForDirichlet )
                     	   {
                       	     FOR_3(i1,i2,i3,J1,J2,J3)
                       	     {
                         	       j1=i1+is1; j2=i2+is2; j3=i3+is3; // boundary point
                         	       if( MASK(j1,j2,j3)>0 )
                         	       {
                           	         DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                           	         DEFECT(i1,i2,i3)=0.;           // extrapolation or symmetry 
                         	       }
                         	       else
                         	       {
                         		 DEFECT(i1,i2,i3)=0.;
                         	       }
                       	     }
                     	   }
                     	   else
                     	   {
                   // Use equation to 2nd order on the first ghost line 
                                      int ms2 = direction==0 ? 1 : direction==1 ? width : width*width;  // shift for 2nd-order stencil in a fourth order operator
                                      ms2*=1-2*side;
                       	     if( numberOfDimensions==2 )
                       	     {
                         	       if( axis==0 )
                         	       {
                         		 if( usingConstantCoefficients )
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1]);  // equation      
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         		 else
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                               		       COEFF(m22+ms2,i1,i2,i3)*u(j1-1,j2-1,j3)+COEFF(m32+ms2,i1,i2,i3)*u(j1,j2-1,j3)+COEFF(m42+ms2,i1,i2,i3)*u(j1+1,j2-1,j3)+
      		    // COEFF(m23+ms2,i1,i2,i3)*u(j1-1,j2  ,j3)+COEFF(m33+ms2,i1,i2,i3)*u(j1,j2  ,j3)+COEFF(m43+ms2,i1,i2,i3)*u(j1+1,j2  ,j3)+
                               		       COEFF(m24+ms2,i1,i2,i3)*u(j1-1,j2+1,j3)+COEFF(m34+ms2,i1,i2,i3)*u(j1,j2+1,j3)+COEFF(m44+ms2,i1,i2,i3)*u(j1+1,j2+1,j3) 
                               			 );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         	       }
                         	       else
                         	       {
                         		 if( usingConstantCoefficients )
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0]);  // equation      
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         		 else
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                           		   COEFF(m22+ms2,i1,i2,i3)*u(j1-1,j2-1,j3)/* +COEFF(m32+ms2,i1,i2,i3)*u(j1,j2-1,j3) */+COEFF(m42+ms2,i1,i2,i3)*u(j1+1,j2-1,j3)+
                           		   COEFF(m23+ms2,i1,i2,i3)*u(j1-1,j2  ,j3)/* +COEFF(m33+ms2,i1,i2,i3)*u(j1,j2  ,j3) */+COEFF(m43+ms2,i1,i2,i3)*u(j1+1,j2  ,j3)+
                           		   COEFF(m24+ms2,i1,i2,i3)*u(j1-1,j2+1,j3)/* +COEFF(m34+ms2,i1,i2,i3)*u(j1,j2+1,j3) */+COEFF(m44+ms2,i1,i2,i3)*u(j1+1,j2+1,j3) 
                               		       );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         	       }
                       	     }
                       	     else if( numberOfDimensions==3 )
                       	     {
                         	       if( axis==0 )
                         	       {
                         		 if( usingConstantCoefficients )
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1])
                                                       				  		     +(U(j1,j2,j3+1)+U(j1,j2,j3-1))/(dx[2]*dx[2]) );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         		 else
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(  // eqn to 2nd order
                                      COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                      COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                      COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                      COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
      	//   COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                      COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                      COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                      COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                      COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                               		       );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         	       }
                         	       else if( axis==1 )
                         	       {
                         		 if( usingConstantCoefficients )
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0])
                                                       					  	     +(U(j1,j2,j3+1)+U(j1,j2,j3-1))/(dx[2]*dx[2]) );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         		 else
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(
                                      COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                      COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                      COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                      COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+/*COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )*/+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
                       	     COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+/*COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )*/+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                      COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+/*COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )*/+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                      COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                      COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                      COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                               		       );
                               		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         	       }
                         	       else 
                         	       {
                         		 if( usingConstantCoefficients )
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-( (U(j1+1,j2,j3)+U(j1-1,j2,j3))/(dx[0]*dx[0])
                                                     						     +(U(j1,j2+1,j3)+U(j1,j2-1,j3))/(dx[1]*dx[1]) );
                             		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         		 else
                         		 {
                           		   FOR_3(i1,i2,i3,J1,J2,J3)
                           		   {
                             		     j1=i1+is1; j2=i2+is2; j3=i3+is3;  // boundary point
                                                      if( MASK(j1,j2,j3)>0 )
                                                      {
                               		       DEFECT(j1,j2,j3)=F(j1,j2,j3);  // dirichlet BC
                               		       DEFECT(i1,i2,i3)=F(i1,i2,i3)-(
                                      COEFF(m222+ms2,i1,i2,i3)*u(j1-1,j2-1,j3-1)+COEFF(m322+ms2,i1,i2,i3)*u(j1,j2-1,j3-1)+COEFF(m422+ms2,i1,i2,i3)*u(j1+1,j2-1,j3-1)+
                                      COEFF(m232+ms2,i1,i2,i3)*u(j1-1,j2  ,j3-1)+/*COEFF(m332+ms2,i1,i2,i3)*u(j1,j2  ,j3-1)*/+COEFF(m432+ms2,i1,i2,i3)*u(j1+1,j2  ,j3-1)+
                                      COEFF(m242+ms2,i1,i2,i3)*u(j1-1,j2+1,j3-1)+COEFF(m342+ms2,i1,i2,i3)*u(j1,j2+1,j3-1)+COEFF(m442+ms2,i1,i2,i3)*u(j1+1,j2+1,j3-1)+
                                      COEFF(m223+ms2,i1,i2,i3)*u(j1-1,j2-1,j3  )+COEFF(m323+ms2,i1,i2,i3)*u(j1,j2-1,j3  )+COEFF(m423+ms2,i1,i2,i3)*u(j1+1,j2-1,j3  )+
                       	     COEFF(m233+ms2,i1,i2,i3)*u(j1-1,j2  ,j3  )+/*COEFF(m333+ms2,i1,i2,i3)*u(j1,j2  ,j3  )*/+COEFF(m433+ms2,i1,i2,i3)*u(j1+1,j2  ,j3  )+
                                      COEFF(m243+ms2,i1,i2,i3)*u(j1-1,j2+1,j3  )+COEFF(m343+ms2,i1,i2,i3)*u(j1,j2+1,j3  )+COEFF(m443+ms2,i1,i2,i3)*u(j1+1,j2+1,j3  )+
                                      COEFF(m224+ms2,i1,i2,i3)*u(j1-1,j2-1,j3+1)+COEFF(m324+ms2,i1,i2,i3)*u(j1,j2-1,j3+1)+COEFF(m424+ms2,i1,i2,i3)*u(j1+1,j2-1,j3+1)+
                                      COEFF(m234+ms2,i1,i2,i3)*u(j1-1,j2  ,j3+1)+/*COEFF(m334+ms2,i1,i2,i3)*u(j1,j2  ,j3+1)*/+COEFF(m434+ms2,i1,i2,i3)*u(j1+1,j2  ,j3+1)+
                                      COEFF(m244+ms2,i1,i2,i3)*u(j1-1,j2+1,j3+1)+COEFF(m344+ms2,i1,i2,i3)*u(j1,j2+1,j3+1)+COEFF(m444+ms2,i1,i2,i3)*u(j1+1,j2+1,j3+1) 
                               		       );
                               		     }
                                                      else
                             		     {
                               		       DEFECT(j1,j2,j3)=0.;
                                                          DEFECT(i1,i2,i3)=0.;
                             		     }
                           		   }
                         		 }
                         	       }
                       	     }
                       	     else
                       	     {
                         	       Overture::abort();
                       	     }
                     	   }
                   	 }
                        }
                        else if( boundaryCondition(side,axis,grid)==OgmgParameters::equation )
                        {
      	 // *****************************************************
      	 // ************ neumann  or mixed **********************
      	 // *****************************************************
                   	 J1=I1; J2=I2; J3=I3;
                   	 Jv[axis]=side==0 ? Iv[axis].getBase() : Iv[axis].getBound();
                   	 if( orderOfAccuracy==2 )
                   	 {
                     	   if( level==0 )
                     	   {
                       	     FOR_3(i1,i2,i3,J1,J2,J3)
                       	     {
                         	       j1=i1+is1; j2=i2+is2; j3=i3+is3;
                         	       if( MASK(j1,j2,j3)>0 )
                         	       {
                         		 DEFECT(i1,i2,i3)=F(i1,i2,i3);   // neumann BC
                         	       }
                         	       else
                         	       {
                         		 DEFECT(i1,i2,i3)=0.;
                         	       }
                       	     }
                     	   }
                     	   else
                     	   {
                       	     FOR_3(i1,i2,i3,J1,J2,J3)
                       	     {
                         	       DEFECT(i1,i2,i3)=0.;           // neumann BC
                       	     }
                     	   }
                   	 }
                   	 else // fourth-order
                   	 {
                 // **** fix this ****
                                  if( useEquationOnGhostForNeumann )
                     	   {
                   // *** these values are now filled in below 
                                      if( true )
                       	     {
                       	     }
                       	     else if( level==0 || level>0 )
                       	     {
                         	       if( usingConstantCoefficients )
                         	       {
      		 // Neumann and  u.xxx = f.x - g.yy
                       // i1,i2,i3 = 2nd ghost
                       // j1,j2,j3 = 1st ghost
                         		 FOR_3(i1,i2,i3,J1,J2,J3)
                         		 {
                           		   j1=i1+is1; j2=i2+is2; j3=i3+is3;
                           		   fprintf(debugFile,"N4Lx: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
                           		   if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                           		   {
                             		     DEFECT(j1,j2,j3)=F(j1,j2,j3);   // neumann BC
                             		     DEFECT(i1,i2,i3)=0.;            // u.xxx=
                           		   }
                           		   else
                           		   {
                             		     DEFECT(j1,j2,j3)=0.;
                             		     DEFECT(i1,i2,i3)=0.;
                           		   }
                         		 }
                         	       }
                         	       else
                         	       {
                            	          Overture::abort("lineSolve: Error useEquationOnGhostForNeumann not implemented.");
                         	       }
                       	     }
                     	   }
                                  else
                                  {
      	     // extrapolation for 2nd ghost or symmetry
                       	     if( level==0 )
                       	     {
                         	       if( usingConstantCoefficients )
                         	       {
      		 // Neumann + extrapolation for rectangular grids.
                         		 FOR_3(i1,i2,i3,J1,J2,J3)
                         		 {
                           		   j1=i1+is1; j2=i2+is2; j3=i3+is3;
      		   // fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
                           		   if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                           		   {
                             		     DEFECT(j1,j2,j3)=F(j1,j2,j3);   // neumann BC
                             		     DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                           		   }
                           		   else
                           		   {
                             		     DEFECT(j1,j2,j3)=0.;
                             		     DEFECT(i1,i2,i3)=0.;
                           		   }
                         		 }
                         	       }
                         	       else
                         	       {
                         		 if( numberOfDimensions==2 && direction==0 )
                         		 {
                     // 		   neumannExtrapCurvilinear(R,2,FOR_3,Iv,I1,I2,I3);
                                          FOR_3(i1,i2,i3,J1,J2,J3)
                                          {
                                              j1=i1+is1; j2=i2+is2; j3=i3+is3;
                     //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                     //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                     //             i1,i2,i3,j1,j2,j3,
                     //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                     //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                     //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                              if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                              {
                       //                        #If "2" == "2" && "R" == "R"
                         // neumann BC: nd=2 dir=0
                                                  DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                        COEFF(m31,j1,j2,j3)*u(j1+is1,j2-2,j3)
                                                      +COEFF(m32,j1,j2,j3)*u(j1+is1,j2-1,j3)
                                                      +COEFF(m34,j1,j2,j3)*u(j1+is1,j2+1,j3)
                                                      +COEFF(m35,j1,j2,j3)*u(j1+is1,j2+2,j3) );
                                                  DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                              }
                                              else
                                              {
                                                  DEFECT(j1,j2,j3)=0.;
                                                  DEFECT(i1,i2,i3)=0.;
                                              }
                                          }
                         		 }
                         		 else if(  numberOfDimensions==2 && direction==1 )
                         		 {
                     // 		   neumannExtrapCurvilinear(S,2,FOR_3,Iv,I1,I2,I3);
                                          FOR_3(i1,i2,i3,J1,J2,J3)
                                          {
                                              j1=i1+is1; j2=i2+is2; j3=i3+is3;
                     //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                     //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                     //             i1,i2,i3,j1,j2,j3,
                     //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                     //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                     //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                              if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                              {
                       //                        #If "2" == "2" && "S" == "R"
                       //                        #Elif "2" == "2" && "S" == "S"
                                                  DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                        COEFF(m13,j1,j2,j3)*u(j1-2,j2+is2,j3)
                                                      +COEFF(m23,j1,j2,j3)*u(j1-1,j2+is2,j3)
                                                      +COEFF(m43,j1,j2,j3)*u(j1+1,j2+is2,j3)
                                                      +COEFF(m53,j1,j2,j3)*u(j1+2,j2+is2,j3) );
                                                  DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                              }
                                              else
                                              {
                                                  DEFECT(j1,j2,j3)=0.;
                                                  DEFECT(i1,i2,i3)=0.;
                                              }
                                          }
                         		 }
                         		 else if(  numberOfDimensions==3 && direction==0 )
                         		 {
                     // 		   neumannExtrapCurvilinear(R,3,FOR_3,Iv,I1,I2,I3);
                                          FOR_3(i1,i2,i3,J1,J2,J3)
                                          {
                                              j1=i1+is1; j2=i2+is2; j3=i3+is3;
                     //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                     //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                     //             i1,i2,i3,j1,j2,j3,
                     //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                     //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                     //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                              if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                              {
                       //                        #If "3" == "2" && "R" == "R"
                       //                        #Elif "3" == "2" && "R" == "S"
                       //                        #Elif "3" == "3" && "R" == "R"
                         // neumann BC: nd=3 dir=0
                                                  DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                        COEFF(m313,j1,j2,j3)*u(j1+is1,j2-2,j3)
                                                      +COEFF(m323,j1,j2,j3)*u(j1+is1,j2-1,j3)
                                                      +COEFF(m343,j1,j2,j3)*u(j1+is1,j2+1,j3)
                                                      +COEFF(m353,j1,j2,j3)*u(j1+is1,j2+2,j3)
                                                      +COEFF(m331,j1,j2,j3)*u(j1+is1,j2  ,j3-2)
                                                      +COEFF(m332,j1,j2,j3)*u(j1+is1,j2  ,j3-1)
                                                      +COEFF(m334,j1,j2,j3)*u(j1+is1,j2  ,j3+1)
                                                      +COEFF(m335,j1,j2,j3)*u(j1+is1,j2  ,j3+2) );
                                                  DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                              }
                                              else
                                              {
                                                  DEFECT(j1,j2,j3)=0.;
                                                  DEFECT(i1,i2,i3)=0.;
                                              }
                                          }
                         		 }
                         		 else if(  numberOfDimensions==3 && direction==1 )
                         		 {
                     // 		   neumannExtrapCurvilinear(S,3,FOR_3,Iv,I1,I2,I3);
                                          FOR_3(i1,i2,i3,J1,J2,J3)
                                          {
                                              j1=i1+is1; j2=i2+is2; j3=i3+is3;
                     //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                     //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                     //             i1,i2,i3,j1,j2,j3,
                     //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                     //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                     //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                              if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                              {
                       //                        #If "3" == "2" && "S" == "R"
                       //                        #Elif "3" == "2" && "S" == "S"
                       //                        #Elif "3" == "3" && "S" == "R"
                       //                        #Elif "3" == "3" && "S" == "S"
                                                  DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                        COEFF(m133,j1,j2,j3)*u(j1-2,j2+is2,j3)
                                                      +COEFF(m233,j1,j2,j3)*u(j1-1,j2+is2,j3)
                                                      +COEFF(m433,j1,j2,j3)*u(j1+1,j2+is2,j3)
                                                      +COEFF(m533,j1,j2,j3)*u(j1+2,j2+is2,j3)
                                                      +COEFF(m331,j1,j2,j3)*u(j1  ,j2+is2,j3-2)
                                                      +COEFF(m332,j1,j2,j3)*u(j1  ,j2+is2,j3-1)
                                                      +COEFF(m334,j1,j2,j3)*u(j1  ,j2+is2,j3+1)
                                                      +COEFF(m335,j1,j2,j3)*u(j1  ,j2+is2,j3+2) );
                                                  DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                              }
                                              else
                                              {
                                                  DEFECT(j1,j2,j3)=0.;
                                                  DEFECT(i1,i2,i3)=0.;
                                              }
                                          }
                         		 }
                         		 else if(  numberOfDimensions==3 && direction==2 )
                         		 {
                     // 		   neumannExtrapCurvilinear(T,3,FOR_3,Iv,I1,I2,I3);
                                          FOR_3(i1,i2,i3,J1,J2,J3)
                                          {
                                              j1=i1+is1; j2=i2+is2; j3=i3+is3;
                     //    fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e C=[%6.2f,%6.2f,%6.2f,%6.2f,%6.2f], "
                     //           " [%6.2f,%6.2f,%6.2f,%6.2f]\n",
                     //             i1,i2,i3,j1,j2,j3,
                     //              F(j1,j2,j3),COEFF(m13,j1,j2,j3),COEFF(m23,j1,j2,j3),COEFF(m33,j1,j2,j3),
                     //               COEFF(m43,j1,j2,j3),COEFF(m53,j1,j2,j3),
                     //               COEFF(m31,j1,j2,j3),COEFF(m32,j1,j2,j3),COEFF(m34,j1,j2,j3),COEFF(m35,j1,j2,j3));
                                              if( MASK(j1+is1,j2+is2,j3+is3)>0 ) // check the mask on the boundary
                                              {
                       //                        #If "3" == "2" && "T" == "R"
                       //                        #Elif "3" == "2" && "T" == "S"
                       //                        #Elif "3" == "3" && "T" == "R"
                       //                        #Elif "3" == "3" && "T" == "S"
                       //                        #Elif "3" == "3" && "T" == "T"
                                                  DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
                                                        COEFF(m133,j1,j2,j3)*u(j1-2,j2  ,j3+is3)
                                                      +COEFF(m233,j1,j2,j3)*u(j1-1,j2  ,j3+is3)
                                                      +COEFF(m433,j1,j2,j3)*u(j1+1,j2  ,j3+is3)
                                                      +COEFF(m533,j1,j2,j3)*u(j1+2,j2  ,j3+is3)
                                                      +COEFF(m313,j1,j2,j3)*u(j1  ,j2-2,j3+is3)
                                                      +COEFF(m323,j1,j2,j3)*u(j1  ,j2-1,j3+is3)
                                                      +COEFF(m343,j1,j2,j3)*u(j1  ,j2+1,j3+is3)
                                                      +COEFF(m353,j1,j2,j3)*u(j1  ,j2+2,j3+is3) );
                                                  DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
                                              }
                                              else
                                              {
                                                  DEFECT(j1,j2,j3)=0.;
                                                  DEFECT(i1,i2,i3)=0.;
                                              }
                                          }
                         		 }
      //  	       FOR_3(i1,i2,i3,J1,J2,J3)
      //  	       {
      //  		 j1=i1+is1; j2=i2+is2; j3=i3+is3;
      //  		 fprintf(debugFile,"N4: i=(%i,%i,%i) j=(%i,%i,%i) F=%8.2e\n",i1,i2,i3,j1,j2,j3,F(j1,j2,j3));
      //                   // neumann BC: nd=2 dir=0
      //  		 DEFECT(j1,j2,j3)=F(j1,j2,j3)- (
      //                                 COEFF(m31,i1,i2,i3)*u(j1+is1,j2-2,j3)
      //                                +COEFF(m32,i1,i2,i3)*u(j1+is1,j2-1,j3)
      //                                +COEFF(m34,i1,i2,i3)*u(j1+is1,j2+1,j3)
      //  			      +COEFF(m35,i1,i2,i3)*u(j1+is1,j2+1,j3) );
      //  		 DEFECT(i1,i2,i3)=0.;            // extrapolation: second ghost line                    
      //  	       }
                         	       }
                       	     }
                       	     else // level>0 
                       	     {
                         	       FOR_3(i1,i2,i3,J1,J2,J3)
                         	       {
                         		 j1=i1+is1; j2=i2+is2; j3=i3+is3;
                         		 DEFECT(j1,j2,j3)=0.;           // neumann BC or symmetry or mixed BC
                         		 DEFECT(i1,i2,i3)=0.;           // second ghost line : extrap or symmetry or mixed BC
                         	       }
                       	     }
                     	   }
                   	 }
                        }
                        else
                        {
                  	printf(" ERROR: unknown bc = %i\n",boundaryCondition(side,axis,grid));
                            Overture::abort("ERROR");
                        }
                    }
                }
            }
            if( useEquationOnGhostForNeumann &&  orderOfAccuracy==4 )
            {
        // new optimised BC's -- currently only for Neumann and equation BC
                ipar[ 4]=I1.getBase();
                ipar[ 5]=I1.getBound();
                ipar[ 6]=I1.getStride();
                ipar[ 7]=I2.getBase();
                ipar[ 8]=I2.getBound();
                ipar[ 9]=I2.getStride();
                ipar[10]=I3.getBase();
                ipar[11]=I3.getBound();
                ipar[12]=I3.getStride();
        // NOTE: do NOT use view pointers here
                lineSmoothRHS( numberOfDimensions,
                                              u.getBase(0),u.getBound(0),u.getBase(1),u.getBound(1),u.getBase(2),u.getBound(2),
                         		 coeff.getLength(0), *coeffp, 
                         		 constantCoefficients(0,grid,level),
                         		 *defect.getDataPointer(), 
                         		 *sptr, *uptr, *f.getDataPointer(), *mask.getDataPointer(), *prsxy, ipar[0], rpar[0], 
                         		 boundaryConditionData.getLength(0),boundaryConditionData(0,0,0,grid) );
            }

            
            tm[timeForRelaxInSmooth]+=getCPU()-time0;

//        if( false && level==0 )
//        { // define the defect for Neumann or mixed BC's on level 0 at ghost points
//  	//     -- these may be inhomogeneous
//  	// **** this assumes BC is normal direction only ******
//  	int iv[3]; 
//  	iv[0]=I1.getBase(); iv[1]=I2.getBase(); iv[2]=I3.getBase();
//  	if( iv[direction]==mg.gridIndexRange()(Start,direction)-1 && mg.boundaryCondition(Start,direction)>0 )
//  	  DEFECT(iv[0],iv[1],iv[2])=f(iv[0],iv[1],iv[2]);
//  	iv[0]=I1.getBound(); iv[1]=I2.getBound(); iv[2]=I3.getBound();
//  	if( iv[direction]==mg.gridIndexRange()(End,direction)+1 && mg.boundaryCondition(End,direction)>0 )
//  	  DEFECT(iv[0],iv[1],iv[2])=f(iv[0],iv[1],iv[2]);
//        }	

            if( Ogmg::debug & 8 )
      	display(defect(I1,I2,I3),"Here is the rhs before the (jacobi) tridiagonalSolver ",debugFile,"%8.2e ");

            time1=getCPU();

            #ifndef USE_PPP
                tridiagonalSolver[level][grid][direction]->solve(defect,I1,I2,I3);
            #else
                Overture::abort("Ogmg::ERROR:finish me for parallel Bill!");
            #endif
//        realArray fff(I1,I2,I3);
//        fff=defect(I1,I2,I3);
//        tridiagonalSolver[level][grid][direction]->solve(fff,I1,I2,I3);
//        defect(I1,I2,I3)=fff;

            time0=getCPU();
            tm[timeForTridiagonalSolverInSmooth]+=time0-time1;

            if( Ogmg::debug & 8 )
      	display(defect(I1,I2,I3),"Here is the solution from the (jacobi) tridiagonalSolver ",debugFile,"%8.2e ");
            
            real & omega=parameters.omegaLineJacobi;
            if( omega<0. )
            {
	// assign default values
                omega=.8;
            }
            real omegam=1.-omega;
            FOR_3(i1,i2,i3,I1,I2,I3)
            {
      	if( MASK(i1,i2,i3) >=0 )
      	{           
        	  U(i1,i2,i3)=omegam*U(i1,i2,i3)+omega*DEFECT(i1,i2,i3);
      	}
            }

            tm[timeForRelaxInSmooth]+=getCPU()-time0;

            if( Ogmg::debug & 8 )
      	display(u,sPrintF(buff,"Here is the solution u=(1-omega)*u+omega*defect omega=%5.2f",omega),debugFile,"%8.2e ");

	  // * applyBoundaryConditions( level,uu,ff );
            
            if( Ogmg::debug & 16 )
            {
      	defect(level,grid);
      	display(defectMG.multigridLevel[level][grid],sPrintF(buff,"smoothLine, direction=%i defect:",direction),debugFile);
      	display(u,sPrintF(buff,"smoothLine, direction=%i: Here is u",direction),debugFile);
            }
            applyBoundaryConditions( level,grid,uu,ff );

            if( Ogmg::debug & 8 )
      	display(u,"Here is the solution u after applyBoundaryConditions ",debugFile,"%8.2e ");
        }


    // back substitute 2n-2 multiplies, n divisions
    //    ***** fourth-order : 5 mults+divides

    // real wu = mg.numberOfDimensions()==2 ? 3./6. : 3./8.;
        real wu = (orderOfAccuracy==2 ? 3. : 5. )/jacobiWork;
    // workUnits(level)+=(1.+wu)/mgcg.multigridLevel[level].numberOfComponentGrids();  
        workUnits(level)+=(1.+wu)*mask.elementCount()/real(numberOfGridPoints);


        bool postSmooth=false; // numberOfLinesSolves%2 == 0; // true;
        if( postSmooth &&  parameters.numberOfBoundaryLayersToSmooth>0 )
        {
            
      // int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth + (numberOfLinesSolves%3)-1;
            int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth; 
      // int numberOfLayers=parameters.numberOfBoundaryLayersToSmooth;

            int bc[6]={0,0,0,0,0,0}; //
            bc[0+2*direction]=1; // smooth boundaries axis==direction
            bc[1+2*direction]=1;
            if( parameters.smootherType(grid,level)==alternatingLineJacobi ||
                    parameters.smootherType(grid,level)==alternatingLineZebra )
            {
        // for alternating smoothers we smooth all boundaries
                bc[0]=bc[1]=bc[2]=bc[3]=bc[4]=bc[5]=1;
            }
            

            smoothBoundary(level,grid,bc,numberOfLayers,parameters.numberOfBoundarySmoothIterations );
        }

        numberOfLinesSolves++;
        
    } // end for iteration
    

}

static const int maximumNumberOfLevelsForDirectionToSmooth=20;
static int directionToSmooth[maximumNumberOfLevelsForDirectionToSmooth]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


//\begin{>>OgmgInclude.tex}{\subsection{alternatingLineSmooth}}
void Ogmg:: 
alternatingLineSmooth(const int & level, const int & grid, bool useZebra /* =true */)
//-------------------------------------------------------------------------
// /Description:
//    Here we do alternating line smooths; one line smooth in each direction.
//\end{OgmgInclude.tex} 
//------------------------------------------------------------------------
{
    int axis;
    if( false && parameters.useSplitStepLineSolver )
    {
    // alternating-alternating  ** what should this be in 3D ??
        if( numberOfCycles % 2 == 0)
        {
            smoothLine(level,grid,axis1,useZebra);
            smoothLine(level,grid,axis2,useZebra);
            if( mgcg.numberOfDimensions() ==3 )
              smoothLine(level,grid,axis3,useZebra);
        }
        else 
        {
            if( mgcg.numberOfDimensions() ==3 )
              smoothLine(level,grid,axis3,useZebra);
            smoothLine(level,grid,axis2,useZebra);
            smoothLine(level,grid,axis1,useZebra);
        }
        
        return;
    }
    
    if( parameters.useSplitStepLineSolver )
    {
    // only do one direction per smooth, alternating through the directions
        const int nd=mgcg.numberOfDimensions();

        if( true )
        {
      // change line direction for each CYCLE
            int axisToSmooth = numberOfCycles % nd;
            smoothLine(level,grid,axisToSmooth,useZebra);
        }
        else
        {
      // change line direction after each SMOOTH

            assert( level<maximumNumberOfLevelsForDirectionToSmooth );
            int axisToSmooth = (directionToSmooth[level]/1) % nd;
            directionToSmooth[level]++;
        
            smoothLine(level,grid,axisToSmooth,useZebra);
        }
        
//    axisToSmooth = (directionToSmooth[level]/1) % nd;
//    directionToSmooth[level]++;
        
//    smoothLine(level,grid,axisToSmooth,useZebra);



//      if( (numberOfCycles % nd) == 0)
//       smoothLine(level,grid,axis1,useZebra);
//      else if( (numberOfCycles % nd) == 1)
//       smoothLine(level,grid,axis2,useZebra);
//      else
//       smoothLine(level,grid,axis3,useZebra);

        return;
    }
    

  // *** TRUE line solver ***
    for( axis=0; axis<mgcg.numberOfDimensions(); axis++ )
    {
        smoothLine(level,grid,axis,useZebra);

        if( false )
            smoothRedBlack(level,grid);
    }
    
    if( false )
    {
    // extra smooth near boundaries
        for( int it=0; it<1; it++ )
            for( axis=0; axis<mgcg.numberOfDimensions(); axis++ )
      	for( int side=0; side<=1; side++ )
        	  smoothLine(level,grid,axis,false,side);
    }
    
}

#undef C
#undef M123
