c These next include files will define the macros that will define the difference approximations
c The actual macro is called below
#Include "defineDiffOrder2f.h"
#Include "defineDiffOrder4f.h"


#beginMacro beginLoop(n1a,n1b,n2a,n2b,n3a,n3b)
do i3=n3a,n3b
do i2=n2a,n2b
do i1=n1a,n1b 
#endMacro
#beginMacro beginLoopJ(n1a,n1b,n2a,n2b,n3a,n3b)
do j3=n3a,n3b
do j2=n2a,n2b
do j1=n1a,n1b 
#endMacro
#beginMacro endLoop()
end do
end do
end do
#endMacro


c return the loop indicies for the "boundary" (side,axis) shifted by "shift"
#beginMacro getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,shift)
 m1a=n1a
 m1b=n1b
 m2a=n2a
 m2b=n2b
 m3a=n3a
 m3b=n3b
 if( axis.eq.0 )then
  if( side.eq.0 )then
    m1a=n1a+shift
  else
    m1a=n1b-shift
  end if
  m1b=m1a
 else if( axis.eq.1 )then
  if( side.eq.0 )then
    m2a=n2a+shift
  else
    m2a=n2b-shift
  end if
  m2b=m2a
 else
  if( side.eq.0 )then
    m3a=n3a+shift
  else
    m3a=n3b-shift
  end if
  m3b=m3a
 end if
#endMacro

#beginMacro fillExtrapolation4(k1,k2,k3,a1,a2,a3,a4,a5)
  a1(k1,k2,k3)= 1.
  a2(k1,k2,k3)=-4.
  a3(k1,k2,k3)= 6.
  a4(k1,k2,k3)=-4.
  a5(k1,k2,k3)= 1.
#endMacro
#beginMacro fillExtrapolation2(k1,k2,k3,a1,a2,a3)
  a1(k1,k2,k3)= 1.
  a2(k1,k2,k3)=-2.
  a3(k1,k2,k3)= 1.
#endMacro


#beginMacro extrapFirstGhost(SIDE)
! write(*,'(''+++++extrapFirstGhost [SIDE]: l1='',6i3)') l1a,l1b,l2a,l2b,l3a,l3b
#If #SIDE == "left"
 ! 1st ghost line on left:
 !       [  c  d  e  a  b ]
 !      i= -1 -0  1  2  3
 if( orderOfExtrapD.eq.4 )then
  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    c(i1,i2,i3)= 1.
    d(i1,i2,i3)=-4.
    e(i1,i2,i3)= 6.
    a(i1,i2,i3)=-4.
    b(i1,i2,i3)= 1.
  endLoop()
 else if( orderOfExtrapD.eq.2 )then
  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    c(i1,i2,i3)= 1.
    d(i1,i2,i3)=-2.
    e(i1,i2,i3)= 1.
    a(i1,i2,i3)= 0.
    b(i1,i2,i3)= 0.
  endLoop()
 else
   stop 63
 end if
#Elif #SIDE == "right" 
 ! 1st ghost line on right:
 !       [  d  e  a  b  c ]
 !   i=n+[ -3 -2 -1  0  1 ]
 if( orderOfExtrapD.eq.4 )then
  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    d(i1,i2,i3)= 1.
    e(i1,i2,i3)=-4.
    a(i1,i2,i3)= 6.
    b(i1,i2,i3)=-4.
    c(i1,i2,i3)= 1.
  endLoop()
 else if( orderOfExtrapD.eq.2 )then
  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    d(i1,i2,i3)= 0.
    e(i1,i2,i3)= 0.
    a(i1,i2,i3)= 1.
    b(i1,i2,i3)=-2.
    c(i1,i2,i3)= 1.
  endLoop()
 else
   stop 64
 end if
#Else
  stop 66
#End
#endMacro


#beginMacro oddSymmetryFirstGhost(SIDE)
#If #SIDE == "left"
 ! 1st ghost line on left:
 !       [  b  c  d  e  a ]
 !     i=[ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    b(i1,i2,i3)= 0.
    c(i1,i2,i3)= 1.
    d(i1,i2,i3)=-2.
    e(i1,i2,i3)= 1. 
    a(i1,i2,i3)= 0.
 endLoop()
#Elif #SIDE == "right" 
! 1st ghost line on right:
!       [  e  a  b  c  d ]
!  i=n+ [ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
   e(i1,i2,i3)= 0.
   a(i1,i2,i3)= 1. 
   b(i1,i2,i3)=-2.
   c(i1,i2,i3)= 1. 
   d(i1,i2,i3)= 0. 
 endLoop()
#Else
  stop 99
#End
#endMacro

#beginMacro evenSymmetryFirstGhost(SIDE)
#If #SIDE == "left"
 ! 1st ghost line on left:
 !       [  b  c  d  e  a ]
 !     i=[ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    b(i1,i2,i3)= 0.
    c(i1,i2,i3)= 1.
    d(i1,i2,i3)= 0.
    e(i1,i2,i3)=-1. 
    a(i1,i2,i3)= 0.
 endLoop()
#Elif #SIDE == "right" 
! 1st ghost line on right:
!       [  e  a  b  c  d ]
!  i=n+ [ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
   e(i1,i2,i3)= 0.
   a(i1,i2,i3)=-1. 
   b(i1,i2,i3)= 0.
   c(i1,i2,i3)= 1. 
   d(i1,i2,i3)= 0. 
 endLoop()
#Else
  stop 99
#End
#endMacro

#beginMacro evenSymmetrySecondGhost(SIDE)
#If #SIDE == "left"
 ! 2nd ghost line on left:
 !       [  c  d  e  a  b ]
 !     i=[ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    c(i1,i2,i3)= 0.
    d(i1,i2,i3)= 1.
    e(i1,i2,i3)= 0.
    a(i1,i2,i3)=-1.
    b(i1,i2,i3)= 0.
 endLoop()
#Elif #SIDE == "right" 
 ! 2nd ghost line on right:
 !       [  d  e  a  b  c ]
 !   i=n+[ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    d(i1,i2,i3)= 0.
    e(i1,i2,i3)=-1.
    a(i1,i2,i3)= 0.
    b(i1,i2,i3)= 1.
    c(i1,i2,i3)= 0.
 endLoop()
#Else
  stop 99
#End
#endMacro

#beginMacro mixedToSecondOrder(GRIDTYPE,SIDE)
#If #SIDE == "left"
 ! 2nd ghost line on left:
 !       [  c  d  e  a  b ]
 !     i=[ -2 -1  0  1  2 ]
 ! 1st ghost line on left:
 !       [  b  c  d  e  a ]
 !     i=[ -2 -1  0  1  2 ]
 ! kkc 081124 mucked with the quoting so that continuation lines were not
 !            broken in the latest gfortran and ifort compilers
 write(*,'(''lineSmoothOpt: mixed to 2nd orderBC: level''''='',i2)') level
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    c(i1,i2,i3)= 1.
    d(i1,i2,i3)= 0.
    e(i1,i2,i3)= 0.
    a(i1,i2,i3)= 0.
    b(i1,i2,i3)=-1.

    j1=i1+is1
    j2=i2+is2
    j3=i3+is3
    b(j1,j2,j3)= 0.
    c(j1,j2,j3)= 1.
    d(j1,j2,j3)= 0.
    e(j1,j2,j3)=-1.
    a(j1,j2,j3)= 0.
 endLoop()
#Elif #SIDE == "right" 
 ! 2nd ghost line on right:
 !       [  d  e  a  b  c ]
 !   i=n+[ -2 -1  0  1  2 ]
 ! 1st ghost line on right:
 !       [  e  a  b  c  d ]
 !  i=n+ [ -2 -1  0  1  2 ]
 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
    d(i1,i2,i3)=-1.
    e(i1,i2,i3)= 0.
    a(i1,i2,i3)= 0.
    b(i1,i2,i3)= 0.
    c(i1,i2,i3)= 1.

    j1=i1+is1
    j2=i2+is2
    j3=i3+is3
    e(j1,j2,j3)= 0.
    a(j1,j2,j3)=-1.
    b(j1,j2,j3)= 0.
    c(j1,j2,j3)= 1.
    d(j1,j2,j3)= 0.
 endLoop()
#Else
  stop 99
#End
#endMacro

c ============================================================================
c *OLD* Fourth-order Neumann equation and normal derivative of equation
c ============================================================================
#beginMacro neumannAndEquationRectangularOld(aa,bb,cc,dd,ee)
 nsign = 2*side-1
 if( nd.eq.2 )then
   diag=2.*a0*dx(axis)**3/(a1*nsign*dx(axisp1)**2)
 else
   diag=(2.*a0*dx(axis)**3/(a1*nsign))*(1./dx(axisp1)**2+1./dx(axisp2)**2)
 end if

 ! write(*,'('' neumannAndEquationRectangular: a0,a1,diag='',3f6.2)') a0,a1,diag

 beginLoopJ(l1a,l1b,l2a,l2b,l3a,l3b)
  i1=j1+2*is1 ! (i1,i2,i3) is the boundary point
  i2=j2+2*is2 ! (j1,j2,j3) is the 2nd ghost line 
  i3=j3+2*is3
  if( mask(i1,i2,i3).gt.0 ) then
    ! This is the operator for urrr*dr^3
    aa(j1,j2,j3)=-.5
    bb(j1,j2,j3)= 1.
    cc(j1,j2,j3)= diag
    dd(j1,j2,j3)=-1.
    ee(j1,j2,j3)= .5
  else if( mask(i1,i2,i3).lt.0 ) then
    fillExtrapolation4(j1,j2,j3,b,c,d,e,a)
  end if
 endLoop()

#endMacro


! This next file defines the macro call appearing in the next function
#Include "neumannEquationBC.h"
#Include "neumannEquationForcing.h"

c ============================================================================
c *OLD* Fourth-order Neumann equation and normal derivative of equation
c ============================================================================
#beginMacro neumannAndEquationCurvilinearOld(DIR,DIM,aa,bb,cc,dd,ee)
 nsign = 2*side-1

write(*,'('' neumannAndEquationCurvilinear: a0,a1='',2f6.2)') a0,a1

 beginLoopJ(l1a,l1b,l2a,l2b,l3a,l3b)
  i1=j1+2*is1 ! (i1,i2,i3) is the boundary point
  i2=j2+2*is2 ! (j1,j2,j3) is the 2nd ghost line 
  i3=j3+2*is3
  if( mask(i1,i2,i3).gt.0 ) then

    fourthOrderNeumannEquationBC(DIR,DIM)

   write(*,'(''LS:matrix: side,axis,axisp1,b0,b1,b2,b3 ='',2i2,i3,4e11.3)') side,axis,axisp1,b0,b1,b2,b3

    aa(j1,j2,j3)=-.5/dr(axis)**3
    bb(j1,j2,j3)= 1./dr(axis)**3
    cc(j1,j2,j3)= 2.*b2/dr(axisp1)**2 - b0
    dd(j1,j2,j3)=-1./dr(axis)**3
    ee(j1,j2,j3)= .5/dr(axis)**3
  else if( mask(i1,i2,i3).lt.0 ) then
    fillExtrapolation4(j1,j2,j3,b,c,d,e,a)
  end if
 endLoop()

#endMacro


#Include "neumannEquationBC.new.h"

c ============================================================================
c Fourth-order Neumann equation and normal derivative of equation
c ============================================================================
#beginMacro neumannAndEquationRectangular(aa,bb,cc,dd,ee)
 nsign = 2*side-1
 diag=(a0/(a1*nsign))*dx(axis)  ! u_xx * dx^3

 ! write(*,'('' neumannAndEquationRectangular: a0,a1,diag='',3f6.2)') a0,a1,diag

 beginLoopJ(l1a,l1b,l2a,l2b,l3a,l3b)
  i1=j1+2*is1 ! (i1,i2,i3) is the boundary point
  i2=j2+2*is2 ! (j1,j2,j3) is the 2nd ghost line 
  i3=j3+2*is3
  if( mask(i1,i2,i3).gt.0 ) then
    ! This is the operator for urrr*dr^3
    aa(j1,j2,j3)=-.5
    bb(j1,j2,j3)= 1.  + diag
    cc(j1,j2,j3)=   -2.*diag
    dd(j1,j2,j3)=-1.  + diag
    ee(j1,j2,j3)= .5
  else if( mask(i1,i2,i3).lt.0 ) then
    fillExtrapolation4(j1,j2,j3,b,c,d,e,a)
  end if
 endLoop()

#endMacro



c ============================================================================
c Fourth-order Neumann equation and normal derivative of equation
c    ***New version: urrr + br2*urrr - b0*u = gb
c ============================================================================
#beginMacro neumannAndEquationCurvilinear(DIR,DIM,aa,bb,cc,dd,ee)
 nsign = 2*side-1

write(*,'('' neumannAndEquationCurvilinear: a0,a1='',2f6.2)') a0,a1

 diag=0. ! for now
 beginLoopJ(l1a,l1b,l2a,l2b,l3a,l3b)
  i1=j1+2*is1 ! (i1,i2,i3) is the boundary point
  i2=j2+2*is2 ! (j1,j2,j3) is the 2nd ghost line 
  i3=j3+2*is3
  if( mask(i1,i2,i3).gt.0 ) then

    fourthOrderNeumannEquationBCNew(DIR,DIM)

   write(*,'(''LS:matrix: side,axis,axisp1,b0,b1,b3,br2 ='',2i2,i3,4e11.3)') side,axis,axisp1,b0,b1,b3,br2

    aa(j1,j2,j3)=-.5/dr(axis)**3
    bb(j1,j2,j3)= 1./dr(axis)**3    +br2/dr(axis)**2
    cc(j1,j2,j3)=                -2.*br2/dr(axis)**2 - b0 
    dd(j1,j2,j3)=-1./dr(axis)**3    +br2/dr(axis)**2
    ee(j1,j2,j3)= .5/dr(axis)**3
  else if( mask(i1,i2,i3).lt.0 ) then
    fillExtrapolation4(j1,j2,j3,b,c,d,e,a)
  end if
 endLoop()

#endMacro


      subroutine lineSmoothBuild( nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    nda1a,nda1b,nda2a,nda2b,nda3a,nda3b,
     &    ndc, coeff, cc, a, b, c, d, e, s, u, f, mask, rsxy, ipar, rpar, ndbcd,bcData )
c ===================================================================================
c  Line smooth -- build the tridiagonal/pentadiagonal matrices
c
c  a,b,c : for tridiagonal
c  a,b,c,d,e : for pentadiagonal
c ===================================================================================

      implicit none
      integer nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,ndc,ndbcd
      integer nda1a,nda1b,nda2a,nda2b,nda3a,nda3b

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real bcData(0:ndbcd-1,0:1,0:2)
      integer ipar(0:*)

      real a(nda1a:nda1b,nda2a:nda2b,nda3a:nda3b)
      real b(nda1a:nda1b,nda2a:nda2b,nda3a:nda3b)
      real c(nda1a:nda1b,nda2a:nda2b,nda3a:nda3b)
      real d(nda1a:nda1b,nda2a:nda2b,nda3a:nda3b)
      real e(nda1a:nda1b,nda2a:nda2b,nda3a:nda3b)

      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
      real coeff(0:ndc-1,nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real s(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real cc(0:*)
      real rpar(0:*)

c....local variables
      integer n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c
      integer sparseStencil,orderOfAccuracy,bcOptionD,bcOptionN
      integer i1,i2,i3,m1a,m1b,m1c,m2a,m2b,m2c,m3a,m3b,m3c,j1,j2,j3,is1,is2,is3,kd
      integer l1a,l1b,l2a,l2b,l3a,l3b
      integer grid,level

      integer direction,width,width2,md,mdm1,mdp1,mdm2,mdp2,side,md2,md2m1,md2p1,ms2
      integer axis,axisp1,axisp2
      integer bc(0:1,0:2),orderOfExtrapD,orderOfExtrapN
      real dx(0:2),dr(0:2)
      real dxi,dx2i,dxm,diag,nsign

      real a0,a1,a2,alpha1,alpha2
      real rxi,ryi,sxi,syi,rxr,rxs,sxr,sxs,ryr,rys,syr,sys
      real rxxi,ryyi,sxxi,syyi
      real rxrr,rxrs,rxss,ryrr,ryrs,ryss
      real sxrr,sxrs,sxss,syrr,syrs,syss
      real rxx,ryy,sxx,syy
      real rxxr,ryyr,rxxs,ryys, sxxr,syyr,sxxs,syys
      real rxNormI,rxNormIs,rxNormIss,rxNormIr,rxNormIrr
      real sxNormI,sxNormIs,sxNormIss,sxNormIr,sxNormIrr
      real n1,n1s,n1ss,n2,n2s,n2ss,n1r,n2r,n1rr,n2rr
      real an1,an1s,an1ss,an2,an2s,an2ss,an1r,an1rr,an2r,an2rs,an2rr
      real ff,ffs,ffr,g,gs,gss,gr,grr
      real c11,c11r,c11s,c12,c12r,c12s,c22,c22r,c22s,c1,c1r,c1s,c2,c2r,c2s,c0,c0r,c0s
      real b0,b1,b2,b3,bf,br2

      integer general, sparse, constantCoefficients, 
     &   sparseConstantCoefficients,sparseVariableCoefficients,
     &   variableCoefficients
      parameter( general=0, 
     &           sparse=1, 
     &           constantCoefficients=2,
     &           sparseConstantCoefficients=3,
     &           sparseVariableCoefficients=4,
     &           variableCoefficients=5 )

      integer dirichlet,neumann,mixed,equation,extrapolation,
     &        combination 

      parameter( 
     &     dirichlet=1,
     &     neumann=2,
     &     mixed=3,
     &     equation=4,
     &     extrapolation=5,
     &     combination=6 )

      integer rectangular,curvilinear
      parameter(
     &     rectangular=0,
     &     curvilinear=1)

      real rx,ry,rz,sx,sy,sz,tx,ty,tz

      declareDifferenceOrder2(u,RX)
      declareDifferenceOrder4(u,RX)

c....start statement functions 

      rx(i1,i2,i3)=rsxy(i1,i2,i3,0,0)
      ry(i1,i2,i3)=rsxy(i1,i2,i3,0,1)
      rz(i1,i2,i3)=rsxy(i1,i2,i3,0,2)
      sx(i1,i2,i3)=rsxy(i1,i2,i3,1,0)
      sy(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
      sz(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
      tx(i1,i2,i3)=rsxy(i1,i2,i3,2,0)
      ty(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
      tz(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
c     The next macro call will define the difference approximation statement functions
      defineDifferenceOrder2Components0(u,RX)
      defineDifferenceOrder4Components0(u,RX)
c....end statement function

      nd              =ipar(0)
      direction       =ipar(1)
      sparseStencil   =ipar(2)
      orderOfAccuracy =ipar(3)
      n1a             =ipar(4)
      n1b             =ipar(5)
      n1c             =ipar(6)
      n2a             =ipar(7)
      n2b             =ipar(8)
      n2c             =ipar(9)
      n3a             =ipar(10)
      n3b             =ipar(11)
      n3c             =ipar(12)
      bc(0,0)         =ipar(13)
      bc(1,0)         =ipar(14)
      bc(0,1)         =ipar(15)
      bc(1,1)         =ipar(16)
      bc(0,2)         =ipar(17)
      bc(1,2)         =ipar(18)
      bcOptionD       =ipar(19)  ! BC option for Dirichlet BC's
      bcOptionN       =ipar(20)  ! BC option for Neumann BC's
      orderOfExtrapD  =ipar(21)  ! for dirichlet
      orderOfExtrapN  =ipar(22)  ! for neumann

      level           =ipar(31)

      dx(0)           =rpar(0)
      dx(1)           =rpar(1)
      dx(2)           =rpar(2)
      dr(0)           =rpar(3) ! **** added 
      dr(1)           =rpar(4)
      dr(2)           =rpar(5)

c      write(*,'(''lineSmoothBuild: level,bcOptionD,bcOptionN='',3i2)') level,bcOptionD,bcOptionN

      axis=direction ! do axis=0,nd
      axisp1=mod(axis+1,nd)
      axisp2=mod(axis+2,nd)


      width = orderOfAccuracy+1   ! 3 or 5

      width2=3  ! for 2nd order

      ! md =  diagonal term
      if( nd.eq.2 )then
        md=(width*width)/2      ! 4 or 12 
        md2=(3*3)/2             ! for a 2nd order-accurate stencil
      else if( nd.eq.3 )then
        md=(width*width*width)/2 ! 13 or 62
        md2=(3*3*3)/2
      else
        md=width/2              ! 1
        md2=3/2
      end if

      ! form the tridiagonal matrices 
      if( direction.eq.0 )then
        mdm2=md-2
        mdm1=md-1
        mdp1=md+1
        mdp2=md+2

        md2m1=md2-1
        md2p1=md2+1

        ms2 = 1 ! shift for 2nd-order stencil in a fourth order operator
      else if( direction.eq.1 )then
        mdm2=md-2*width
        mdm1=md-  width
        mdp1=md+  width
        mdp2=md+2*width

        md2m1=md2-width2
        md2p1=md2+width2

        ms2 = width ! shift for 2nd-order stencil in a fourth order operator
      else if( direction.eq.2 )then
        mdm2=md-2*width**2
        mdm1=md-  width**2
        mdp1=md+  width**2
        mdp2=md+2*width**2

        md2m1=md2-width2**2
        md2p1=md2+width2**2

        ms2 = width*width ! shift for 2nd-order stencil in a fourth order operator
      else
        write(*,*) 'lineSmoothFactor:ERROR: invalid direction! '
      end if
      
      

      if( sparseStencil.eq.constantCoefficients .or. sparseStencil.eq.sparseConstantCoefficients ) then

        ! constant coefficients
        if( orderOfAccuracy.eq.2 )then

          beginLoop(n1a,n1b,n2a,n2b,n3a,n3b)
	    if( mask(i1,i2,i3) .gt. 0 ) then
	      a(i1,i2,i3)=cc(mdm1)
	      b(i1,i2,i3)=cc(md)
	      c(i1,i2,i3)=cc(mdp1)
c  write(*,'('' i1,i2,i3,a,b,c='',3i3,3f8.2)') i1,i2,i3,a(i1,i2,i3),b(i1,i2,i3),c(i1,i2,i3)
	    else 
	      a(i1,i2,i3)=0.
	      b(i1,i2,i3)=1.
	      c(i1,i2,i3)=0.
            end if
          endLoop()

        else if( orderOfAccuracy.eq.4 )then

          beginLoop(n1a,n1b,n2a,n2b,n3a,n3b)
	    if( mask(i1,i2,i3) .gt. 0 ) then
	      a(i1,i2,i3)=cc(mdm2)
	      b(i1,i2,i3)=cc(mdm1)
	      c(i1,i2,i3)=cc(md)
	      d(i1,i2,i3)=cc(mdp1)
	      e(i1,i2,i3)=cc(mdp2)
	    else 
	      a(i1,i2,i3)=0.
	      b(i1,i2,i3)=0.
	      c(i1,i2,i3)=1.
	      d(i1,i2,i3)=0.
	      e(i1,i2,i3)=0.
            end if
          endLoop()

        else
          write(*,*) 'lineSmoothBuild: invalid orderOfAccuracy=',orderOfAccuracy
          stop 6
        end if

        dxi = 1./dx(direction)
        dx2i = dxi*dxi
        dxm = 1./dx(0)**2 + 1./dx(1)**2
        if( nd.eq.3 )then
          dxm=dxm+1./dx(2)**2
        end if
 
        is1=0
        is2=0
        is3=0
        do side=0,1
          if( axis.eq.0 )then
            is1=1-2*side
          else if( axis.eq.1 )then
            is2=1-2*side
          else
            is3=1-2*side
          end if
          if( bc(side,axis).gt.0 )then
  	    if( bc(side,axis).eq.extrapolation )then

            ! **********************************************************
            ! ******************** Dirichlet BC ************************
            ! **********************************************************
  
              if( orderOfAccuracy.eq.2 )then

                getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,0)
                beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
  	         if( mask(i1,i2,i3) .gt. 0 ) then
  		  a(i1,i2,i3)=0.
  		  b(i1,i2,i3)=1.
  		  c(i1,i2,i3)=0.
                 end if
                endLoop()

              else if( orderOfAccuracy.eq.4 )then

                getBoundaryIndex(side,axis,l1a,l1b,l2a,l2b,l3a,l3b,0)  ! first ghost line
                getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,1)  ! boundary

                if( side.eq.0 )then
                 ! 1st ghost line on left:
                 !       [  c  d  e  a  b ]
                 !      i= -1 -0  1  2  3
                  if( bcOptionD.eq.0 )then
                   ! extrapolate
                   extrapFirstGhost(left)
                  else if( bcOptionD.eq.1 )then
                    ! use eqn to 2nd order on the boundary
                    beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
                     j1=i1+is1 ! (j1,j2,j3) is the boundary point
                     j2=i2+is2
                     j3=i3+is3
  	             if( mask(j1,j2,j3).gt.0 ) then
	              c(i1,i2,i3)= dx2i
	              d(i1,i2,i3)=-2.*dxm
	              e(i1,i2,i3)= dx2i
	              a(i1,i2,i3)= 0.
	              b(i1,i2,i3)= 0.
                     else if( mask(j1,j2,j3).lt.0 ) then
                       fillExtrapolation4(i1,i2,i3,c,d,e,a,b)
                     end if
                    endLoop()
                  else if( bcOptionD.eq.2 )then
                    oddSymmetryFirstGhost(left)
                  else
                    stop 71
                  end if
                  ! boundary on left:
                  !       [  b  c  d  e  a ]
                  !      i= -1  0  1  2  3
                  beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
  	           if( mask(i1,i2,i3) .gt. 0 ) then
	            b(i1,i2,i3)=0.
	            c(i1,i2,i3)=1.
	            d(i1,i2,i3)=0.
	            e(i1,i2,i3)=0.
	            a(i1,i2,i3)=0.
                   end if
                  endLoop()

                else ! side.eq.1

                  ! 1st ghost line on right:
                  !       [  d  e  a  b  c ]
                  !   i=n+[ -3 -2 -1  0  1 ]

                  if( bcOptionD.eq.0 )then
                    ! extrapolate
                   extrapFirstGhost(right)

                  else if( bcOptionD.eq.1 )then
                    ! use eqn to 2nd order on the boundary for first ghost
                    beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
                     j1=i1+is1 ! (j1,j2,j3) is the boundary point
                     j2=i2+is2
                     j3=i3+is3
  	             if( mask(j1,j2,j3).gt.0 ) then
	              d(i1,i2,i3)= 0.
	              e(i1,i2,i3)= 0.
	              a(i1,i2,i3)= dx2i
	              b(i1,i2,i3)=-2.*dxm
	              c(i1,i2,i3)= dx2i
                     else if( mask(j1,j2,j3).lt.0 ) then
                       fillExtrapolation4(i1,i2,i3,c,b,a,e,d)
                     end if
                    endLoop()
                  else if( bcOptionD.eq.2 )then
                    oddSymmetryFirstGhost(right)
                  else
                    stop 6
                  end if
                  ! boundary on right:
                  !       [  e  a  b  c  d ]
                  !   i=n+[ -3 -2 -1  0  1 ]
                  beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
  	           if( mask(i1,i2,i3) .gt. 0 ) then
	            e(i1,i2,i3)=0.
	            a(i1,i2,i3)=0.
	            b(i1,i2,i3)=0.
	            c(i1,i2,i3)=1.
	            d(i1,i2,i3)=0.
                   end if
                  endLoop()
                end if
              else
                write(*,*) 'lineSmoothBuild: invalid orderOfAccuracy=',orderOfAccuracy
                stop 6
              end if

            else if( axis.eq.direction )then ! only apply Neumman BC if axis==direction

              ! ********************************************************
              ! *****************NEUMANN RECTANGULAR *******************
              ! ********************************************************
  	      ! apply a neumann or mixed BC on this side.

              !    a0*u + a1*u.n = f
       	      a0=bcData(0,side,axis)
  	      a1=bcData(1,side,axis)
              if( a0.eq.0. .and. a1.eq.0. )then
                write(*,*) 'lineSmoothBuild:ERROR: a0 and a1 are both zero'
                write(*,*) 'side,axis,a0,a1,dxi=',side,axis,a0,a1,dxi
                stop 5
              end if	      
              if( orderOfAccuracy.eq.2 )then

               getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,0)  ! first ghost line

               if( side.eq.0 )then
                 !       [  b  c  a  ]
                 !         -1  0  1  
                beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                  j1=i1+is1 ! (j1,j2,j3) is the boundary point
                  j2=i2+is2
                  j3=i3+is3
  	          if( mask(j1,j2,j3).gt.0 ) then
  		    b(i1,i2,i3)= a1*dxi*.5
  		    c(i1,i2,i3)= a0
  		    a(i1,i2,i3)=-a1*dxi*.5
                  else if( mask(j1,j2,j3).lt.0 )then
                    fillExtrapolation2(i1,i2,i3,b,c,a)
                  end if
                endLoop()
  	       else
                 !       [  c  a  b  ]
                 !         -1  0  1  
                beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                  j1=i1+is1 ! (j1,j2,j3) is the boundary point
                  j2=i2+is2
                  j3=i3+is3
  	          if( mask(j1,j2,j3).gt.0 ) then
  		   c(i1,i2,i3)=-a1*dxi*.5
  		   a(i1,i2,i3)= a0
  		   b(i1,i2,i3)= a1*dxi*.5
                  else if( mask(j1,j2,j3).lt.0 )then
                    fillExtrapolation2(i1,i2,i3,c,a,b)
                  end if
                endLoop()
               end if

              else if( orderOfAccuracy.eq.4 )then

               getBoundaryIndex(side,axis,l1a,l1b,l2a,l2b,l3a,l3b,0)  ! 2nd ghost line
               getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,1)  ! first ghost line

               if( side.eq.0 )then
                 ! 2nd ghost line on left:
                 !       [  c  d  e  a  b ]
                 !     i=[ -2 -1  0  1  2 ]
                if( bcOptionN.eq.0 )then
                 ! extrapolate 2nd ghost
                 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
	            c(i1,i2,i3)= 1.
	            d(i1,i2,i3)=-4.
	            e(i1,i2,i3)= 6.
	            a(i1,i2,i3)=-4.
	            b(i1,i2,i3)= 1.
                 endLoop()
                else if( bcOptionN.eq.1 )then
                 ! u.xxx = 
                 neumannAndEquationRectangular(c,d,e,a,b)
c$$$                 beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
c$$$                  j1=i1+is1 ! (j1,j2,j3) is the boundary point
c$$$                  j2=i2+is2
c$$$                  j3=i3+is3
c$$$  	          if( mask(j1,j2,j3).gt.0 ) then
c$$$	           c(i1,i2,i3)=-1.
c$$$	           d(i1,i2,i3)= 2.
c$$$	           e(i1,i2,i3)= 0.
c$$$	           a(i1,i2,i3)=-2.
c$$$	           b(i1,i2,i3)= 1.
c$$$                  else if( mask(j1,j2,j3).lt.0 ) then
c$$$                    fillExtrapolation4(i1,i2,i3,b,c,d,e,a)
c$$$                  end if
c$$$                 endLoop()

                else if( bcOptionN.eq.2 )then
                  evenSymmetrySecondGhost(left)
                else if( bcOptionN.eq.3 )then
                  ! mixed BC for both first and second ghost lines
                  mixedToSecondOrder(rectangular,left)
                else 
                  stop 12
                end if
                 ! 1st ghost line on left:
                 !       [  b  c  d  e  a ]
                 !     i=[ -2 -1  0  1  2 ]
                if( bcOptionN.eq.0 .or. bcOptionN.eq.1 )then
                 beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                  j1=i1+is1 ! (j1,j2,j3) is the boundary point
                  j2=i2+is2
                  j3=i3+is3
  	          if( mask(j1,j2,j3).gt.0 ) then
	           b(i1,i2,i3)=-a1*dxi/12.    
	           c(i1,i2,i3)= a1*dxi*8./12. 
	           d(i1,i2,i3)= a0            
	           e(i1,i2,i3)=-a1*dxi*8./12. 
	           a(i1,i2,i3)= a1*dxi/12.    
                  else if( mask(j1,j2,j3).lt.0 ) then
                    fillExtrapolation4(i1,i2,i3,b,c,d,e,a)
                  end if
                 endLoop()
                else if( bcOptionN.eq.2 ) then
                  evenSymmetryFirstGhost(left)
                else if( bcOptionN.eq.3 )then
                  ! mixed BC alread done
                else
                  stop 14
                end if

  	       else ! side==1

                 ! 2nd ghost line on right:
                 !       [  d  e  a  b  c ]
                 !   i=n+[ -2 -1  0  1  2 ]
                 if( bcOptionN.eq.0 )then
                  ! extrapolate 2nd ghost
                  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
	             d(i1,i2,i3)= 1.
	             e(i1,i2,i3)=-4.
	             a(i1,i2,i3)= 6.
	             b(i1,i2,i3)=-4.
	             c(i1,i2,i3)= 1.
                  endLoop()
                 else if( bcOptionN.eq.1 )then
                  ! u.xxx = 
                  neumannAndEquationRectangular(d,e,a,b,c)

c$$$                  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
c$$$                   j1=i1+is1 ! (j1,j2,j3) is the boundary point
c$$$                   j2=i2+is2
c$$$                   j3=i3+is3
c$$$  	           if( mask(j1,j2,j3).gt.0 ) then
c$$$	            d(i1,i2,i3)=-1.
c$$$	            e(i1,i2,i3)= 2.
c$$$	            a(i1,i2,i3)= 0.
c$$$	            b(i1,i2,i3)=-2.
c$$$	            c(i1,i2,i3)= 1.
c$$$                   else if( mask(j1,j2,j3).lt.0 ) then
c$$$                     fillExtrapolation4(i1,i2,i3,b,c,d,e,a)
c$$$                   end if
c$$$                  endLoop()

                 else if( bcOptionN.eq.2 )then
                  evenSymmetrySecondGhost(right)
                 else if( bcOptionN.eq.3 )then
                   ! mixed BC for both first and second ghost lines
                   mixedToSecondOrder(rectangular,right)
                 else 
                   stop 12
                 end if

                 ! 1st ghost line on right:
                 !       [  e  a  b  c  d ]
                 !  i=n+ [ -2 -1  0  1  2 ]
                 if( bcOptionN.eq.0 .or. bcOptionN.eq.1 )then
                  beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                   j1=i1+is1 ! (j1,j2,j3) is the boundary point
                   j2=i2+is2
                   j3=i3+is3
  	           if( mask(j1,j2,j3).gt.0 ) then
	            e(i1,i2,i3)= a1*dxi/12.
	            a(i1,i2,i3)=-a1*dxi*8./12.
	            b(i1,i2,i3)= a0
	            c(i1,i2,i3)= a1*dxi*8./12.
	            d(i1,i2,i3)=-a1*dxi/12.    
                   else if( mask(j1,j2,j3).lt.0 ) then
                     fillExtrapolation4(i1,i2,i3,d,c,b,a,e)
                   end if
                  endLoop()
                 else if( bcOptionN.eq.2 ) then
                   evenSymmetryFirstGhost(right)
                 else if( bcOptionN.eq.3 )then
                   ! mixed BC alread done
                  else
                   stop 14
                 end if
               end if  ! side

              else
                write(*,*) 'lineSmoothBuild: invalid orderOfAccuracy=',orderOfAccuracy
                stop 6
              end if

            end if
          end if

        end do ! end do side
	      
      else
        ! **************************************
        ! ***** variable coefficients **********
        ! **************************************

        if( orderOfAccuracy.eq.2 )then
         beginLoop(n1a,n1b,n2a,n2b,n3a,n3b)
	  if( mask(i1,i2,i3) .gt. 0 ) then
	    a(i1,i2,i3)=coeff(mdm1,i1,i2,i3)
	    b(i1,i2,i3)=coeff(md  ,i1,i2,i3)
	    c(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
  	  else 
	    a(i1,i2,i3)=0.
	    b(i1,i2,i3)=1.
	    c(i1,i2,i3)=0.
	  end if
         endLoop()

        else if( orderOfAccuracy.eq.4 )then

         beginLoop(n1a,n1b,n2a,n2b,n3a,n3b)
	  if( mask(i1,i2,i3) .gt. 0 ) then
	    a(i1,i2,i3)=coeff(mdm2,i1,i2,i3)
	    b(i1,i2,i3)=coeff(mdm1,i1,i2,i3)
	    c(i1,i2,i3)=coeff(md  ,i1,i2,i3)
	    d(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
	    e(i1,i2,i3)=coeff(mdp2,i1,i2,i3)
  	  else 
	    a(i1,i2,i3)=0.
	    b(i1,i2,i3)=0.
	    c(i1,i2,i3)=1.
	    d(i1,i2,i3)=0.
	    e(i1,i2,i3)=0.
	  end if
         endLoop()

        else
          write(*,*) 'lineSmoothBuild: invalid orderOfAccuracy=',orderOfAccuracy
          stop 6
        end if

        ! fix up boundary conditions 
        axis=direction
        is1=0
        is2=0
        is3=0
        do side=0,1
          if( axis.eq.0 )then
            is1=1-2*side
          else if( axis.eq.1 )then
            is2=1-2*side
          else
            is3=1-2*side
          end if
          if( bc(side,direction).gt.0 .and. bc(side,direction).eq.extrapolation )then 

            ! ******************************************************************
            ! **********************DIRICHLET VAR*******************************
            ! ******************************************************************

            ! Add extrapolation BC's on "dirichlet" BC's
            if( orderOfAccuracy.eq.4 )then

              getBoundaryIndex(side,axis,l1a,l1b,l2a,l2b,l3a,l3b,0)  ! first ghost line
c      write(*,'(''+++++lineSmoothOpt: bcOptionD,l1='',i2,2x,6i3)') bcOptionD,l1a,l1b,l2a,l2b,l3a,l3b

              if( side.eq.0 )then
               ! 1st ghost line on left:
               !       [  c  d  e  a  b ]
               !      i= -1 -0  1  2  3
                if( bcOptionD.eq.0 )then
                 ! extrapolate
                  extrapFirstGhost(left)
                else if( bcOptionD.eq.1 )then
                  ! use eqn to 2nd order on the boundary
                  ! **** we could store the eqn coeff's in coeff
                  !  
                  !  20 21 22 23 24
                  !  15 16 17 18 19
                  !  10 11 12 13 14
                  !   5  6  7  8  9
                  !   0  1  2  3  4
                  !
                  ! The 2nd-order stencil is shifted to the right or left in the 4th order stencil
                  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
                   j1=i1+is1 ! (j1,j2,j3) is the boundary point
                   j2=i2+is2
                   j3=i3+is3
  	           if( mask(j1,j2,j3).gt.0 ) then
	            c(i1,i2,i3)=coeff(mdm1+ms2,i1,i2,i3)  
	            d(i1,i2,i3)=coeff(md  +ms2,i1,i2,i3)
	            e(i1,i2,i3)=coeff(mdp1+ms2,i1,i2,i3)
	            a(i1,i2,i3)=0.
	            b(i1,i2,i3)=0. 
                    ! write(*,'('' lineSmooth:BC:EQN2:i1,i2,mdm1,md,mdp1,c,d,e='',5i3,3e10.2)') i1,i2,mdm1,md,mdp1,c(i1,i2,i3),d(i1,i2,i3),e(i1,i2,i3)
                   else if( mask(j1,j2,j3).lt.0 ) then
                     fillExtrapolation4(i1,i2,i3,c,d,e,a,b)
                   end if
                  endLoop()
                else if( bcOptionD.eq.2 )then
                  oddSymmetryFirstGhost(left)
                else
                  stop 6
                end if
              else 
                ! 1st ghost line on right:
                !       [  d  e  a  b  c ]
                !   i=n+[ -3 -2 -1  0  1 ]
                if( bcOptionD.eq.0 )then
                 ! extrapolate
                  extrapFirstGhost(right)
                else if( bcOptionD.eq.1 )then
                  ! use eqn to 2nd order on the boundary
                  ! **** we could store the eqn coeff's in coeff
                  beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
                   j1=i1+is1 ! (j1,j2,j3) is the boundary point
                   j2=i2+is2
                   j3=i3+is3
  	           if( mask(j1,j2,j3).gt.0 ) then
	            d(i1,i2,i3)= 0.
	            e(i1,i2,i3)= 0.
	            a(i1,i2,i3)=coeff(mdm1-ms2,i1,i2,i3)  
	            b(i1,i2,i3)=coeff(md  -ms2,i1,i2,i3)
	            c(i1,i2,i3)=coeff(mdp1-ms2,i1,i2,i3)
                   else if( mask(j1,j2,j3).lt.0 ) then
                     fillExtrapolation4(i1,i2,i3,c,b,a,e,d)
                   end if
                  endLoop()
                 else if( bcOptionD.eq.2 )then
                   oddSymmetryFirstGhost(right)
                 else
                   stop 6
                end if
              end if

            end if

          else if( bc(side,direction).gt.0 .and. bc(side,direction).ne.extrapolation )then 

            ! ***********************************************************************
            ! *****************  Neumann or mixed BC  *******************************
            ! ***********************************************************************
  
            if( orderOfAccuracy.eq.2 )then

             getBoundaryIndex(side,direction,m1a,m1b,m2a,m2b,m3a,m3b,0)  ! first ghost line
             if( side.eq.0 )then
               !       [  b  c  a  ]
               !         -1  0  1  
              beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
               j1=i1+is1 ! (j1,j2,j3) is the boundary point
               j2=i2+is2
               j3=i3+is3
    	       if( mask(j1,j2,j3).gt.0 ) then
  	        b(i1,i2,i3)=coeff(mdm1,i1,i2,i3)  ! note: c
  	        c(i1,i2,i3)=coeff(md  ,i1,i2,i3)
  	        a(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
               else if( mask(j1,j2,j3).lt.0 ) then
                fillExtrapolation2(i1,i2,i3,b,c,a)
               end if
              endLoop()
             else
               !       [  c  a  b  ]
               !         -1  0  1  
              beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
               j1=i1+is1 ! (j1,j2,j3) is the boundary point
               j2=i2+is2
               j3=i3+is3
    	       if( mask(j1,j2,j3).gt.0 ) then
  	        c(i1,i2,i3)=coeff(mdm1,i1,i2,i3)  ! note: c
  	        a(i1,i2,i3)=coeff(md  ,i1,i2,i3)
  	        b(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
               else if( mask(j1,j2,j3).lt.0 ) then
                fillExtrapolation2(i1,i2,i3,c,a,b)
               end if
              endLoop()
             end if

            else if( orderOfAccuracy.eq.4 )then

              !    a0*u + a1*u.n = f
       	      a0=bcData(0,side,axis)
  	      a1=bcData(1,side,axis)
              if( a0.eq.0. .and. a1.eq.0. )then
                write(*,*) 'lineSmoothBuild:ERROR: a0 and a1 are both zero'
                write(*,*) 'side,axis,a0,a1,dxi=',side,axis,a0,a1,dxi
                stop 5
              end if	      

             getBoundaryIndex(side,axis,l1a,l1b,l2a,l2b,l3a,l3b,0)  ! 2nd ghost line
             getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,1)  ! first ghost line

             if( side.eq.0 )then
               ! 2nd ghost line on left:
               !       [  c  d  e  a  b ]
               !    i= [ -2 -1  0  1  2 ]
              if( bcOptionN.eq.0 )then
               ! extrapolate 2nd ghost
               beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
	          c(i1,i2,i3)= 1.
	          d(i1,i2,i3)=-4.
	          e(i1,i2,i3)= 6.
	          a(i1,i2,i3)=-4.
	          b(i1,i2,i3)= 1.
               endLoop()
              else if( bcOptionN.eq.1 )then
               ! u.rrr = 

               if( axis.eq.0 .and. nd.eq.2 )then
                 neumannAndEquationCurvilinear(R,2,c,d,e,a,b)
               else if( axis.eq.1 .and. nd.eq.2 )then
                 neumannAndEquationCurvilinear(S,2,c,d,e,a,b)
               else if( axis.eq.0 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(R,3,c,d,e,a,b)
               else if( axis.eq.1 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(S,3,c,d,e,a,b)
               else if( axis.eq.2 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(T,3,c,d,e,a,b)
               else
                 stop 88
               end if

              else if( bcOptionN.eq.2 )then
                 evenSymmetrySecondGhost(left)
              else if( bcOptionN.eq.3 )then
                ! mixed BC for both first and second ghost lines
                mixedToSecondOrder(curvilinear,left)
              else
                stop 14
              end if

              ! 1st ghost line on left:
              !       [  b  c  d  e  a ]
              !    i= [ -2 -1  0  1  2 ]
              if( bcOptionN.eq.0 .or. bcOptionN.eq.1 )then
               beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                j1=i1+is1 ! (j1,j2,j3) is the boundary point
                j2=i2+is2
                j3=i3+is3
    	        if( mask(j1,j2,j3).gt.0 ) then
                  b(i1,i2,i3)=coeff(mdm2,i1,i2,i3)
                  c(i1,i2,i3)=coeff(mdm1,i1,i2,i3)
                  d(i1,i2,i3)=coeff(md  ,i1,i2,i3)
                  e(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
                  a(i1,i2,i3)=coeff(mdp2,i1,i2,i3)
                else if( mask(j1,j2,j3).lt.0 ) then
                  fillExtrapolation4(i1,i2,i3,b,c,d,e,a)
                end if
               endLoop()
              else if( bcOptionN.eq.2 )then
                evenSymmetryFirstGhost(left)
              else if( bcOptionN.eq.3 )then
                ! mixed BC already done
              else
                stop 17
              end if

             else  ! side==1


              ! 2nd ghost line on right:
              !       [  d  e  a  b  c ]
              !  i=n+ [ -2 -1  0  1  2 ]
              if( bcOptionN.eq.0 )then
               ! extrapolate 2nd ghost
               beginLoop(l1a,l1b,l2a,l2b,l3a,l3b)
	          d(i1,i2,i3)= 1.
	          e(i1,i2,i3)=-4.
	          a(i1,i2,i3)= 6.
	          b(i1,i2,i3)=-4.
	          c(i1,i2,i3)= 1.
               endLoop()
              else if( bcOptionN.eq.1 )then
               ! u.rrr = 
               if( axis.eq.0 .and. nd.eq.2 )then
                 neumannAndEquationCurvilinear(R,2,d,e,a,b,c)
               else if( axis.eq.1 .and. nd.eq.2 )then
                 neumannAndEquationCurvilinear(S,2,d,e,a,b,c)
               else if( axis.eq.0 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(R,3,d,e,a,b,c)
               else if( axis.eq.1 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(S,3,d,e,a,b,c)
               else if( axis.eq.2 .and. nd.eq.3 )then
                 neumannAndEquationCurvilinear(T,3,d,e,a,b,c)
               else
                 stop 88
               end if

              else if( bcOptionN.eq.2 )then
                evenSymmetrySecondGhost(right)
              else if( bcOptionN.eq.3 )then
                ! mixed BC for both first and second ghost lines
                mixedToSecondOrder(curvilinear,right)
              else
                stop 14
              end if
              ! 1st ghost line on right:
              !       [  e  a  b  c  d ]
              !  i=n+ [ -2 -1  0  1  2 ]
              if( bcOptionN.eq.0 .or. bcOptionN.eq.1 )then
                beginLoop(m1a,m1b,m2a,m2b,m3a,m3b)
                 j1=i1+is1 ! (j1,j2,j3) is the boundary point
                 j2=i2+is2
                 j3=i3+is3
    	         if( mask(j1,j2,j3).gt.0 ) then
                  e(i1,i2,i3)=coeff(mdm2,i1,i2,i3)
                  a(i1,i2,i3)=coeff(mdm1,i1,i2,i3)
                  b(i1,i2,i3)=coeff(md  ,i1,i2,i3)
                  c(i1,i2,i3)=coeff(mdp1,i1,i2,i3)
                  d(i1,i2,i3)=coeff(mdp2,i1,i2,i3)
                 else if( mask(j1,j2,j3).lt.0 ) then
                   fillExtrapolation4(i1,i2,i3,d,c,b,a,e)
                 end if
                endLoop()
              else if( bcOptionN.eq.2 )then
                evenSymmetryFirstGhost(right)
              else if( bcOptionN.eq.3 )then
                ! mixed BC already done
              else
                stop 91
              end if

             end if
            else
              stop 6
            end if
  
          end if
        end do ! do side

      end if

      return
      end      

c Define the fourth-order accurate neumann BC which uses the normal derivative of the equation on the
c boundary. 
#beginMacro neumannAndEquationOld(FORCING,DIR,DIM)

 a0=bcData(0,side,axis)
 a1=bcData(1,side,axis)
 if( a1.eq.0. )then
   write(*,*) 'lineSmoothRHS:ERROR: a1=0!'
   stop 2
 end if
   
 if( gridType.eq.rectangular )then

c write(*,*) 'LSRHSt:4th-order neumann+EQN2 (rect)'
c   write(*,'(''LSRHS:4th neumannAndEqn (rect) nn2a,nn2b='',2i3,)') nn2a,nn2b

   drn=dx(axis)
   nsign = 2*side-1
   cf1= nsign*(drn**3)/3. !  030525: add nsign to cf1,cg1,cf2,cg2
   cg1= 2.*nsign*drn

   cf2=nsign*(drn**3)*8/3.
   cg2=nsign*4.*drn

   ! (i1,i2,i3) = boundary point
   ! (j1,j2,j3) = ghost point
   do i3=m3a,m3b,m3c
    j3=i3-is3
   do i2=m2a,m2b,m2c
    j2=i2-is2
   do i1=m1a,m1b,m1c
     if( mask(i1,i2,i3).gt.0 )then
      j1=i1-is1

    ! the rhs for the mixed BC is stored in the ghost point value of f
    defineNeumannEquationForcing(nn1a,nn1b,nn2a,nn2b,nn3a,nn3b,FORCING,rectangular,DIR)

    #If #DIR eq "R"
!     uss=uyy22r(i1,i2,i3)
      uss=(u(i1,i2+1,i3)+u(i1,i2-1,i3))/dx(1)**2 ! leave off diagonal term which goes into the matrix
    #Elif #DIR eq "S"
!      urr=uxx22r(i1,i2,i3)  ! need to 2nd-order
      urr=(u(i1+1,i2,i3)+u(i1-1,i2,i3))/dx(0)**2 ! leave off diagonal term which goes into the matrix
    #Else
      stop 7
    #End

c      ur=( g - a0*u(i1,i2,i3) )/(a1*nsign)
c      urrr= ffr - (gss - a0*uss )/(a1*nsign) ! 030525
   
c   write(*,'(''LNSM : i1,i2,i3,g,ffr,gss,u,uss ='',3i3,5f11.6)') i1,i2,i3,g,ffr,gss,u(i1,i2,i3),(u(i1,i2+1,i3)-2.*u(i1,i2,i3)+u(i1,i2-1,i3))/dx(1)**2
c  write(*,'('' i1,i2,i3,f,f,f='',3i3,4e11.2)') i1,i2,i3,f(i1,i2,i3),f(i1+2*is1,i2+2*is2,i3),f(i1+is1,i2+is2,i3)

     r(j1,j2,j3)=g 
    #If #DIR eq "R"
      r(i1-2*is1,i2,i3)=(ffr-(gss- a0*uss )/(a1*nsign))*dx(axis)**3  
    #Else
      r(i1,i2-2*is2,i3)=(ffs-(grr- a0*urr )/(a1*nsign))*dx(axis)**3  
    #End

    else
      r(j1,j2,j3)=0.
      r(i1-2*is1,i2-2*is2,i3-2*is3)=0.
    end if

  end do
  end do
  end do



 else
   ! **** curvilinear case ****

   if( axis.gt.1 )then
     write(*,*) 'lineSmoothRHS:ERROR: this option not implemented yet'
     write(*,*) 'axis=',axis
     stop 12
   end if

   ! write(*,*) 'lineSmoothRHS:4th-order neumann and L.n - DIR)'

   nsign = 2*side-1

   ! (i1,i2,i3) = boundary point
   ! (j1,j2,j3) = ghost point
   do i3=m3a,m3b,m3c
    j3=i3-is3
   do i2=m2a,m2b,m2c
    j2=i2-is2
   do i1=m1a,m1b,m1c
     if( mask(i1,i2,i3).gt.0 )then
      j1=i1-is1

    ! the rhs for the mixed BC is stored in the ghost point value of f
    defineNeumannEquationForcing(nn1a,nn1b,nn2a,nn2b,nn3a,nn3b,FORCING,curvilinear,DIR)

    fourthOrderNeumannEquationBC(DIR,DIM)

    #If #DIR eq "R"
      us=us4(i1,i2,i3)
!     uss=uss2(i1,i2,i3) 
      uss=(u(i1,i2+1,i3)+u(i1,i2-1,i3))/dr(1)**2 ! leave off diagonal term which goes into the matrix
      usss=usss2(i1,i2,i3)
    #Elif #DIR eq "S"
      ur=ur4(i1,i2,i3)
!      urr=urr2(i1,i2,i3)  ! need to 2nd-order
      urr=(u(i1+1,i2,i3)+u(i1-1,i2,i3))/dr(0)**2 ! leave off diagonal term which goes into the matrix
      urrr=urrr2(i1,i2,i3)
    #Else
      stop 7
    #End

!    write(*,'(''LSmOpt: i1,i2,i3,g,gs,gss,ff,ffr,ffs,uss ='',3i3,7e9.2)') i1,i2,i3,g,gs,gss,ff,ffr,ffs,uss2(i1,i2,i3)
!    write(*,'(''LSmOpt: an1,an2,c11,b0,b1,b2,b3,bf,b0+bf ='',9e10.2)') an1,an2,c11,b0,b1,b2,b3,bf,b0+bf

    #If #DIR eq "R"

      r(i1-is1,i2-is2,i3-is3)=g - an2*us
      r(i1-2*is1,i2-2*is2,i3-2*is3)=b1*us+b2*uss+b3*usss+bf 
    #Else

      ! write(*,'(''i='',i3,i3,'' us='',f6.2,'', approx='',f6.2)') i1,i2,us,us2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' urs='',f6.2,'', approx='',f6.2)') i1,i2,urs,urs2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' uss='',f6.2,'', approx='',f6.2)') i1,i2,uss,uss2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' usss='',f6.2,'', approx='',f6.2)') i1,i2,usss,usss2(i1,i2+is2,i3)

      r(i1-is1,i2-is2,i3-is3)=g- an1*ur
      r(i1-2*is1,i2-2*is2,i3-2*is3)=b1*ur+b2*urr+b3*urrr+bf 
    #End
   
    end if
  end do
  end do
  end do

 end if
#endMacro



c Define the fourth-order accurate neumann BC which uses the normal derivative of the equation on the
c boundary. 
#beginMacro neumannAndEquation(FORCING,DIR,DIM)

 a0=bcData(0,side,axis)
 a1=bcData(1,side,axis)
 if( a1.eq.0. )then
   write(*,*) 'lineSmoothRHS:ERROR: a1=0!'
   stop 2
 end if
   
 if( gridType.eq.rectangular )then

c write(*,*) 'LSRHSt:4th-order neumann+EQN2 (rect)'
c   write(*,'(''LSRHS:4th neumannAndEqn (rect) nn2a,nn2b='',2i3,)') nn2a,nn2b

   drn=dx(axis)
   nsign = 2*side-1

   ! (i1,i2,i3) = boundary point
   ! (j1,j2,j3) = ghost point
   do i3=m3a,m3b,m3c
    j3=i3-is3
   do i2=m2a,m2b,m2c
    j2=i2-is2
   do i1=m1a,m1b,m1c
     if( mask(i1,i2,i3).gt.0 )then
      j1=i1-is1

    ! the rhs for the mixed BC is stored in the ghost point value of f
    defineNeumannEquationForcing(nn1a,nn1b,nn2a,nn2b,nn3a,nn3b,FORCING,rectangular,DIR)

c   write(*,'(''LNSM : i1,i2,i3,g,ffr,gss,u,uss ='',3i3,5f11.6)') i1,i2,i3,g,ffr,gss,u(i1,i2,i3),(u(i1,i2+1,i3)-2.*u(i1,i2,i3)+u(i1,i2-1,i3))/dx(1)**2
c  write(*,'('' i1,i2,i3,f,f,f='',3i3,4e11.2)') i1,i2,i3,f(i1,i2,i3),f(i1+2*is1,i2+2*is2,i3),f(i1+is1,i2+is2,i3)

    r(j1,j2,j3)=g 
    #If #DIR eq "R"
      r(i1-2*is1,i2,i3)=(ffr-(gss- a0*ff )/(a1*nsign))*dx(axis)**3  
    #Else
      r(i1,i2-2*is2,i3)=(ffs-(grr- a0*ff )/(a1*nsign))*dx(axis)**3  
    #End

    else
      r(j1,j2,j3)=0.
      r(i1-2*is1,i2-2*is2,i3-2*is3)=0.
    end if

  end do
  end do
  end do



 else
   ! **** curvilinear case ****

   if( axis.gt.1 )then
     write(*,*) 'lineSmoothRHS:ERROR: this option not implemented yet'
     write(*,*) 'axis=',axis
     stop 12
   end if

   ! write(*,*) 'lineSmoothRHS:4th-order neumann and L.n - DIR)'

   nsign = 2*side-1

   ! (i1,i2,i3) = boundary point
   ! (j1,j2,j3) = ghost point
   do i3=m3a,m3b,m3c
    j3=i3-is3
   do i2=m2a,m2b,m2c
    j2=i2-is2
   do i1=m1a,m1b,m1c
     if( mask(i1,i2,i3).gt.0 )then
      j1=i1-is1

    ! the rhs for the mixed BC is stored in the ghost point value of f
    defineNeumannEquationForcing(nn1a,nn1b,nn2a,nn2b,nn3a,nn3b,FORCING,curvilinear,DIR)

    fourthOrderNeumannEquationBCNew(DIR,DIM)

    #If #DIR eq "R"
      us=us4(i1,i2,i3)
      usss=usss2(i1,i2,i3)
    #Elif #DIR eq "S"
      ur=ur4(i1,i2,i3)
      urrr=urrr2(i1,i2,i3)
    #Else
      stop 7
    #End

!    write(*,'(''LSmOpt: i1,i2,i3,g,gs,gss,ff,ffr,ffs,uss ='',3i3,7e9.2)') i1,i2,i3,g,gs,gss,ff,ffr,ffs,uss2(i1,i2,i3)
!    write(*,'(''LSmOpt: an1,an2,c11,b0,b1,b2,b3,bf,b0+bf ='',9e10.2)') an1,an2,c11,b0,b1,b2,b3,bf,b0+bf

    #If #DIR eq "R"

      r(i1-is1,i2-is2,i3-is3)=g - an2*us
      r(i1-2*is1,i2-2*is2,i3-2*is3)=b1*us+b3*usss+bf 

    #Else

      ! write(*,'(''i='',i3,i3,'' us='',f6.2,'', approx='',f6.2)') i1,i2,us,us2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' urs='',f6.2,'', approx='',f6.2)') i1,i2,urs,urs2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' uss='',f6.2,'', approx='',f6.2)') i1,i2,uss,uss2(i1,i2+is2,i3)
      ! write(*,'(''i='',i3,i3,'' usss='',f6.2,'', approx='',f6.2)') i1,i2,usss,usss2(i1,i2+is2,i3)

      r(i1-is1,i2-is2,i3-is3)=g- an1*ur
      r(i1-2*is1,i2-2*is2,i3-2*is3)=b1*ur+b3*urrr+bf 
    #End
   
    end if
  end do
  end do
  end do

 end if
#endMacro




      subroutine lineSmoothRHS( nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &    ndc, coeff, cc,  r, s, u, f, mask, rsxy, ipar, rpar, ndbcd,bcData )
c ===================================================================================
c  Line smooth assign RHS
c
c  r : rhs to be filled in
c  
c ===================================================================================

      implicit none
      integer nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,ndc,ndbcd
      integer nda1a,nda1b,nda2a,nda2b,nda3a,nda3b

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real bcData(0:ndbcd-1,0:1,0:2)
      integer ipar(0:*)


      real r(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
      real coeff(0:ndc-1,nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real s(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real cc(0:*)
      real rpar(0:*)

c....local variables
      integer n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c,sparseStencil,orderOfAccuracy,bcOptionD,bcOptionN
      integer i1,i2,i3,m1a,m1b,m1c,m2a,m2b,m2c,m3a,m3b,m3c,j1,j2,j3,is1,is2,is3
      integer l1a,l1b,l2a,l2b,l3a,l3b,kd,shift
      integer nn1a,nn1b,nn2a,nn2b,nn3a,nn3b

      integer direction,width,width2,md,mdm1,mdp1,mdm2,mdp2,side,axis,md2,md2m1,md2p1,ms2
      integer bc(0:1,0:2),orderOfExtrapD,orderOfExtrapN,gridType
      real dx(0:2),dr(0:2)
      real dxi,dx2i,dxm

      real nsign

      real drn
      real cf1,cf2,cg1,cg2
      real uu,us,uss,usss,ur,urr,urrr,urs,urss,urrs

      real a0,a1,a2,alpha1,alpha2
      real rxi,ryi,sxi,syi,rxr,rxs,sxr,sxs,ryr,rys,syr,sys
      real rxxi,ryyi,sxxi,syyi
      real rxrr,rxrs,rxss,ryrr,ryrs,ryss
      real sxrr,sxrs,sxss,syrr,syrs,syss
      real rxx,ryy,sxx,syy
      real rxxr,ryyr,rxxs,ryys, sxxr,syyr,sxxs,syys
      real rxNormI,rxNormIs,rxNormIss,rxNormIr,rxNormIrr
      real sxNormI,sxNormIs,sxNormIss,sxNormIr,sxNormIrr
      real n1,n1s,n1ss,n2,n2s,n2ss,n1r,n2r,n1rr,n2rr
      real an1,an1s,an1ss,an2,an2s,an2ss,an1r,an1rr,an2r,an2rs,an2rr
      real ff,ffs,ffr,g,gs,gss,gr,grr
      real c11,c11r,c11s,c12,c12r,c12s,c22,c22r,c22s,c1,c1r,c1s,c2,c2r,c2s,c0,c0r,c0s
      real b0,b1,b2,b3,bf,br2

      integer general, sparse, constantCoefficients, 
     &   sparseConstantCoefficients,sparseVariableCoefficients,
     &   variableCoefficients
      parameter( general=0, 
     &           sparse=1, 
     &           constantCoefficients=2,
     &           sparseConstantCoefficients=3,
     &           sparseVariableCoefficients=4,
     &           variableCoefficients=5 )

      integer dirichlet,neumann,mixed,equation,extrapolation,
     &        combination 

      parameter( 
     &     dirichlet=1,
     &     neumann=2,
     &     mixed=3,
     &     equation=4,
     &     extrapolation=5,
     &     combination=6 )

      integer rectangular,curvilinear
      parameter(
     &     rectangular=0,
     &     curvilinear=1)

      real rx,ry,rz,sx,sy,sz,tx,ty,tz
      declareDifferenceOrder2(u,RX)
      declareDifferenceOrder4(u,RX)
c....start statement functions 

      rx(i1,i2,i3)=rsxy(i1,i2,i3,0,0)
      ry(i1,i2,i3)=rsxy(i1,i2,i3,0,1)
      rz(i1,i2,i3)=rsxy(i1,i2,i3,0,2)
      sx(i1,i2,i3)=rsxy(i1,i2,i3,1,0)
      sy(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
      sz(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
      tx(i1,i2,i3)=rsxy(i1,i2,i3,2,0)
      ty(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
      tz(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
c     The next macro call will define the difference approximation statement functions
      defineDifferenceOrder2Components0(u,RX)
      defineDifferenceOrder4Components0(u,RX)
c....end statement function

c      write(*,9000) (((f(i1,i2,i3),i1=nd1a,nd1b),i2=nd2a,nd2b),i3=nd3a,nd3b)
c 9000 format(<nd1b-nd1a+1>(f4.1,1x))

      nd              =ipar(0)
      direction       =ipar(1)
      sparseStencil   =ipar(2)
      orderOfAccuracy =ipar(3)
      n1a             =ipar(4)
      n1b             =ipar(5)
      n1c             =ipar(6)
      n2a             =ipar(7)
      n2b             =ipar(8)
      n2c             =ipar(9)
      n3a             =ipar(10)
      n3b             =ipar(11)
      n3c             =ipar(12)
      bc(0,0)         =ipar(13)
      bc(1,0)         =ipar(14)
      bc(0,1)         =ipar(15)
      bc(1,1)         =ipar(16)
      bc(0,2)         =ipar(17)
      bc(1,2)         =ipar(18)
      bcOptionD       =ipar(19)  ! BC option for Dirichlet BC's
      bcOptionN       =ipar(20)  ! BC option for Neumann BC's
      orderOfExtrapD  =ipar(21)  ! for dirichlet
      orderOfExtrapN  =ipar(22)  ! for neumann
      gridType        =ipar(23)  ! **** added
      nn1a            =ipar(24)  ! these define the full bounds assuming no zebra solve, 
      nn1b            =ipar(25)  ! end points are used to determine when one-sided differences of f and g are needed
      nn2a            =ipar(26)
      nn2b            =ipar(27)
      nn3a            =ipar(28)
      nn3b            =ipar(29)


      dx(0)           =rpar(0)
      dx(1)           =rpar(1)
      dx(2)           =rpar(2)
      dr(0)           =rpar(3) ! **** added 
      dr(1)           =rpar(4)
      dr(2)           =rpar(5)

      axis=direction ! we only fill in BC's along the direction of the line solve
      is1=0
      is2=0
      is3=0
      do side=0,1
        if( axis.eq.0 )then
          is1=1-2*side
        else if( axis.eq.1 )then
          is2=1-2*side
        else
          is3=1-2*side
        end if
        ! write(*,'(''LS:RHS: side,axis,bc,bcOptionN='',4i3)') side,axis,bc(side,axis),bcOptionN
        if( bc(side,axis).eq.equation .and. bcOptionN.eq.1 )then
          shift=2 ! shift to boundary
          getBoundaryIndex(side,axis,m1a,m1b,m2a,m2b,m3a,m3b,shift) ! boundary 
          m1c=n1c
          m2c=n2c
          m3c=n3c

          if( axis.eq.0 .and. nd.eq.2 )then
            neumannAndEquation(forcing,R,2)
          else if( axis.eq.1 .and. nd.eq.2 )then
            neumannAndEquation(forcing,S,2)
c         else if( axis.eq.0 .and. nd.eq.3 )then
c           neumannAndEquation(forcing,R,3)
c         else if( axis.eq.1 .and. nd.eq.3 )then
c           neumannAndEquation(forcing,S,3)
c         else if( axis.eq.2 .and. nd.eq.3 )then
c             neumannAndEquation(forcing,T,3)
          else
            stop 10
          end if
        end if
      end do

      return 
      end


#beginMacro beginLoop()
do i3=n3a,n3b,n3c
do i2=n2a,n2b,n2c
do i1=n1a,n1b,n1c
#endMacro
#beginMacro endLoop()
end do
end do
end do
#endMacro

#beginMacro computeOmega2d(k1,k2,k3)
 c1=abs(c(m1a,k1,k2,k3)+c(m1b,k1,k2,k3))  
 c2=abs(c(m2a,k1,k2,k3)+c(m2b,k1,k2,k3))
 ! At the end points the coefficients may be zero
!  if( c1+c2 .gt. 0. )then
   cmax=1.-min(c1,c2)/(c1+c2)
!  else
!    cmax=.5
!  end if
 omega=variableOmegaFactor/(1.+sqrt(1.-cmax**2))
 ! omega=1.072*(.666-cmax)/.166 + 1.145*(cmax-.5)/.166
 ! write(*,'(''k1,k2='',2i3,'' c1,c2,cmax,omega='',4(f9.4,1x))') k1,k2,c1,c2,cmax,omega
#endMacro

#beginMacro computeOmega2dFourthOrder(k1,k2,k3)
 c1=abs(c(m1a,k1,k2,k3)+c(m1b,k1,k2,k3))  
 c2=abs(c(m2a,k1,k2,k3)+c(m2b,k1,k2,k3))
 ! At the end points the coefficients may be zero
!  if( c1+c2 .gt. 0. )then
   cmin=min(c1,c2)/(c1+c2)
!  else
!    cmin=.5
!  end if
 omega=(1.23-.16*cmin)*variableOmegaFactor  ! w(.5)=1.15 w(.25)=1.19 -- this is for a W[2,1] ***
 ! write(*,'(''k1,k2='',2i3,'' cmin,omega='',2(f7.4,1x))') k1,k2,cmin,omega
#endMacro

      subroutine lineSmoothUpdate( nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &     u, defect, mask, ndc, c, ipar, rpar )
c ===================================================================================
c  Line smooth assign RHS
c
c  r : rhs to be filled in
c  
c ===================================================================================

      implicit none
      integer nd,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,ndc

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer ipar(0:*)

      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real defect(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real c(1:ndc,nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real rpar(0:*)

c................ local
      integer orderOfAccuracy,i1,i2,i3,variableCoefficients,direction,useOmega
      integer n1a,n1b,n1c,n2a,n2b,n2c,n3a,n3b,n3c
      integer m1a,m1b,m2a,m2b,width,wBase,k1,k1Old
      integer j1,j2,j3,shift3

      real omega,omegam,variableOmegaFactor,c1,c2,cmin,cmax

c............. start statement function
      integer m123
      m123(i1,i2,i3)=i1-wBase+width*(i2-wBase+width*(i3-wBase))+1  ! index into 3d stencil, 
c............. end statement function

      n1a                 =ipar(0)
      n1b                 =ipar(1)
      n1c                 =ipar(2)
      n2a                 =ipar(3)
      n2b                 =ipar(4)
      n2c                 =ipar(5)
      n3a                 =ipar(6)
      n3b                 =ipar(7)
      n3c                 =ipar(8)
      direction           =ipar(9)
      orderOfAccuracy     =ipar(10)
      variableCoefficients=ipar(11)
      useOmega            =ipar(12)

      omega               =rpar(0)
      variableOmegaFactor =rpar(1)

      if( orderOfAccuracy.eq.2 )then
        width=3
        wBase=-1
      else
        width=5
        wBase=-2
      end if
      
      ! write(*,'("lineSmoothUpdate: direction,variableCoefficients,useOmega=",3i3," omega=",f6.3)') direction,variableCoefficients,useOmega,omega

      if( useOmega.eq.0 )then
        
        beginLoop()
	  if( mask(i1,i2,i3).ge.0 )then
	    u(i1,i2,i3)=defect(i1,i2,i3)
          end if
        endLoop()

      else if( useOmega.eq.1 .or. variableCoefficients.eq.0 )then
        ! use constant omega or constant coefficients -> use constant omega
        omegam=1.-omega
        beginLoop()
	  if( mask(i1,i2,i3).ge.0 )then
	    u(i1,i2,i3)=omegam*u(i1,i2,i3)+omega*defect(i1,i2,i3)
          end if
        endLoop()

      else 
        if( variableCoefficients.ne.1 )then
          write(*,'("ERROR: variableCoefficients.ne.1")')
          stop 123
        end if

        ! use variable omega and variable coeff -> use variable omega
    
        ! (m1a,m1b) and (m2a,m2b) : use these indicies to determine the size of the coefficients
        ! in the two tangential directions to direction -- used in the calculation of omega
        if( direction.eq.0 )then
          m1a=m123( 0,-1, 0)  
          m1b=m123( 0, 1, 0)
          m2a=m123( 0, 0,-1)
          m2b=m123( 0, 0, 1)
        else if( direction.eq.1 )then
          m1a=m123(-1, 0, 0)
          m1b=m123( 1, 0, 0)
          m2a=m123( 0, 0,-1)
          m2b=m123( 0, 0, 1)
        else if( direction.eq.2 )then
          m1a=m123(-1, 0, 0)
          m1b=m123( 1, 0, 0)
          m2a=m123( 0,-1, 0)
          m2b=m123( 0, 1, 0)
        else
          stop 55
        end if

        ! write(*,'(" direction=",i1,", ndc=",i3,", m1a,m1b,m2a,m2b=",6i3)') direction,ndc,m1a,m1b,m2a,m2b

        shift3=orderOfAccuracy/2
        if( nd.eq.2 )then
          shift3=0
        end if
        if( orderOfAccuracy.eq.2 )then
          do i3=n3a,n3b,n3c
            j3=max(n3a+shift3,min(n3b-shift3,i3)) ! avoid boundaries for omega -- coefficients could be zero (BC)
          do i2=n2a,n2b,n2c
            j2=max(n2a+1,min(n2b-1,i2)) 
          do i1=n1a,n1b,n1c
	    if( mask(i1,i2,i3).ge.0 )then
              j1=max(n1a+1,min(n1b-1,i1)) 
              computeOmega2d(j1,j2,j3)
	      u(i1,i2,i3)=(1.-omega)*u(i1,i2,i3)+omega*defect(i1,i2,i3)
            end if
          endLoop()
        else
          do i3=n3a,n3b,n3c
            j3=max(n3a+shift3,min(n3b-shift3,i3)) ! avoid boundaries for omega -- coefficients could be zero (BC)
          do i2=n2a,n2b,n2c
            j2=max(n2a+2,min(n2b-2,i2)) 
          do i1=n1a,n1b,n1c
	    if( mask(i1,i2,i3).ge.0 )then
              j1=max(n1a+2,min(n1b-2,i1)) 
              computeOmega2dFourthOrder(j1,j2,j3)
	      u(i1,i2,i3)=(1.-omega)*u(i1,i2,i3)+omega*defect(i1,i2,i3)
            end if
          endLoop()
        end if
      end if

      return 
      end
