#ifndef CONTOUR_SURFACE_H
#define CONTOUR_SURFACE_H

#include "GL_GraphicsInterface.h"

// This class holds a contour surface for the 3D contour plotter
class ContourSurface
{
 public:

  ContourSurface(){ init(); }

  // init an inactive surface.
  void init() 
  { 
    surfaceType=unknownSurfaceType; surfaceStatus=inactive; side=-1; axis=-1, index=-1; 
    grid=-1; value=0.;
  }

  enum SurfaceTypeEnum
  {
    unknownSurfaceType,
    coordinateSurface,
    contourPlane,
    isoSurface
  } surfaceType;

  enum SurfaceStatusEnum
  {
    inactive,
    notBuilt,
    built
  } surfaceStatus;
  
  // destroy data and reset to inactive:
  void destroy(){ csData.redim(0); init(); } 

  RealArray csData;
  
  int side,axis,index,grid;  // for coordinate surfaces

  real normal[3], point[3];       // for contour planes

  real value;  // for iso-surface
};
#endif
