#ifndef GRID_STATISTICS_H
#define GRID_STATISTICS_H

#include "CompositeGrid.h"

class GridStatistics
{
public:

enum MaskOptionEnum
{
  ignoreMask,
  positiveMask,
  nonZeroMask
};


static void 
printGridStatistics(CompositeGrid & cg, FILE *file=stdout );
static void
printGridStatistics(GridCollection & gc, FILE *file=stdout );
static void 
printGridStatistics(MappedGrid & mg, FILE *file=stdout, int grid=0, int *ipar=NULL, real *rpar=NULL );

static void 
getGridSpacing(MappedGrid & mg, real dsMin[3], real dsAve[3], real dsMax[3], MaskOptionEnum maskOption=ignoreMask );

static void 
getGridSpacingAndNumberOfPoints(MappedGrid & mg, real dsMin[3], real dsAve[3], real dsMax[3],
                                int & numberOfPoints, MaskOptionEnum maskOption=ignoreMask );

static void 
getNumberOfPoints(GridCollection & gc, int & totalNumberOfGridPoints, MaskOptionEnum maskOption=ignoreMask );

static void 
getNumberOfPoints(MappedGrid & mg, int & numberOfPoints, MaskOptionEnum maskOption=ignoreMask );

private:

// The constructure should never be called
GridStatistics();
~GridStatistics();

};


#endif
