#ifndef MULTIGRID_EQUATION_SOLVER_H
#define MULTIGRID_EQUATION_SOLVER_H

//
//  Multigrid solver for Oges
// 

//kkc 040415 #include <iostream.h>
#include "OvertureDefine.h"
#include OV_STD_INCLUDE(iostream)

#include <math.h>
#include <assert.h>

#include "EquationSolver.h"
#include "Ogmg.h"


class MultigridEquationSolver : public EquationSolver
{
 public:
  MultigridEquationSolver(Oges & oges_);
  virtual ~MultigridEquationSolver();

  virtual int solve(realCompositeGridFunction & u,
		    realCompositeGridFunction & f);

  virtual int setEquationAndBoundaryConditions( OgesParameters::EquationEnum equation, 
                                                CompositeGridOperators & op,
                                                const IntegerArray & boundaryConditions,
						const RealArray & bcData, 
                                                RealArray & constantCoeff = Overture::nullRealArray(),
                                                realCompositeGridFunction *variableCoeff=NULL );

  virtual int printStatistics( FILE *file = stdout ) const;   // output any relevant statistics 

  virtual real sizeOf( FILE *file=NULL ); // return number of bytes allocated 

 protected:

  Ogmg ogmg;
  
};


#endif
