*
*  Grid for an airfoil using the hyperbolic grid generator
*
$camber=0.; $angle=-2.; 
$interpType="explicit for all grids";
*
$factor="1"; $grid="airfoil1.hdf"; 
* $factor="2"; $grid="airfoil2.hdf"; 
* $factor="4"; $grid="airfoil4.hdf"; 
* $factor="8"; $grid="airfoil8.hdf"; 
* $factor="16"; $grid="airfoil16.hdf"; 
* $factor="32"; $grid="airfoil32.hdf"; 
*
* $factor="1"; $grid="airfoilWithCamber1.hdf"; $camber=.1; $angle=2.; 
* $factor="2"; $grid="airfoilWithCamber2.hdf"; $camber=.1; $angle=2.; 
*
$ds=3./45./$factor; 
*
create mappings
  *
  * First make a back-ground grid  
  *
  rectangle
    mappingName
      backGround
    set corners
      $xa=-1.5; $xb=2.5; $ya=-1.5; $yb=1.5; 
      $xa $xb $ya $yb
*      -1.5 2.5  -1.5 1.5 
    lines
     $nx = int( ($xb-$xa)/$ds+1.5 );
     $ny = int( ($yb-$ya)/$ds+1.5 );
     $nx $ny 
*     61 45 
  exit
  * make the NACA airfoil (curve)
  Airfoil
    airfoil type
      naca
    camber 
      $camber
    lines
     $arcLength=2.5 + 3./$factor; # include more points on coarser grids
     $ns = int( $arcLength/$ds+1.5 );
     $ns 
*    91
    mappingName
      airfoil-curve
    exit
*   -- rotate the airfoil curve 
  rotate/scale/shift
    transform which mapping?
    airfoil-curve
    rotate
      $angle
      0 0
    mappingName
      airfoil-curve-rotated
    exit
*
  hyperbolic
*
    BC: left trailing edge
    BC: right trailing edge
*
    $radialDist=.35/$factor; $nr = 21;
    lines to march $nr
    distance to march $radialDist
*   lines to march 21
*   distance to march .45
*    uniform dissipation coefficient .01
    geometric stretch factor 1.2
    generate
    smoothing...
    GSM:BC: left periodic
    GSM:BC: right periodic
    GSM:BC: top smoothed
    GSM:number of iterations 5
    GSM:smooth grid
    GSM:smooth grid
* 
* pause
    mappingName
     airfoil
    boundary conditions
      -1 -1 1 0
    exit
 exit
*
* make an overlapping grid
*
generate an overlapping grid
    backGround
    airfoil
  done
  change parameters
    ghost points
      all
      2 2 2 2 2 2
    interpolation type
      $interpType
  exit
  * pause
  compute overlap
  * pause
exit
*
save an overlapping grid
$grid
naca
exit
