*
* Annulus (taking arguments)
*
*
* usage: ogen [noplot] annulusArg -factor=<num> -order=[2/4/6/8] -interp=[e/i]
* 
* examples:
*     ogen noplot annulusArg -order=2 -factor=1 
*     ogen noplot annulusArg -order=2 -factor=2 
*     ogen noplot annulusArg -order=2 -factor=4 
*     ogen noplot annulusArg -order=2 -factor=8
* 
$order=2; $factor=1; $interp="e"; # default values
$orderOfAccuracy = "second order"; $ng=2; $interpType = "explicit for all grids";
$name=""; 
* 
* get command line arguments
GetOptions( "order=i"=>\$order,"factor=f"=> \$factor,"interp=s"=> \$interp,"name=s"=> \$name);
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=2; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=6; }
if( $interp eq "e" ){ $interpType = "explicit for all grids"; }
* 
$suffix = ".order$order"; 
if( $name eq "" ){$name = "annulus" . "$factor" . $suffix . ".hdf";}
* 
$ds=.1/$factor;
* 
create mappings
*
Annulus
  $innerRad=.5; $outerRad = 1.;
  inner and outer radii
    $innerRad $outerRad
  lines
    $nTheta = int( 2.*3.1415*($innerRad+$outerRad)*.5/$ds + 1.5 );
    $nr = int( ($outerRad-$innerRad)/$ds + 2.5 );
    $nTheta $nr
  boundary conditions
    -1 -1 1 1
  mappingName
    annulus
exit
*
exit
generate an overlapping grid
    annulus
  done
  change parameters
    * choose implicit or explicit interpolation
    interpolation type
      $interpType
    order of accuracy 
      $orderOfAccuracy
    ghost points
      all
      $ng $ng $ng $ng $ng $ng 
  exit
*  display intermediate results
  compute overlap
**  display computed geometry
  exit
*
* save an overlapping grid
save a grid (compressed)
$name
annulus
exit

