*
*  Grid for an orthographic projection on a sphere
*
*
* usage: ogen [noplot] orthoSphere -factor=<num> -order=[2/4/6/8] 
* 
* examples:
*     ogen noplot orthoSphere -factor=1 -order=2
*
$order=2; $factor=1; $interp="i"; # default values
$orderOfAccuracy = "second order"; $ng=2; 
$name=""; $xa=-2.; $xb=2.; $ya=-2.; $yb=2.; 
* 
* get command line arguments
GetOptions( "order=i"=>\$order,"factor=f"=> \$factor,"xa=f"=> \$xa,"xb=f"=> \$xb,"ya=f"=> \$ya,"yb=f"=> \$yb,\
            "interp=s"=> \$interp,"name=s"=> \$name);
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=2; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=6; }
* 
$suffix = ".order$order"; 
if( $name eq "" ){$name = "orthoSphere" . "$factor" . $suffix . ".hdf";}
* 
$ds=.1/$factor;
$pi=4.*atan2(1.,1.);
* *
*
create mappings
* first make a sphere
Sphere
exit
*
* now make a mapping for the north pole
*
reparameterize
  orthographic
    specify sa,sb
    * 2.5 2.5
      1.75 1.75 
  exit
  lines
    $nx = int( 1.4/$ds + 1.5 );
    $ny = int( 1.4/$ds + 1.5 );
    $nz = int(  .5/$ds + 1.5 );
    $nx $ny $nz 
*   15 15 7   
  boundary conditions
    1 1 1 1 1 1
  mappingName
    north-pole
exit
exit
*
generate an overlapping grid
  north-pole
  done
  change parameters
    order of accuracy 
      $orderOfAccuracy
    ghost points
      all
      $ng $ng $ng $ng $ng $ng 
  exit
  compute overlap
exit
save an overlapping grid
$name
orthoSphere
exit
