* 
*  Quarter of a sphere in a box
* 
$xa=-2.5; $xb=2.5; $ya=0.; $yb=2.5; $za=0.; $zb=2.5; 
* 
$interpType="implicit for all grids";
* 
* $factor=.5; $name="quarterSphere0e.hdf"; $interpType="explicit for all grids"; 
* $factor=1.; $name="quarterSphere1e.hdf"; $interpType="explicit for all grids"; 
$factor=2.; $name="quarterSphere2e.hdf"; $interpType="explicit for all grids";
* $factor=3.; $name="quarterSphere3e.hdf"; $interpType="explicit for all grids";
* $factor=3.; $name="quarterSphere3i.hdf"; $interpType="implicit for all grids";
* $factor=4.; $name="quarterSphere4e.hdf"; $interpType="explicit for all grids";
* 16M pts:
* $factor=8.; $name="quarterSphere8e.hdf"; $interpType="explicit for all grids";
* 130M pts:  
* $factor=16.; $name="quarterSphere16e.hdf"; $interpType="explicit for all grids";
* $factor=1.; $name="quarterSphere.hdf"; 
* $factor=2.; $name="quarterSphere2.hdf"; 
* $factor=4.; $name="quarterSphere4.hdf"; 
*
$ds=1./10./$factor;
$pi=3.141592653;
*
create mappings 
  * 
  Box 
    set corners 
*     0. 2.5 0. 2.5 -4. 5.
      $xa $xb $ya $yb $za $zb
    lines 
     $nx = int( ($xb-$xa)/$ds+1.5 );
     $ny = int( ($yb-$ya)/$ds+1.5 );
     $nz = int( ($zb-$za)/$ds+1.5 );
     $nx $ny $nz 
*      21 21 71   51 51 91
    boundary conditions
      3 4 2 2 2 2
    share
      0 0 3 0 2 0
    mappingName
      channel
    exit
  * 
  sphere
    $rad=1.; $deltaRad=6.*$ds; 
    inner radius
      $rad
    outer radius
      $outerRad=$rad+$deltaRad;
      $outerRad
    lines
      $nPhi = int( $pi*$rad/$ds+1.5 );
      $nTheta = int( 2.*$pi*$rad/$ds+1.5 );
      $nr = int( $deltaRad/$ds + 1.5 );
      $nPhi $nTheta $nr
* 
    share
      0 0 0 0 1 0
    mappingName
      sphere-unrotated
    exit
* 
  rotate/scale/shift
    rotate
      -90 1
      0 0 0
    mappingName
      sphere-rotated
* pause
    exit
* 
  reparameterize
    transform which mapping?
      sphere-rotated
    orthographic
      choose north or south pole
      1
      specify sa,sb
        $sa=.6; $sb=$sa; 
        $sa $sb
      exit
    mappingName
    northPole-full
    exit
* 
  reparameterize
    transform which mapping?
      sphere-rotated
    orthographic
      choose north or south pole
        -1
      specify sa,sb
        $sa $sb
      exit
    mappingName
    southPole-full
    share
      0 0 0 0 1 0
    exit
*
  reparameterize
    transform which mapping?
      northPole-full
    restrict parameter space
      set corners
      .5 1. .5 1. 0. 1.
      exit
    boundary conditions
      2 0 2 0 1 0
    share
      2 0 3 0 1 0
    lines 
      $nx = int( .2*$pi*$rad/$ds+1.5 ); $ny=$nx; 
      $nx $ny $nr
    mappingName
      northPole
    exit
*
  reparameterize
    transform which mapping?
    southPole-full
    restrict parameter space
      set corners
      .5 1. 0. .5 0. 1.
      exit
    boundary conditions
      2 0 0 2 1 0
    share
      2 0 0 3 1 0
    lines 
      $nx = int( .2*$pi*$rad/$ds+1.5 ); $ny=$nx; 
      $nx $ny $nr
    mappingName
      southPole
    exit
*
  reparameterize
    transform which mapping?
      sphere-rotated
    restrict parameter space
      set corners
        .15 .85   0. .25  0. 1.
      exit
    mappingName
      sphere
    boundary conditions
      0 0 2 2 1 0 
    share
      0 0 3 2 1 0 
*    lines
*    11 33 7
    exit
*
exit this menu
*
  generate an overlapping grid
    channel
    sphere
    northPole
    southPole
    done
    change parameters
      ghost points
        all
        2 2 2 2 2 2
    interpolation type
      $interpType
    exit
* 
* 
    compute overlap
    exit
*
* save an overlapping grid
save a grid (compressed)
  $name
  quarterSphere
exit

