*
* Square in a square
*
*
* usage: ogen [noplot] sisArg -factor=<num> -order=[2/4/6/8] -interp=[e/i]
* 
* examples:
*     ogen noplot sisArg -factor=1 -order=2 -interp=i
*     ogen noplot sisArg -factor=2 -order=2 -interp=e
*     ogen noplot sisArg -factor=2 -order=4 -interp=e
*
$order=2; $factor=1; $interp="i"; # default values
$orderOfAccuracy = "second order"; $ng=2; $interpType = "implicit for all grids";
* 
* get command line arguments
GetOptions( "order=i"=>\$order,"factor=i"=> \$factor,"interp=s"=> \$interp);
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=3; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=5; }
if( $interp eq "e" ){ $interpType = "explicit for all grids"; }
* 
$suffix = ".order$order"; 
$name = "sis" . "$interp$factor" . $suffix . ".hdf";
* 
$ds=.1/$factor;
* 
create mappings
  rectangle
    set corners
     $xa=-1.; $xb=1.; $ya=-1.; $yb=1.; 
     $xa $xb $ya $yb 
    lines
      $nx=int( ($xb-$xa)/$ds+1.5 );
      $ny=int( ($yb-$ya)/$ds+1.5 );
      $nx $ny
    mappingName
      outer-square
    exit
*
  rectangle
    set
     $xai=-.5; $xbi=.5; $yai=-.5; $ybi=.5; 
     $xai $xbi $yai $ybi 
    lines
      $nx=int( ($xbi-$xai)/$ds+1.5 );
      $ny=int( ($ybi-$yai)/$ds+1.5 );
      $nx $ny
    boundary conditions
      0 0 0 0
    mappingName
      inner-square
    exit
  exit
*
generate an overlapping grid
  outer-square
  inner-square
  done
  change parameters
    ghost points
      all
       $ng $ng $ng $ng $ng $ng 
    order of accuracy
      $orderOfAccuracy
    interpolation type
      $interpType
  exit
  compute overlap
exit
save a grid (compressed)
$name
sis
exit
