# ------------------------------------------------------------------
# Make a sphere : this file is included in other ogen cmd files.
# -----------------------------------------------------------------
Sphere
  $innerRad=$sphereRadius; $outerRad=$innerRad+($nr-$nrExtra-1)*$ds;
  inner and outer radii
    $innerRad $outerRad
  centre for sphere
    $xSphere $ySphere $zSphere
  lines
    $nTheta=int( 2.*$pi*($innerRad+$outerRad)*.5/$ds +1.5 );    
    $nPhi = int( $pi*($innerRad+$outerRad)*.5/$ds +1.5 );  
    $nPhi $nTheta $nr
  boundary conditions
    0 0 -1 -1 1 0
  share
    $sphereShare++;
    0 0 0 0 $sphereShare 0 
  mappingName
    $numberOfSpheres++;
    $sphereName="unrotatedSphere$numberOfSpheres";
    $sphereName
# open graphics
exit
#
# now make a mapping for the north pole
#
reparameterize
  transform which mapping?
    $sphereName
  orthographic
 # sa=2 --> patches just match (not including ghost points)
    $sa = .55 + ($order-2)*$ds*.5; $sb=$sa; 
    specify sa,sb
      $sa $sb
  exit
  lines
    $nTheta=int( .7*$sa*$pi*($innerRad+$outerRad)*.5/$ds +1.5 );    
    $nTheta $nTheta $nr
  mappingName
    $northPoleName="unRotatedNorthPole$numberOfSpheres";
    $northPoleName
exit
#
# now make a mapping for the south pole
#
reparameterize
  transform which mapping?
    $sphereName
  orthographic
    choose north or south pole
      -1
    specify sa,sb
      $sa $sb
  exit
  lines
    $nTheta $nTheta $nr
  mappingName
    $southPoleName="unRotatedSouthPole$numberOfSpheres";
    $southPoleName
exit
#
#  -- stretch mappings ---
# 
  stretch coordinates
    transform which mapping?
      $sphereName
    Stretch r3:itanh
    STP:stretch r3 itanh: layer 0 1 $sphereStretchb 0 (id>=0,weight,exponent,position)
    stretch grid
    mappingName
      $sphereName="stretchedSphere$numberOfSpheres";
      $sphereName
    exit
# 
  stretch coordinates
    transform which mapping?
      $northPoleName
    Stretch r3:itanh
    STP:stretch r3 itanh: layer 0 1 $sphereStretchb 0 (id>=0,weight,exponent,position)
    stretch grid
    mappingName
      $northPoleName="stretchedNorthPole$numberOfSpheres";
      $northPoleName
    exit
# 
  stretch coordinates
    transform which mapping?
      $southPoleName
    Stretch r3:itanh
    STP:stretch r3 itanh: layer 0 1 $sphereStretchb 0 (id>=0,weight,exponent,position)
    stretch grid
    mappingName
      $southPoleName="stretchedSouthPole$numberOfSpheres";
      $southPoleName
    exit
#
#  -- remove the singular ends of the sphere 
  reparameterize
    transform which mapping?
      $sphereName
    restrict parameter space
      set corners
        .125 .875  0. 1.  0. 1.
      exit
#     boundary conditions
#       0 0 2 2 1 0 
#     share
#       0 0 3 2 1 0 
    mappingName
      $sphereName="sphereWithoutPoles$numberOfSpheres";
      $sphereName
    exit
#
# -- convert to nurbs for faster evaluation AND rotate mappings to align with the x-axis
# 
  nurbs 
    interpolate from mapping with options
      $sphereName
      # keep stretching: 
      parameterize by index (uniform)
    done
    rotate
      -90 1
      0 0 0
    mappingName
      $sphereName="sphere$numberOfSpheres";
      $sphereName
    exit
# 
  nurbs 
    interpolate from mapping with options
      $northPoleName
      # keep stretching: 
      parameterize by index (uniform)
    done
    rotate
      -90 1
      0 0 0
    mappingName
      $northPoleName="northPole$numberOfSpheres";
      $northPoleName
    exit
# 
  nurbs 
    interpolate from mapping with options
      $southPoleName
      # keep stretching: 
      parameterize by index (uniform)
    done
    rotate
      -90 1
      0 0 0
    mappingName
      $southPoleName="southPole$numberOfSpheres";
      $southPoleName
    exit
# 
    $gridNames.="\n $sphereName\n $northPoleName\n $southPoleName";
