*
* make a grid for a square:
* usage: ogen [noplot] square -nx=<num> -order=[2/4/6/8] 
* 
* examples:
*
*     ogen noplot squareArg -nx=11 
*     ogen noplot squareArg -nx=21 
*     ogen noplot squareArg -nx=41 
* 
*     ogen noplot squareArg -nx=11 -order=2
*     ogen noplot squareArg -nx=17 -order=4
*     ogen noplot squareArg -nx=21 -order=4
* 
* see also the script buildSquares
*
$order=2; $nx=11; # default values
$orderOfAccuracy = "second order"; $ng=2;
* 
* get command line arguments
GetOptions( "order=i"=>\$order,"nx=i"=> \$nx);
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=2; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=6; }
* 
$lines = $nx;
$suffix = ".order$order"; 
* 
* $lines = 11;	
* $lines = 1025;	
* $lines = 2049;	
* $lines = 4097;	
* $lines = "17"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "21"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "33"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "41"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "65"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "129"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* 
* $lines = "17"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "33"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "65"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "129"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* 
* $lines = "17"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "33"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "65"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "129"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* 
$cells = $lines -1;
$name = "square" . "$cells" . $suffix;
*
create mappings
  rectangle
    mappingName
      square
    lines
      $lines $lines
    boundary conditions
      1 1 1 1
  exit
exit
*
generate an overlapping grid
  square
  done
  change parameters
    ghost points
      all
      $ngp = $ng+1;
      $ng $ng $ng $ngp $ng $ng
    order of accuracy
      $orderOfAccuracy
  exit
  compute overlap
  display computed geometry
exit
*
save an overlapping grid
  $name.hdf
  $name
exit

