*
* two circles in a long channel
*
***************************************************************************
* scale number of grid points in each direction by the following factor
* 
* $gridName = "tcilc1e.hdf";  $interpType="explicit for all grids"; $factor=.5; 
*   $gridName = "tcilc2e.hdf";  $interpType="explicit for all grids"; $factor=1; 
*  $gridName = "tcilc3e.hdf";  $interpType="explicit for all grids"; $factor=2; 
 $gridName = "tcilc4e.hdf";  $interpType="explicit for all grids"; $factor=4; 
* $gridName = "tcilc5e.hdf";  $interpType="explicit for all grids"; $factor=8; 
* $gridName = "tcilc6e.hdf";  $interpType="explicit for all grids"; $factor=16; 
*  $gridName = "tcilc7e.hdf";  $interpType="explicit for all grids"; $factor=32; 
*  $gridName = "tcilc8e.hdf";  $interpType="explicit for all grids"; $factor=64; 
*
* make the number of grid points a multiple of $mgFactor
$mgFactor=8; 
* Define a subroutine to convert the number of grid points
sub getGridPoints\
{ local($n1,$n2)=@_; \
  $nx=$mgFactor*int(1.*($n1-1)*$factor/$mgFactor)+1; \
  $ny=$mgFactor*int(1.*($n2-1)*$factor/$mgFactor)+1; \
}
*
**************************************************************************
*
$ds = 5./160./$factor; 
*
create mappings
  rectangle
    set corners
    -2.5  7.5  -2.5 2.5
    lines
      getGridPoints(321,161);
      $nx $ny
    boundary conditions
      1 1 1 1
    mappingName
    square
    exit
*
  Annulus
    inner radius
      .5
    * decrease the radius as the grids get finer
    $nya = 17; 
    $radius = .5 + $ds*$nya/1.5;   # divide by 1.5 to account for stretching
    outer radius
      $radius
    centre for annulus
      -.6 .6
    lines
     $nx = $mgFactor*int( 2.*3.1415*$radius/$ds/$mgFactor )+1;
     $nxa=$nx; 
      $nxa $nya
    boundary conditions
    -1 -1 1 0
    mappingName
      unstretched-annulus1
    exit
  * stretch the annulus *********
  *
  * Stretch coordinates
  stretch coordinates
    transform which mapping?
      unstretched-annulus1
    Stretch r2:itanh
      $dx = .006/$factor;
      STP:stretch r2 itanh: position and min dx 0 $dx
    stretch grid
*
    mappingName
    annulus1
    exit
  *
*
  Annulus
    inner radius
    .5
    outer radius
      $radius
    centre for annulus
      +.6 -.6
    lines
      $nxa $nya
    boundary conditions
    -1 -1 1 0
    mappingName
      unstretched-annulus2
    exit
  * stretch the annulus *********
  *
  * Stretch coordinates
  stretch coordinates
    transform which mapping?
    unstretched-annulus2
    Stretch r2:itanh
      STP:stretch r2 itanh: position and min dx 0 $dx
    stretch grid
    mappingName
    annulus2
    exit
  *
  exit
  generate an overlapping grid
    square
    annulus1
    annulus2
    done
    change parameters
      interpolation type
        $interpType
      ghost points
        all
        2 2 2 2 2 2
      exit
    compute overlap
* pause
    exit
  save an overlapping grid
  $gridName
  tcilc
  exit




